<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;

use App\Models\Banks;
use App\Models\Currencies;
use App\Models\CurrenciesPrices; 
use App\Models\Query;
use Illuminate\Support\Facades\Log;
use Aws\Rekognition\RekognitionClient;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Client;
use GuzzleHttp\Psr7;
use Spatie\Browsershot\Browsershot;
use App\Models\Notifications;
use Illuminate\Support\Facades\Cache;


class BanksHandler extends Command
{

  private $egypt_banks = [
                        //////////////////////////////////////////////////
                        //   not working
                        //////////////////////////////////////////////////
                        //   'Faisalbank',// بنك فيصل الاسلامي
                        //   'Arabbank', البنك العربي
                        //    'Pbdac',// البنك الزراعي المصري
                        //////////////////////////////////////////////////
                        'banqueducaire',// بنك القاهره
                        //'Hdb',// بنك التعمير والاسكان
                        'Scbank',
                        'Banquemisr',// بنك مصر
                        'Aaib',// البنك العربي الافريقي
                        'Albaraka',
                        'Theubeg',
                        'Ca_egypt',
                        'Midb',
                        'Cib',
                        'Cbe',
                        'Egbank',
                        'Nbg',
                        'Mashreq',
                        'Nbk', 
                        'Audi',
                        'Hsbc',
                        'Ebe',
                        'Aib',
                        'Blom',
                        'Piraeus',
                        'Alexbank',// بنك الاسكندرية
                        'Adib',
                        'Saib',// بنك سايب
                        'IDB',
                        'Aibegypt',
                        'Ealb',
                        'Fab',
                        'QNB',
                        'Nbe',
                    ];
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'cronlive:banks';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'get Currencies from banks';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
        config(['app.debug' => true]);
        // $url = 'https://www.nbe.com.eg/NBE/E/#/EN/ExchangeRatesAndCurrencyConverter';
        // $command = "/home3/banklive/phantom/bin/phantomjs --ignore-ssl-errors=true /home3/banklive/public_html/public/phantom/app.js " . escapeshellarg($url) . " > /home3/banklive/public_html/public/elahly_rates_nbe.html";
        // DD($command);
        // \exec($command);

        // exit;
        // if (file_exists('/home/banklive/public_html/public/elahly_rates_nbe.html'))
        // {
          // @unlink('/home/banklive/public_html/public/elahly_rates_nbe.html');
          // @exec('/home/banklive/phantom/bin/phantomjs --ignore-ssl-errors=true /home/banklive/public_html/public/private_live/phantom/elahly.js > /home/banklive/public_html/public/elahly_rates_nbe.html');
        // }

        
          // config(['app.debug' => true]);
        // // $client = new Client();
        // // $response = $client->request('GET', 'https://www.nbe.com.eg/NBE/E/#/EN/ExchangeRatesAndCurrencyConverter')->getBody()->getContents();

        // // // $promise = $client->getAsync('http://httpbin.org/get');
        // $response = Browsershot::url('https://example.com')->bodyHtml(); // returns the html of the body


        // dd($response);

        
        // exit;
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle() 
    {
      // config(['app.debug' => true]);
      
        date_default_timezone_set("Africa/Cairo");
        $nowork = ['saturday', 'friday'];
        $date = strtolower(date('l'));
        
        // if ( in_array($date, $nowork) )
        // {
        //     echo 'no work today';
        //     exit;
        // }
        
        // $current_time = date('h:i a');
        // $sunrise = "05:30 am";
        // $sunset = "10:00 pm";
        
        // $date1 = \DateTime::createFromFormat('H:i a', $current_time);
        // $date2 = \DateTime::createFromFormat('H:i a', $sunrise);
        // $date3 = \DateTime::createFromFormat('H:i a', $sunset);
        
        // if ($date1 > $date2 && $date1 < $date3)
        // {
        //   ///  echo 'here';
        // }else{
        //     echo 'not work now';
        //     exit;
        // }

        ////////////////////////////////////

        //param
        // $custom_bank = $this->option('bank');

        $custom_bank = 'all';
        if ( $custom_bank === 'all' )
        {
            foreach ($this->egypt_banks as $key => $bank_func)
            {
                    $this->allBanksCurrency = [];

                    try{
                        $data = $this->$bank_func();

                         if ( $data == 'Error' || empty($data))
                         {
                           // sendMail('Empty OR Error .. | ' . $bank_func ,'eeeeeeeeee' ,'m.gamalayoub@gmail.com');
                           continue;
                         }

                         $this->CurrenciesHander($data['bank_id'], $data);

                    } catch (\Error $e)
                    {
                      // sendMail('Error .. | ', $e->getMessage() . ' - ' .$e->getFile() . ' - ' . $e->getLine() ,'m.gamalayoub@gmail.com');
                      continue;
                    }

            }// end of foreach
        }else{

          try
          {
            $data = $this->$custom_bank();
            $this->CurrenciesHander($data['bank_id'], $data);
          }
          catch (\Exception $e)
          {
            // sendMail('Error .. | ', $e->getMessage() . ' - ' .$e->getFile() . ' - ' . $e->getLine() ,'m.gamalayoub@gmail.com');
           //continue;
         }

        }// end of (if not custom bank)


        //sendMail('cron stop','eeeee' ,'m.gamalayoub@gmail.com');

    }// end of handle

    public function QNB()
    {
      $bank_id = 37; 
        $html = (scrapAPISystem('https://www.qnb.com/sites/qnb/qnbegypt/page/en/enexchangerates.html'));
 

        // dump($html);
        $document = new \DOMDocument('1.0', 'UTF-8');
        libxml_use_internal_errors(true);
        $document->loadHTML($html);
        $xpath = new \DOMXPath($document);
        $row   = $xpath->query("//*[contains(@class, 'excelDataTable')]//table")[1];


        //$row = $xpath->query("//tr", $row);
        // dd($row->item(0));
        // 
        $trs = $row->getElementsByTagName('tr');
        DOMRemove($trs->item(0));
        
        foreach ($trs as $tr)
        {
          
            $CurCode    = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
            $buy        = (double) ($tr->getElementsByTagName('td')->item(1)->nodeValue);
            $sell       = (double) ($tr->getElementsByTagName('td')->item(2)->nodeValue);

            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0; 
        }
        
        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
    }

    public function Fab()
    {
      $bank_id = 36; 
        $html = (getCrul('https://www.bankfab.com/en-eg/personal/fx-rate'));
        if ($html === false)
          return;

          
        $document = new \DOMDocument('1.0', 'UTF-8');
        libxml_use_internal_errors(true);

        $document->loadHTML($html);
        $xpath = new \DOMXPath($document);
        $row = $xpath->query("//*[contains(@class, 'fab-tables')]//li");

        

        DOMRemove($row->item(0));

        //getElementsByTagName
        foreach ($row as $tr)
        {

          if (!is_object($tr->getElementsByTagName('div')->item(0)))
                  continue;


            $CurCode    = filterCode(trim($tr->getElementsByTagName('div')->item(0)->nodeValue));
            // $buy_trans  = priceFilter($tr->getElementsByTagName('div')->item(2)->nodeValue);
            // $sell_trans = priceFilter($tr->getElementsByTagName('div')->item(2)->nodeValue);
            $buy        = priceFilter($tr->getElementsByTagName('div')->item(3)->nodeValue);
            $sell       = priceFilter($tr->getElementsByTagName('div')->item(2)->nodeValue);
            if ( $buy == 0 && $sell == 0)
              continue;


            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;
        }
        
        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
    }
    public function Ealb()
    {
      $bank_id = 35; 
        $html = (getCrul('https://www.eal-bank.com/VI/index_en.asp'));
        if ($html === false)
          return;

          
        $document = new \DOMDocument('1.0', 'UTF-8');
        libxml_use_internal_errors(true);

        $document->loadHTML($html);
        $xpath = new \DOMXPath($document);
        $row = $xpath->query("//*[contains(@class, 'thm-container')]//table//tr");

        

        DOMRemove($row->item(0)); 

        //getElementsByTagName
        foreach ($row as $tr)
        {

         

          if (!is_object($tr->getElementsByTagName('td')->item(0)))
                  continue;

          if (!is_object($tr->getElementsByTagName('td')->item(2)))
            continue;
          if (!is_object($tr->getElementsByTagName('td')->item(3)))
            continue;


            $CurCode    = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
            // $buy_trans  = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);
            // $sell_trans = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);
            $buy        = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);
            $sell       = priceFilter($tr->getElementsByTagName('td')->item(3)->nodeValue);
            if ( $buy == 0 && $sell == 0)
              continue;


            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;
        }

        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
    }

    public function IDB()
    {
        $bank_id = 34; 
        $html = (getCrul('https://www.idb.com.eg/$J@5YhwAAwCwOhACLR2TQpnjDV1RA3qhDhcTcFnv0v8O70Zd5Nfkgu-NB8'));
        if ($html === false)
          return;

          
        $document = new \DOMDocument('1.0', 'UTF-8');
        libxml_use_internal_errors(true);

        $document->loadHTML($html);
        $xpath = new \DOMXPath($document);
        $row = $xpath->query("//*[contains(@class, 'table-style2')]//tr");


        DOMRemove($row->item(0)); 

        //getElementsByTagName
        foreach ($row as $tr)
        {
          if (!is_object($tr->getElementsByTagName('td')->item(0)))
                  continue;


            $CurCode    = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
            $buy_trans  = priceFilter($tr->getElementsByTagName('td')->item(1)->nodeValue);
            $sell_trans = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);
            $buy        = priceFilter($tr->getElementsByTagName('td')->item(3)->nodeValue);
            $sell       = priceFilter($tr->getElementsByTagName('td')->item(4)->nodeValue);
            if ( $buy == 0 && $sell == 0 && $sell_trans == 0 && $buy_trans == 0)
              continue;


            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_trans;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_trans;
        }

        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
    }
// start of alex bank
    public function Alexbank()
  	{
  	    $bank_id = 3;

          $url = 'https://www.alexbank.com/digitalServicesServlet/?operation=latestExchangeRatesCash&httpMethod=GET&endpointName=latestExchangeRatesCash&headers=standardHeaders&bank=ALEX&bankId=ALEX&locale=en';
          $Content = (getCrul($url));
          if ($Content === false)
            return;

          $Content = json_decode($Content, true);
          foreach( $Content['rates'] as $rate )
          {
              $CurCode    = filterCode(trim($rate['toCurrency']['label']));

              $buy_trans  = ($rate['buyRate']['rate']);
              $sell_trans = ($rate['sellingRate']['rate']);
              $buy        = ($rate['buyRate']['rate']);
              $sell       = ($rate['sellingRate']['rate']);

              if ($CurCode == 'JPY')
              {
                $buy        = $buy / 100;
                $sell       = $sell / 100;
                $buy_trans  = $buy_trans / 100;
                $sell_trans = $sell_trans / 100;
              }
              
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_trans;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_trans;
          }

          $this->allBanksCurrency['bank_id'] = $bank_id;

          return $this->allBanksCurrency;

      }// end of alex bank
// start of Saib
    public function Saib()
     {
         ini_set("display_errors","On");
         error_reporting(-1);
         $bank_id = 20;

         //
         $url = 'https://www.saib.com.eg/en/personal';
         $Content = (getCrul($url));
         if ($Content === false || empty($Content))
           return;

         // create new DOMDocument
         $document = new \DOMDocument('1.0', 'UTF-8');
         // set error level
         $internalErrors = libxml_use_internal_errors(true);
                 // load HTML
         $document->loadHTML($Content);
         $xpath = new \DOMXPath($document);
         //*[starts-with(@class,"row-")]//text()
         $row = $xpath->query("//*[contains(@class, 'Currency-item-right-inner')]");

         foreach($row as $divs)
         {


             $CurCode    = filterCode(trim($divs->getElementsByTagName('div')->item(0)->nodeValue));
             $buy        = (double)(trim(str_replace('buy', '', strtolower($divs->getElementsByTagName('div')->item(1)->nodeValue))));
             $sell       = (double)(trim(str_replace('sell', '', strtolower($divs->getElementsByTagName('div')->item(2)->nodeValue))));
             $buy_trans  = 0;
             $sell_trans = 0;
             
             $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
             $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
             $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_trans;
             $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_trans;

         }
         
         $this->allBanksCurrency['bank_id'] = $bank_id;
         return $this->allBanksCurrency;

     } // end of Saib

     private function checkBankCurrencies(array $currencies, object $bank)
     {
        $currencies = (array_keys($currencies));

        foreach ($bank->prices as $currencyRates) 
        {
            if( ! in_array($currencyRates->currency->cur_code, $currencies) )
              CurrenciesPrices::where('bankp_id', $currencyRates->bankp_id)->delete();
        }
      }
    // end of checkBankCurrencies

    // start of hander
    public function CurrenciesHander($bank_id, $dataCurrencies)
    {

        if ( empty($dataCurrencies['FinalData']) )
          return;

          // get BankData Details
            $BankData = Banks::find($bank_id);

            if ( empty($dataCurrencies['FinalData']) )
            {
                // send msg to developer
                // sendMail('BankMeter : Can\'t get data From ' . $BankData->bank_name_ar . date('r'), $bank_id);
            }else
            {

              // check if currencies supportd in bank or No
             
              $handerJPY = [];
              foreach ($dataCurrencies['FinalData'] as $key => $value) 
              {
                if ($key == '100JPY')
                    {
                      $handerJPY['JPY'] = [
                        'bankp_buy_banknote'  => $value['bankp_buy_banknote'] / 100,
                        'bankp_sell_banknote' => $value['bankp_sell_banknote'] / 100,
                        'bankp_buy_trans'     => $value['bankp_buy_trans'] / 100,
                        'bankp_sell_trans'    => $value['bankp_sell_trans'] / 100,
                      ];
                    }
              }
              
              if (!empty($handerJPY))
              {
                unset($dataCurrencies['FinalData']['100JPY']);
                $dataCurrencies['FinalData'] += $handerJPY;
              }
              
              $this->checkBankCurrencies($dataCurrencies['FinalData'], $BankData);

                $FoundUpdate = false;
                foreach($dataCurrencies['FinalData'] as $key => $value)
                {
                    // check if not found this Currency in Our System
                    if (null === filterCode($key))
                    {
                        // sendMail('BankMeter : áã äÚËÑ Úáì åÐå ÇáÚãáÉ Ýí ÇáäÙÇã ' . $key . ' ÎÇÕÉ ÈÜ' . $BankData['bank_name_ar']);
                        continue;
                    }

                    //100JPY
                    //JPY
                    if ($key == '100JPY')
                    {
                      $key = 'JPY';
                      $value['bankp_buy_banknote']     = $value['bankp_buy_banknote'] / 100;
                      $value['bankp_sell_banknote']    = $value['bankp_sell_banknote'] / 100;
                    }
                    // get this Currency
                    $currency = Query::getCurrencyByCode($key);
                    
                    // check found this Currency into this Bank or not
                    $data     = Query::getBankRate($bank_id, $currency['cur_id']);

                    if ( $data === NULL && null !== $currency && ($value['bankp_buy_banknote'] != 0 && $value['bankp_sell_banknote'] != 0))
                    {
                        // add this currency to this Bank
                        CurrenciesPrices::insert([
                          'bankp_bank_id' => $bank_id,
                          'bankp_cur_id' => $currency['cur_id']
                        ]);
                        $data     = Query::getBankRate($bank_id, $currency['cur_id']);
                    }
                    
                    if (empty($data) || null == $data)
                      continue;
                    
                    $bankp_buy_banknote     = rounded($data['bankp_buy_banknote']);
                    $bankp_sell_banknote    = rounded($data['bankp_sell_banknote']);
                    $stauts_buy             = $data['bankp_status_buy'];
                    $stauts_sell            = $data['bankp_status_sell'];
                    $stauts_buy_amount      = $data['bankp_percent_buy'];
                    $stauts_sell_amount     = $data['bankp_percent_sell'];


                    $buy_change_amount      = $data['buy_change_amount'];
                    $sell_change_amount     = $data['sell_change_amount'];
                    $buy_change_percent     = $data['buy_change_percent'];
                    $sell_change_percent    = $data['sell_change_percent'];
                    

                    $value['bankp_buy_banknote']  = rounded($value['bankp_buy_banknote']);
                    $value['bankp_sell_banknote'] = rounded($value['bankp_sell_banknote']);

                    if ($value['bankp_buy_banknote'] == $bankp_buy_banknote && $bankp_sell_banknote == $value['bankp_sell_banknote'])
                    {
                        echo $key . ' - is alrady updated before ' . $BankData['bank_name_ar'] . "\n\r";
                        continue;
                    }
                    
                    
                    if ($value['bankp_buy_banknote'] != $bankp_buy_banknote )
                    {

                      $stauts_buy_amount  = rounded($value['bankp_buy_banknote'] - $bankp_buy_banknote);
                      $stauts_buy         = $value['bankp_buy_banknote'] > $bankp_buy_banknote ? 'up' : 'down';
                      if ($currency['cur_id'] == 1)
                      {
                        $this->publicNotifications($stauts_buy, $BankData, $currency);
                      }
                    }

                    if ($value['bankp_sell_banknote'] != $bankp_sell_banknote)
                    {

                      $stauts_sell_amount = rounded($value['bankp_sell_banknote'] - $bankp_sell_banknote);
                      $stauts_sell        = $value['bankp_sell_banknote'] > $bankp_sell_banknote ? 'up' : 'down';
                    }
                    
                    $dataRates = CurrenciesPrices::where('bankp_bank_id', $bank_id)->where('bankp_cur_id', $currency['cur_id'])->first();

                    // new version
                    $buyChangeClean  = str_replace(['+', '-'], '', $stauts_buy_amount);
                    $sellChangeClean = str_replace(['+', '-'], '', $stauts_sell_amount);

                    $dataRates->buy_change_amount   = $buyChangeClean;
                    $dataRates->sell_change_amount  = $sellChangeClean;
                    $dataRates->buy_change_percent  = $dataRates['bankp_buy_banknote'] == 0 ? 100 :  ($buyChangeClean * 100) / $dataRates['bankp_buy_banknote'];
                    $dataRates->sell_change_percent = $dataRates['bankp_sell_banknote'] == 0 ? 100 : ($sellChangeClean * 100) / $dataRates['bankp_sell_banknote'];

                    $dataRates->bankp_buy_banknote  = ($value['bankp_buy_banknote']);
                    $dataRates->bankp_sell_banknote = ($value['bankp_sell_banknote']);
                    // $dataRates->bankp_buy_trans     = number_format($value['bankp_buy_trans'], 10);
                    // $dataRates->bankp_sell_trans    = number_format($value['bankp_sell_trans'], 10);
                    $dataRates->bankp_status_buy    = $stauts_buy;
                    $dataRates->bankp_status_sell   = $stauts_sell;

                    $dataRates->bankp_percent_buy   = $stauts_buy_amount; // will be remove
                    $dataRates->bankp_percent_sell  = $stauts_sell_amount; // will be remove
                    
                    $dataRates->bankp_update = time();
                    $dataRates->save();
                    $addArchiveBuy = array(
                        'a_bank_id'  => $bank_id,
                        'a_curn_id' => $data['bankp_cur_id'],
                        'a_price'     => number_format($value['bankp_buy_banknote'], 5),
                        'a_option'    => 'buy',
                        'a_time'    => time(),
                    );
                    \DB::table('bp_archive')->insert($addArchiveBuy);
                    $addArchiveSell = array(
                        'a_bank_id'  => $bank_id,
                        'a_curn_id' => $data['bankp_cur_id'],
                        'a_price'     => number_format($value['bankp_sell_banknote'], 5),
                        'a_option'    => 'sell',
                        'a_time'    => time(),
                    );
                    \DB::table('bp_archive')->insert($addArchiveSell);

                    // update currency table
                    Currencies::where('cur_id', $currency['cur_id'])->update(['cur_last_update'=> time()]);

                    // $FoundUpdate = true;
                    // update Notification
                    // Banks::where('bank_id', $bank_id)->update(['bank_last_update' => time(), 'is_lost'=> 0]);
                    Banks::where('bank_id', $bank_id)->update(['bank_last_update' => time(), 'updated_at' => now(), 'is_lost' => 0, 'active' => 1], false);

                    echo 'Done Update 1' . "\n\r";

                    // remove Cache
                    Cache::forget('eg_local_banks_rates');
                    Cache::forget('eg_local_home_banks_prices');
                    Cache::forget('eg_local_home_banks');

                    if ($bank_id == 22)
                      Cache::forget('centralBank');
                    
                } // end add data
            }
    	}
      // end of hander
    private function publicNotifications($status, $bank, $cur)
    {
      $nowork = ['saturday', 'friday'];
        $date = strtolower(date('l'));
        
        if ( in_array($date, $nowork) )
          return;

      if ($status == 'up')
      {
        $title_ar = $bank->bank_name_ar . ' يرفع سعر شراء ' . $cur->cur_name_ar;
        $title_en = $bank->bank_name_en . ' has Increased of the buy Price in ' . $cur->cur_name_en;
      }else{
        $title_ar = $bank->bank_name_ar . ' يخفض سعر شراء ' . $cur->cur_name_ar;
        $title_en = $bank->bank_name_en . ' has Decreased of The buy price in ' . $cur->cur_name_en;
      }
      
      $notifications = New Notifications();
      $notifications->title_ar = $title_ar;
      $notifications->title_en = $title_en;
      $notifications->device_type = 'all';
      $notifications->link = 'https://banklive.net/currency-exchange-rates-in-' . $bank->bank_slug;
      $notifications->link_en = 'https://banklive.net/en/currency-exchange-rates-in-' . $bank->bank_slug;
      $notifications->save();
    }
    // start of Piraeus
    public function Piraeus()
    {
        $bank_id = 19;

        $url = 'https://www.abkegypt.com/en/Business/Treasury/Currency-Converter-and-Exchange-Rates';
        $Content = (scrapAPISystem($url));
        if ($Content === false || empty($Content))
          return;


          // dd($Content);

        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');

        // set error level
        $internalErrors = libxml_use_internal_errors(true);

        // load HTML
        $document->loadHTML($Content);

      
        
        $xpath = new \DOMXPath($document);

        //*[starts-with(@class,"row-")]//text()
        $rows = $xpath->query("//table[contains(@class, 'table-striped-white')]/tbody/tr");

        foreach ($rows as $tr)
        {
              $CurCode    = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
              $buy        = priceFormat($tr->getElementsByTagName('td')->item(3)->nodeValue, 10);
              $sell       = priceFormat($tr->getElementsByTagName('td')->item(4)->nodeValue, 10);
              $buy_trans  = 0;
              $sell_trans = 0;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_trans;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_trans;

        }
        
        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
        // Restore error level
        libxml_use_internal_errors($internalErrors);
    }
    // end of Piraeus


    // start of Pbdac
    public function Pbdac()
    {
        $bank_id = 25;
          $url = 'https://abe.com.eg/currency-rates2/?lang=en/';
          $Content = getCrul($url);
          if ($Content === false || empty($Content))
            return;


          // create new DOMDocument
          $document = new \DOMDocument('1.0', 'UTF-8');

          // set error level
          $internalErrors = libxml_use_internal_errors(true);

          // load HTML
          $document->loadHTML($Content);

          $xpath = new \DOMXPath($document);

          //*[starts-with(@class,"row-")]//text()
          $row = $xpath->query("//*[contains(@class, 'mk-fancy-table')]//table")[0];
          //$row = $xpath->query("//tr", $row);
          // dd($row->item(0));
          // DOMRemove($row->item(0));
          $FTR = $row->getElementsByTagName('tr');
          DOMRemove($FTR->item(0));
          foreach($FTR as $tr)
          {

              $CurCode    = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
              $buy        = priceFilter($tr->getElementsByTagName('td')->item(1)->nodeValue);
              $sell       = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);
              $buy_trans  = 0;
              $sell_trans = 0;



              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_trans;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_trans;

          }

          // Restore error level
          libxml_use_internal_errors($internalErrors);
          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;
      }
      // end of Pbdac


    // start of Theubeg
    public function Theubeg()
    {
        $bank_id = 16;

          $url = 'https://www.theubeg.com/ub-services/foreign-currency-exchange';


          $ch = curl_init();
          curl_setopt($ch, CURLOPT_URL, $url);
          //curl_setopt($ch, CURLOPT_PROXY, $proxy);
          curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
          curl_setopt($ch, CURLOPT_HEADER, 0);
          $Content = curl_exec($ch);
          curl_close($ch);

          if (empty($Content))
            return;

          // create new DOMDocument
          $document = new \DOMDocument('1.0', 'UTF-8');


          // set error level
          $internalErrors = libxml_use_internal_errors(true);

          // load HTML
          $document->loadHTML($Content);

          $xpath = new \DOMXPath($document);

          //*[starts-with(@class,"row-")]//text()
          $row = $xpath->query("//*[contains(@class, 'exchange-table')]//tr");

          DOMRemove($row->item(0));

          foreach($row as $tr)
          {
              if (!is_object($tr->getElementsByTagName('td')->item(0)))
                  continue;

              $CurCode    = filterCode(trim($tr->getElementsByTagName('td')->item(1)->nodeValue));
              $sell       = (double) ($tr->getElementsByTagName('td')->item(3)->nodeValue);
              $buy        = (double) ($tr->getElementsByTagName('td')->item(2)->nodeValue);
              $sell_trans = 0;
              $buy_trans  = 0;

              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_trans;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_trans;
          }


          // Restore error level
          libxml_use_internal_errors($internalErrors);
          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;
      } // end of Theubeg


    // start of Scbank
    public function Scbank()
    {
        $bank_id = 8;
          $url = 'https://scbank.com.eg/CurrencyAll.aspx';
          $Content = strtolower(getCrul($url));
          if ($Content === false || empty($Content))
            return;


          $DataCurrncyTable = HandleItems('<table class="table table-hover[\s\S]*?<\/table>', $Content);
          if ( ! isset($DataCurrncyTable[0][0]))
          {
            return null;
          }



          $explode = explode('<tr', $DataCurrncyTable[0][0]);
          unset($explode[0]);
          unset($explode[1]);
          unset($explode[2]);
          foreach($explode as $tr)
          {

              $tr = trim((str_replace('>', '', strip_tags($tr))));
              $tdExpload = explode("\n", $tr);
              $CurrencyName = '';
               foreach($tdExpload as $ContentCur)
               {
                  $ContentCur = trim($ContentCur);
                  if( ! empty($ContentCur) )
                  {
                      $Double = (double)$ContentCur;
                      if ($Double == 0 and empty($CurrencyName))
                      {
                          $codeCurrency = $ContentCur != 'classhide' ? filterCode($ContentCur) : null;
                          if ($codeCurrency === null)
                              break;

                          $CurrencyName = $codeCurrency;
                      }else
                      {
                         $this->allBanksCurrency['FinalData'][$CurrencyName][] = priceFilter($Double);
                      }
                  }

               }
          }


          $newPrice = array();
          $newPrice['FinalData'] = $this->allBanksCurrency['FinalData'];

          if (! empty($newPrice['FinalData']))
          {
              unset($this->allBanksCurrency);

              foreach($newPrice['FinalData'] as $key => $value)
              {
                  if ( ! isset($value[0]) )
                    continue;

                  $this->allBanksCurrency['FinalData'][$key]['bankp_buy_banknote'] = $value[0];
                  $this->allBanksCurrency['FinalData'][$key]['bankp_sell_banknote'] = $value[1];
                  $this->allBanksCurrency['FinalData'][$key]['bankp_buy_trans'] = $value[2];
                  $this->allBanksCurrency['FinalData'][$key]['bankp_sell_trans'] = $value[3];
              }
          }
          
          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;

      } // end of Scbank



    // start of Mashreq
    public function Mashreq()
    {
        $bank_id = 26;

          $url = (('https://www.mashreqbank.com/egypt/en/personal/accounts-deposits/fx-rates.aspx'));
          $Content = strtolower(getCrul($url));

          if ($Content === false || empty($Content))
            return;

          // create new DOMDocument
          $document = new \DOMDocument('1.0', 'UTF-8');

          // set error level
          $internalErrors = libxml_use_internal_errors(true);

          // load HTML
          $document->loadHTML($Content);

          $xpath = new \DOMXPath($document);

          //*[starts-with(@class,"row-")]//text()
          $row = $xpath->query("//*[contains(@class, 'table-hover')]//tr");
          DOMRemove($row->item(6));


          foreach($row as $tr)
          {
              if (!is_object($tr->getElementsByTagName('td')->item(0)))
                  continue;

              $CurCode = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
              $buy     = priceFilter($tr->getElementsByTagName('td')->item(1)->nodeValue);
              $sell    = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);

              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;
          }

          // Restore error level
          libxml_use_internal_errors($internalErrors);
          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;
      }
      // end of Mashreq


    // start of Hsbc
    public function Hsbc()
    {
        $bank_id = 29;
        $url = 'https://egrates.com/en/banks/24';
        $Content = strtolower(getCrul($url));
        if ($Content === false || empty($Content))
          return;

        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');
        // set error level
        $internalErrors = libxml_use_internal_errors(true);
                // load HTML
        $document->loadHTML($Content);
        $xpath = new \DOMXPath($document);
        //*[starts-with(@class,"row-")]//text()
        $row = $xpath->query("//*[contains(@class, 'tbl-curr')]//tbody//tr");


        foreach($row  as $tr)
        {
            $name = explode('/', $tr->getElementsByTagName('img')->item(1)->getAttribute('title'));

            if (!is_array($name))
                continue;

            $CurCode = filterCode($name[1]);
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = priceFilter(trim($tr->getElementsByTagName('td')->item(2)->nodeValue));
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = priceFilter(trim($tr->getElementsByTagName('td')->item(3)->nodeValue));
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;
        }

        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
        // Restore error level
        libxml_use_internal_errors($internalErrors);

    }// end of Hsbc

    // start of Nbk
    public function Nbk()
    {
        $bank_id = 28;

          // here I use argv for URL, but you can adapt it however you like
          $curl_page = getCrul("https://www.nbk.com/en/egypt/personal/currency-rates.html");
          if ($curl_page === false || empty($curl_page))
            return;
          // you can echo the response if you're interrested, or just dump it
          // create new DOMDocument
          $document = new \DOMDocument('1.0', 'UTF-8');
          if ( empty($curl_page) )
              return;

          // set error level
          $internalErrors = libxml_use_internal_errors(true);
          // load HTML
          $document->loadHTML($curl_page);
          $xpath = new \DOMXPath($document);

          //*[starts-with(@class,"row-")]//text()
          $row = $xpath->query("//*[contains(@class, 'fck-tables')]//table//tr");
          DOMRemove($row->item(0));
          DOMRemove($row->item(1));
          foreach($row as $tr)
          {

              if (!is_object($tr->getElementsByTagName('td')->item(0)))
                  continue;

              $CurCode    = filterCode(trim($tr->getElementsByTagName('td')->item(1)->nodeValue));
              $buy        = (double) ($tr->getElementsByTagName('td')->item(2)->nodeValue);
              $sell       = (double) ($tr->getElementsByTagName('td')->item(3)->nodeValue);

              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;


          }

          // Restore error level
          libxml_use_internal_errors($internalErrors);

          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;
      }// end of Nbk

    // start of Nbg
    public function Nbg()
    {
        $bank_id = 24;

          // here I use argv for URL, but you can adapt it however you like
          $curl_page = getCrul('https://www.nbg.com.eg/en/exchange-rates');
          if ($curl_page === false || empty($curl_page))
            return;

          // you can echo the response if you're interrested, or just dump it
          // create new DOMDocument
          $document = new \DOMDocument('1.0', 'UTF-8');
          if ( empty($curl_page) )
              return;



          // set error level
          $internalErrors = libxml_use_internal_errors(true);

          // load HTML
          $document->loadHTML($curl_page);

          $xpath = new \DOMXPath($document);

          //*[starts-with(@class,"row-")]//text()
          $row = $xpath->query("//*[contains(@class, 'row_exchange')]");

          DOMRemove($row->item(0));
          DOMRemove($row->item(1));


          foreach($row as $tr)
          {
              if (!is_object($tr->getElementsByTagName('td')->item(0)))
                  continue;

              $CurCode    = filterCode(trim($tr->getElementsByTagName('td')->item(1)->nodeValue));
              $buy        = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);
              $sell       = priceFilter($tr->getElementsByTagName('td')->item(3)->nodeValue);

              if ( strtolower($CurCode) == 'usd' )
              {
                  $sell = "$sell";
              }


              $buy_trans  = priceFilter($tr->getElementsByTagName('td')->item(4)->nodeValue);
              $sell_trans = priceFilter($tr->getElementsByTagName('td')->item(5)->nodeValue);


              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_trans;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_trans;

          }

          // Restore error level
          libxml_use_internal_errors($internalErrors);
          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;
      }
      // end of Nbg

    // start of Nbe
    public function Nbe()
    {
      
          $bank_id = 5;
          $Content = scrapAPISystem('https://www.nbe.com.eg/NBE/E/#/EN/ExchangeRatesAndCurrencyConverter');
          // $Content = file_get_contents('/home/banklive/public_html/public/elahly_rates_nbe.html');
          if ($Content === false || empty($Content))
            return;
            
          // create new DOMDocument
          $document = new \DOMDocument('1.0', 'UTF-8');
          // set error level
          $internalErrors = libxml_use_internal_errors(true);
          // load HTML
          $document->loadHTML($Content);
          $xpath = new \DOMXPath($document);
          //*[starts-with(@class,"row-")]//text()
          $row = $xpath->query("//*[contains(@class, 'currency-table')]");
          $row = $row->item(0);
          $row = $row->getElementsByTagName('tr');


          if ($row->length == 0)
            return null;

          DOMRemove($row->item(0));

          foreach($row as $tr)
          {
              if (!is_object($tr->getElementsByTagName('td')->item(0)))
                  continue;

              $CurCode    = (trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
              if ( $CurCode == 'Buy' OR $CurCode == 'Sell' )
                continue;

              $CurCodeFilter = filterCode($CurCode);
              if (empty($CurCodeFilter) || null == $CurCodeFilter)
                continue;

              try {
                $banknote_buy  = trim($tr->getElementsByTagName('td')->item(1)->getElementsByTagName('tr')->item(0)->getElementsByTagName('td')->item(1)->nodeValue);
                $banknote_sell = trim($tr->getElementsByTagName('td')->item(1)->getElementsByTagName('tr')->item(1)->getElementsByTagName('td')->item(1)->nodeValue);
                // $banknote_buy_trans =trim($tr->getElementsByTagName('td')->item(2)->getElementsByTagName('tr')->item(0)->getElementsByTagName('td')->item(1)->nodeValue);
                // $banknote_sell_trans =trim($tr->getElementsByTagName('td')->item(2)->getElementsByTagName('tr')->item(1)->getElementsByTagName('td')->item(1)->nodeValue);

                $this->allBanksCurrency['FinalData'][$CurCodeFilter]['bankp_buy_banknote'] = (double) ($banknote_buy);
                $this->allBanksCurrency['FinalData'][$CurCodeFilter]['bankp_sell_banknote'] = (double) ($banknote_sell);
                $this->allBanksCurrency['FinalData'][$CurCodeFilter]['bankp_buy_trans'] = 0;
                $this->allBanksCurrency['FinalData'][$CurCodeFilter]['bankp_sell_trans'] = 0;
              } catch (\Throwable $th) {
                dd($th->getMessage());
              }

          }
          

          // Restore error level
          libxml_use_internal_errors($internalErrors);
          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;
      }
      // end of Nbe

    // start of Midb
    public function Midb()
    {
        $bank_id = 18;

          $url = 'https://midbank.com.eg/currency.aspx';
          $Content = (getCrul($url));
          if ($Content === false || empty($Content))
            return;

          // create new DOMDocument
          $document = new \DOMDocument('1.0', 'UTF-8');


          // set error level
          $internalErrors = libxml_use_internal_errors(true);

          // load HTML
          $document->loadHTML($Content);

          $xpath = new \DOMXPath($document);

          //*[starts-with(@class,"row-")]//text()
          $row = $xpath->query("//*[contains(@id, 'MainContent_grdcurrency')]//tr");

          DOMRemove($row->item(0));

          foreach($row as $tr)
          {
              if (!is_object($tr->getElementsByTagName('td')->item(0)))
                  continue;

              $CurCode    = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
              $sell       = priceFilter($tr->getElementsByTagName('td')->item(1)->nodeValue);
              $buy        = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);
              $sell_trans = priceFilter($tr->getElementsByTagName('td')->item(3)->nodeValue);
              $buy_trans  = priceFilter($tr->getElementsByTagName('td')->item(4)->nodeValue);

              if ($CurCode == 'JPY')
              {
                $buy        = $buy / 100;
                $sell       = $sell / 100;
                $buy_trans  = $buy_trans / 100;
                $sell_trans = $sell_trans / 100;
              }

              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_trans;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_trans;
          }

          // Restore error level
          libxml_use_internal_errors($internalErrors);
          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;
    }
    // end of Midb


    // start of Ebe
    public function Ebe()
    {
        $bank_id = 30;
        $url = 'http://www.centat.net/bank/edbebank';
        $Content = strtolower(getCrul($url));
        if ($Content === false || empty($Content))
          return;
        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');
        // set error level
        $internalErrors = libxml_use_internal_errors(true);
                // load HTML
        $document->loadHTML($Content);
        $xpath = new \DOMXPath($document);
        //*[starts-with(@class,"row-")]//text()
        $row = $xpath->query("//*[contains(@class, 'tbodysort')]//tr");

        foreach($row as $tr)
        {
            $CurCode = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = priceFilter($tr->getElementsByTagName('td')->item(1)->nodeValue);
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;
        }
        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
        // Restore error level
        libxml_use_internal_errors($internalErrors);
    }
    // end of Ebe

    // start of Cib
    public function Cib()
    {
        $bank_id = 4;

        $url = 'https://www.cibeg.com/api/currency/rates';
        $Content = json_decode(strtolower(getCrul($url)), true);
        if ($Content === false || empty($Content))
          return;

        foreach($Content['rates'] as $td)
        {
            $CurrencyName = filterCode($td['currencyid']);

            $this->allBanksCurrency['FinalData'][$CurrencyName]['bankp_buy_banknote'] = $td['buyrate'];
            $this->allBanksCurrency['FinalData'][$CurrencyName]['bankp_sell_banknote'] = $td['sellrate'];
            $this->allBanksCurrency['FinalData'][$CurrencyName]['bankp_buy_trans'] = 0;
            $this->allBanksCurrency['FinalData'][$CurrencyName]['bankp_sell_trans'] = 0;
        }

        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
    }
    // end of Cib



    // start of Cbe
    public function Cbe()
    {
        $bank_id = 22;
        

        $url = 'https://www.cbe.org.eg/ar/economic-research/statistics/cbe-exchange-rates';
        $Content = strtolower(getCrul($url));
        if ($Content === false || empty($Content))
          return;


        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');
        // set error level
        $internalErrors = libxml_use_internal_errors(true);
                // load HTML
        $document->loadHTML($Content);
        $xpath = new \DOMXPath($document);


        $row = $xpath->query("//*[contains(@class, 'table-container')]//table//tr");

        DOMRemove($row->item(0));

        foreach($row as $tr)
        {
            if (!is_object($tr->getElementsByTagName('td')->item(0)))
                continue;

 
            $CurCode = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
            $buy     = (trim($tr->getElementsByTagName('td')->item(1)->nodeValue));
            $sell    = (trim($tr->getElementsByTagName('td')->item(2)->nodeValue));
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;
        }
        

        // Restore error level
        libxml_use_internal_errors($internalErrors);
        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
    }
    // end of Cbe


    // start of Ca_egypt
    public function Ca_egypt()
    {
      $bank_id = 14;
        $url = 'https://www.ca-egypt.com/ar/%d8%a7%d9%84%d8%ae%d8%af%d9%85%d8%a7%d8%aa-%d8%a7%d9%84%d8%a8%d9%86%d9%83%d9%8a%d8%a9-%d9%84%d9%84%d8%a3%d9%81%d8%b1%d8%a7%d8%af//';
        $Content = strtolower(getCrul($url));
        if ($Content === false || empty($Content))
          return;

        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');


        // set error level
        $internalErrors = libxml_use_internal_errors(true);

        // load HTML
        $document->loadHTML($Content);

        $xpath = new \DOMXPath($document);

        //*[starts-with(@class,"row-")]//text()
        $row = $xpath->query("//*[contains(@id, 'f_box')]//option");

        foreach($row as $option)
        {
            $CurCode    = filterCode(trim($option->getAttribute('value')));
            $sell       = $option->getAttribute('data-sell');
            $buy        = $option->getAttribute('data-buy');
            $sell_trans = 0;
            $buy_trans  = 0;

            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_trans;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_trans;
        }
        // Restore error level
        libxml_use_internal_errors($internalErrors);
        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
    }
    // start of Ca_egypt

    // start of Hdb
    public function Hdb()
    {
      

        $bank_id = 9;
        
        $Content = strtolower(getCrul('https://www.hdb-egy.com/en/modern_currency/'));
        dd($Content);
        if ($Content === false || empty($Content))
          return;

          
        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');

        // set error level
        $internalErrors = libxml_use_internal_errors(true);

        // load HTML
        $document->loadHTML($Content);

        $xpath = new \DOMXPath($document);

        //*[starts-with(@class,"row-")]//text()
        $row = $xpath->query('//table[@class="table"]/tbody/tr');
        // $row = $xpath->query("//*[contains(@class, 'table')]//tr");

        // DOMRemove($row->item(0));
        //DOMRemove($row->item(1));

        
        
        try {
          foreach($row as $tr)
          {

            // dd($tr->getElementsByTagName('td')->item(0));
              if (!is_object($tr->getElementsByTagName('td')->item(0)))
                 continue;

              $CurCode = filterCode(trim($tr->getElementsByTagName('th')->item(0)->nodeValue));

              $buy     = priceFilter(str_replace(',', '.', $tr->getElementsByTagName('td')->item(0)->nodeValue));
              $sell    = priceFilter(str_replace(',', '.', $tr->getElementsByTagName('td')->item(1)->nodeValue));
              $buy_tran = priceFilter(str_replace(',', '.', $tr->getElementsByTagName('td')->item(2)->nodeValue));
              $sell_tran = priceFilter(str_replace(',', '.', $tr->getElementsByTagName('td')->item(3)->nodeValue));
              if ($buy == 0 AND $sell == 0)
              {
                  $buy     = $buy_tran;
                  $sell    = $sell_tran;
              }

              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_tran;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_tran;
          }


        } catch (\Exception $e) {
          echo $e->getMessage();
        }

        
        // Restore error level
        libxml_use_internal_errors($internalErrors);
        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
    }
    // end of Hdb

    // start of Faisalbank
    public function Faisalbank()
    {
        $bank_id = 12;
        $url = 'https://online.faisalbank.com.eg/IB/.FIBUserServices/currencyXRate.do?op=getCurrencyExchangeRates&LangID=2';
        $Content = (getCrul($url));
        if ($Content === false || empty($Content))
          return;

        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');

        // set error level
        $internalErrors = libxml_use_internal_errors(true);

        // load HTML
        $document->loadHTML($Content);

        $xpath = new \DOMXPath($document);

        //*[starts-with(@class,"row-")]//text()
        //$row = $xpath->query("//*[contains(@class, 'Action-Table')]");
        $row = $xpath->query("//*[contains(@class, 'Action-Table')]//tr");

        //$row = $xpath->query("//tr", $row);
        DOMRemove($row->item(0));
        foreach($row as $tr)
        {
            if (!is_object($tr->getElementsByTagName('td')->item(0)))
                continue;


            $CurCode = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
            $buy     = trim($tr->getElementsByTagName('td')->item(1)->nodeValue);
            $sell    = trim($tr->getElementsByTagName('td')->item(2)->nodeValue);
            $buy_tran = trim($tr->getElementsByTagName('td')->item(3)->nodeValue);
            $sell_tran = trim($tr->getElementsByTagName('td')->item(4)->nodeValue);
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_tran;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_tran;

        }
        // Restore error level
        libxml_use_internal_errors($internalErrors);
        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
    }
    // end of Faisalbank


    // start of Egbank
    public function Egbank()
    {


        $bank_id = 23;
        // $Content = (getCrul($url));
        $Content = scrapAPISystem('https://www.eg-bank.com/En/ExchangeRate');
        

        if ($Content === false || empty($Content))
          return;


          
        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');
        // set error level
        $internalErrors = libxml_use_internal_errors(true);
        // load HTML
        $document->loadHTML($Content);
        $xpath = new \DOMXPath($document);
        //*[starts-with(@class,"row-")]//text()
        $row = $xpath->query("//*[contains(@class, 'content_of_currency')]");

        //DOMRemove($row->item(0));
        foreach($row as $tr)
        {
            if (! is_object($tr->getElementsByTagName('div')->item(0)))
            {
                continue;
            }
            $CurCode = filterCode(trim($tr->getElementsByTagName('div')->item(0)->nodeValue));
            
            $buy     = (($tr->getElementsByTagName('div')->item(3)->nodeValue));
            $sell    = (($tr->getElementsByTagName('div')->item(2)->nodeValue));

            $buy  = preg_replace("/[^0-9,.]/", "", $buy);
            $sell = preg_replace("/[^0-9,.]/", "", $sell);

            // $buy = preg_replace('/(?<=\d)(\.)?(?=\d{3}($|,))/', ',', $buy);
            // $sell = preg_replace('/(?<=\d)(\.)?(?=\d{3}($|,))/', ',', $sell);
            


            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;
        }
        // dd($this->allBanksCurrency);

        // Restore error level
        libxml_use_internal_errors($internalErrors);
        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
    }
    // end of Egbank

    // start of Arabib bank
    public function Aibegypt()
    {
        $bank_id = 33;
        $url = 'https://www.aibegypt.com/en/personal/';
        $Content = strtolower(getCrul($url));
        if ($Content === false || empty($Content))
          return;

        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');
        // set error level
        $internalErrors = libxml_use_internal_errors(true);
                // load HTML
        $document->loadHTML($Content);
        $xpath = new \DOMXPath($document);
        //*[starts-with(@class,"row-")]//text()
        $row = $xpath->query("//*[contains(@class, 'grey-bg2')]//tr");
        DOMRemove($row->item(0));
        
        foreach($row  as $tr)
        {
          if (!is_object($tr->getElementsByTagName('td')->item(0)))
                  continue;


            $CurCode    = filterCode(trim($tr->getElementsByTagName('td')->item(1)->nodeValue));
            $buy        = (double) ($tr->getElementsByTagName('td')->item(2)->nodeValue);
            $sell       = (double) ($tr->getElementsByTagName('td')->item(3)->nodeValue);
            if ($CurCode == 'JPY')
              $CurCode = '100JPY';

            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = (double) ($buy);
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = (double) ($sell);
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;
        }
        

        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
        // Restore error level
        libxml_use_internal_errors($internalErrors);
    }
    // end of Arabib bank

    // start of bloom bank
    public function Blom()
    {
        $bank_id = 21;
        //$url = 'https://www.blombankegypt.com/BlomEgypt/Exchange-rates';
        $url = 'https://www.blombankegypt.com/BlomEgypt/Exchange-rates';
        $Content = strtolower(getCrul($url));
        if ($Content === false || empty($Content))
          return;

        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');

        // set error level
        $internalErrors = libxml_use_internal_errors(true);

        // load HTML
        $document->loadHTML($Content);

        $xpath = new \DOMXPath($document);

        //*[starts-with(@class,"row-")]//text()
        $row = $xpath->query("//*[contains(@class, 'tableholder')]");

        $row = ($row->item(0)->getElementsByTagName('table')->item(0));
        $row = $row->getElementsByTagName('tr');

        foreach($row as $index => $tr)
        {

            if ( $index == 0 || $index == 1 )
              continue;


            $CurCode = filterCode($tr->getElementsByTagName('td')->item(0)->nodeValue);

            if (!empty($CurCode))
            {

                $CurCode = explode(" ", $CurCode);
                $CurCode = trim($CurCode[0]);


                    $buy_trans  = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);
                    $sell_trans    = priceFilter($tr->getElementsByTagName('td')->item(3)->nodeValue);


                    if ( is_object($tr->getElementsByTagName('td')->item(4)) )
                    {
                      $buy     = priceFilter($tr->getElementsByTagName('td')->item(4)->nodeValue);
                      $buy     = ( $buy == 0 ? $buy_trans : $buy);
                    }else
                      $buy     =  $buy_trans;

                    if ( is_object($tr->getElementsByTagName('td')->item(5)) )
                    {
                      $sell    = priceFilter($tr->getElementsByTagName('td')->item(5)->nodeValue);
                      $sell    = ( $sell == 0 ? $sell_trans : $sell);
                    }else
                      $sell    =  $sell_trans;


                if ($CurCode == 'JPY')
                {
                  $buy = $buy / 100;
                  $sell = $sell / 100;
                  $buy_trans = $buy_trans / 100;
                  $sell_trans = $sell_trans / 100;
                }
                $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
                $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
                $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_trans;
                $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_trans;
            }

        }

        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
    }
    // end of bloom bank

    // start of Banquemisr
    public function Banquemisr()
    {
        $bank_id = 1;
        $url = 'https://www.banquemisr.com/Home/CAPITAL%20MARKETS/Exchange%20rates%20and%20currencies?sc_lang=en';
        //$handle1 = fopen($_SERVER["DOCUMENT_ROOT"] . '/Exchange Rates.html', "r");
        //$Content = fread($handle1, filesize($_SERVER["DOCUMENT_ROOT"] . '/Exchange Rates.html'));
        //fclose($handle1);

        $Content = scrapAPISystem($url);
        if ($Content === false || empty($Content))
          return;

        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');

        // set error level
        $internalErrors = libxml_use_internal_errors(true);
 
                // load HTML
        $document->loadHTML($Content);

        $xpath = new \DOMXPath($document);

        //*[starts-with(@class,"row-")]//text()
        $row = $xpath->query("//*[contains(@class, 'table-responsive')]//tr");



        /*
        $FTR = $priceTable->getElementsByTagName('tr')->item(0);
        $FTR->parentNode->removeChild($FTR);
        */

        foreach($row  as $tr)
        {
            if (!is_object($tr->getElementsByTagName('td')->item(0)))
                continue;

            $CurCode = filterCode($tr->getElementsByTagName('td')->item(0)->nodeValue);

            if (empty($CurCode))
              continue;

            $buy = 0;
            $sell = 0;
            $buy_trans = 0;
            $sell_trans = 0;

            if (! empty($tr->getElementsByTagName('td')->item(1)->nodeValue))
                $buy     = ($tr->getElementsByTagName('td')->item(1)->nodeValue);

            if (! empty($tr->getElementsByTagName('td')->item(2)->nodeValue))
                $sell    = ($tr->getElementsByTagName('td')->item(2)->nodeValue);

            if (! empty($tr->getElementsByTagName('td')->item(3)->nodeValue))
                $buy_trans  = ($tr->getElementsByTagName('td')->item(3)->nodeValue);

            if (! empty($tr->getElementsByTagName('td')->item(4)->nodeValue))
                $sell_trans    = ($tr->getElementsByTagName('td')->item(4)->nodeValue);

            if ( $buy == 0 AND $sell == 0 )
                continue;

            if ($buy == 0 AND $buy_trans != 0)
              $buy = $buy_trans;


              if ($sell == 0 AND $sell_trans != 0)
                $sell = $sell_trans;


            if ($CurCode == 'JPY')
            {
              $buy = $buy / 100;
              $sell = $sell / 100;
              $buy_trans = $buy_trans / 100;
              $sell_trans = $sell_trans / 100;
            }
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = (double)$buy;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = (double)$sell;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = (double)$buy_trans;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = (double)$sell_trans;
        }
        
        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
        // Restore error level
        libxml_use_internal_errors($internalErrors);
    }
    // end of Banquemisr

    
    // start of Banqueducaire
    public function Banqueducaire()
    {
        $bank_id = 7;

          $url = 'https://www.bdc.com.eg/bdcwebsite/fx-rates.html';
          // $url = 'https://banklive.net/phantom/cairoBank_data.html';
          $Content = scrapAPISystem($url);

          // create new DOMDocument
          $document = new \DOMDocument('1.0', 'UTF-8');

          // set error level
          $internalErrors = libxml_use_internal_errors(true);

          // load HTML
          $document->loadHTML($Content);


          $xpath = new \DOMXPath($document);

          //*[starts-with(@class,"row-")]//text()
          $row = $xpath->query("//*[contains(@class, 'left-panel')]//tr");
          foreach($row as $tr)
          {
              if (!is_object($tr->getElementsByTagName('td')->item(0)))
                  continue;

              $CurCode = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
              $buy     = ($tr->getElementsByTagName('td')->item(1)->nodeValue);
              $sell    = ($tr->getElementsByTagName('td')->item(2)->nodeValue);
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;
          }
          
          // Restore error level
          libxml_use_internal_errors($internalErrors);
          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;
      }
      // end of Banqueducaire
    
    // start of Audi bank
    public function Audi()
    {
        $bank_id = 27;
          $url = 'https://www.bankaudi.com.eg/egypt/fx-rates';
          $Content = (getCrul($url));
          if ($Content === false || empty($Content))
            return;

          // create new DOMDocument
          $document = new \DOMDocument('1.0', 'UTF-8');

          // set error level
          $internalErrors = libxml_use_internal_errors(true);

          // load HTML
          $document->loadHTML($Content);

          $xpath = new \DOMXPath($document);


          //*[starts-with(@class,"row-")]//text()
          $trs = $xpath->query("//*[contains(@id, 'FxRatesTable')]//tr");


          DOMRemove($trs->item(0));


          foreach($trs as $tr)
          {
              if (!is_object($tr) OR $tr->getElementsByTagName('td')->length < 3)
                  continue;

              $CurCode = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));

              $buy     = priceFilter($tr->getElementsByTagName('td')->item(3)->nodeValue);
              $sell    = priceFilter($tr->getElementsByTagName('td')->item(4)->nodeValue);
              $T_buy     = priceFilter($tr->getElementsByTagName('td')->item(1)->nodeValue);
              $T_sell    = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);

              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $T_buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $T_sell;
          }

          // Restore error level
          libxml_use_internal_errors($internalErrors);
          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;
      }// end if Audi bank

    // start of Albaraka
    public function Albaraka()
    {
        $bank_id = 10;
        $url = 'https://www.albaraka-bank.com.eg/banking-services/exchange-rates.aspx';
        $Content = strtolower(getCrul($url));
        if ($Content === false || empty($Content))
          return;
        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');

        // set error level
        $internalErrors = libxml_use_internal_errors(true);

        // load HTML
        $document->loadHTML($Content);

        $xpath = new \DOMXPath($document);

        //*[starts-with(@class,"row-")]//text()
        //$row = $xpath->query("//*[contains(@class, 'Action-Table')]");
        $row = $xpath->query("//*[contains(@id, 'hr-border')]//tr");

        //$row = $xpath->query("//tr", $row);
        DOMRemove($row->item(0));


        foreach($row as $tr)
        {
            if (!is_object($tr->getElementsByTagName('td')->item(0)))
                continue;

            $CurCode   = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
            $buy       = priceFilter($tr->getElementsByTagName('td')->item(1)->nodeValue);
            $sell      = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);
            $buy_tran  = priceFilter((double) $tr->getElementsByTagName('td')->item(3)->nodeValue);
            $sell_tran = priceFilter($tr->getElementsByTagName('td')->item(4)->nodeValue);

            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_tran;
            $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_tran;
        }

        // Restore error level
        libxml_use_internal_errors($internalErrors);
        $this->allBanksCurrency['bank_id'] = $bank_id;
        return $this->allBanksCurrency;
    }
    // end of Albaraka

    // start of Aib bank
    public function Aib()
    {
        $bank_id = 31;
          $Content = strtolower(getCrul('https://aib.com.eg/rates/currencyrates.json'));
  

          if ($Content === false || empty($Content))
            return;
          $data = json_decode($Content, true);


          foreach($data['items']  as $currency)
          {
              if (!is_array($currency))
                  continue;
              $CurCode = filterCode($currency['key']);
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = (double)($currency['value']);
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = (double)($currency['value2']);
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;
          }
          
          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;
          // Restore error level
          // libxml_use_internal_errors($internalErrors);
    }
    // end of Aib bank

    // start of Adib
    public function Adib()
  	{
  	    $bank_id = 15;
          $url = 'https://www.adib.eg/Foreign-Currencies';

          $Content = (getCrul($url));
          if ($Content === false || empty($Content))
            return;
          // create new DOMDocument
          $document = new \DOMDocument('1.0', 'UTF-8');

          // set error level
          $internalErrors = libxml_use_internal_errors(true);

          // load HTML
          $document->loadHTML($Content);

          $xpath = new \DOMXPath($document);

          //*[starts-with(@class,"row-")]//text()
          $trs = $xpath->query("//*[contains(@class, 'tbl-analyst')]//tr");
          DOMRemove($trs->item(0));
          foreach($trs as $tr)
          {
              if (!is_object($tr) OR $tr->getElementsByTagName('td')->length < 3)
                  continue;

              $CurCode = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));

              if ( empty($CurCode) )
                  continue;

              $buy     = ($tr->getElementsByTagName('td')->item(1)->nodeValue);
              $sell    = ($tr->getElementsByTagName('td')->item(2)->nodeValue);

              $buy_trans   = ($tr->getElementsByTagName('td')->item(3)->nodeValue);
              $sell_trans  = ($tr->getElementsByTagName('td')->item(4)->nodeValue);

              if ($buy == 0 AND $sell == 0)
              {
                  $buy     = $buy_trans;
                  $sell    = $sell_trans;
              }

              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = $buy_trans;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = $sell_trans;
          }
          
          // Restore error level
          libxml_use_internal_errors($internalErrors);
          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;
      }
      // end of Adib

    // start of arab african bank
    public function Aaib()
  	{
  	    $bank_id = 2;

          $url = 'https://aaib.com/ar/rates';
          $Content = (getCrul($url));
          if ($Content === false || empty($Content))
            return;
          // create new DOMDocument
          $document = new \DOMDocument('1.0', 'UTF-8');

          // set error level
          $internalErrors = libxml_use_internal_errors(true);

          // load HTML
          $document->loadHTML($Content);

          $xpath = new \DOMXPath($document);

          //*[starts-with(@class,"row-")]//text()
          $row = $xpath->query("//*[contains(@id, 'rates-table')]//tr");
          foreach($row as $tr)
          {
              if (!is_object($tr->getElementsByTagName('td')->item(0)))
                  continue;

              $CurCode = filterCode(trim($tr->getElementsByTagName('td')->item(0)->nodeValue));
              $buy     = priceFilter($tr->getElementsByTagName('td')->item(1)->nodeValue);
              $sell    = priceFilter($tr->getElementsByTagName('td')->item(2)->nodeValue);

              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = $buy;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = $sell;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
              $this->allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;
          }
          // Restore error level
          libxml_use_internal_errors($internalErrors);
          $this->allBanksCurrency['bank_id'] = $bank_id;
          return $this->allBanksCurrency;
      }
      // end of arab african bank



    // start of arab bank
    public function Arabbank()
    {
        $allBanksCurrency = [];
        $bank_id = 32;

        $url = 'https://egyptrates.com/en/banks/26';
        $Content = strtolower(getCrul($url));
        if ($Content === false || empty($Content))
          return;

        // create new DOMDocument
        $document = new \DOMDocument('1.0', 'UTF-8');
        // set error level
        $internalErrors = libxml_use_internal_errors(true);
                // load HTML
        $document->loadHTML($Content);
        $xpath = new \DOMXPath($document);
        //*[starts-with(@class,"row-")]//text()
        $row = $xpath->query("//*[contains(@class, 'rates-data')]");
        $data = $row->item(0)->getAttribute('value');
        $data = json_decode($data, true);
        foreach($data  as $currency)
        {
            if (!is_array($currency))
                continue;
            $CurCode = filterCode($currency['currency_code']);
            $allBanksCurrency['FinalData'][$CurCode]['bankp_buy_banknote'] = priceFilter($currency['buy']);
            $allBanksCurrency['FinalData'][$CurCode]['bankp_sell_banknote'] = priceFilter($currency['sell']);
            $allBanksCurrency['FinalData'][$CurCode]['bankp_buy_trans'] = 0;
            $allBanksCurrency['FinalData'][$CurCode]['bankp_sell_trans'] = 0;
        }

        //dd($allBanksCurrency);
        $allBanksCurrency['bank_id'] = $bank_id;
        return $allBanksCurrency;
        // Restore error level
        libxml_use_internal_errors($internalErrors);
    }
    // end of arab bank

}
