<?php

namespace App\Console\Commands;

use App\Jobs\SendBrowserNotifications;
use Illuminate\Console\Command;
use App\Models\Banks;
use App\Models\Currencies;
use App\Models\GeneralCurrencyRates;
use App\Models\Notifications;
use GuzzleHttp\Client;
use GuzzleHttp\Psr7;
use Spatie\Browsershot\Browsershot;


class BanksIsLost extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'cronlive:banklost';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'check bank is lost';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $notification = Notifications::where('is_done', 0)->first();
        if (!empty($notification)) {
            $notification->is_done = 1;
            $notification->save();

            $chunkSize    = 900;
            $tokens       = \App\BrowserTokensFCM::get()->chunk($chunkSize);
            
            foreach ($tokens as $tokenGroup) {
                dispatch(new SendBrowserNotifications($notification, $tokenGroup));
            }

            // if ($notification->sendToMobile == 1 && $notification->is_pin == 0)
            //     $notification->delete();
        }



        $banks = Banks::all();
        foreach ($banks as $bank)
        {
        
            $lastUpdate  = \Carbon\Carbon::createFromTimestamp($bank->bank_last_update)->toDateTimeString();
            $lastDays    = \Carbon\Carbon::now()->subDays(30)->toDateTimeString();
        
            // check if last update is more than 3 day is lost
            if ( $lastUpdate <= $lastDays )
            {
              $bank->is_lost = 1;
              $bank->active = 0;
              $bank->save();
                echo $bank->bank_name_ar . 'is Lost >> ' . $lastUpdate . "<br>";
            }else{// check if this bank is less than 3 day is not lost
                echo $bank->bank_name_ar . 'is Not Lost >> '  . $lastUpdate . "<br><hr>";
                $bank->is_lost = 0;
                $bank->active = 1;
                $bank->save();
            }
        }
        dd('Done');
        

        //   config(['app.debug' => true]);stopped_id_at
        // for ($i=0; $i < 10 ; $i++)
        // {
        //     $tokens = \App\BrowserTokensFCM::where('id', '>', $lastID)->limit(1000)->get();
        //     if ( !empty($tokens) )
        //     {
        //         // dd($tokens);
        //         $data = [];
        //         foreach($tokens as $token)
        //         {
        //             $data[] = $token->token_id;
        //             $token->send_noti = 1;
        //             $token->save();
        //         }

        //         $title    = 'البنك الأهلي المصري يرفع سعر شراء الدولار';

        //         $data = $this->sendBrowseNoti($data, $title, 'ar');
        //         $data = json_decode($data, true);
        //        //dd($data);
        //     }
        // }


                    // $token_id = $token->token_id;
            //   if ( $token->lang == 'en' )
            //     $title    = 'ميد بنك MIDBANK يرفع سعر الشراء للدولار';
            //   else
            //     $title    = 'ميد بنك MIDBANK يرفع سعر الشراء للدولار';

            //     $data = $this->sendBrowseNoti($token_id, $title, $token->lang);
            //     $data = json_decode($data, true);

            //     if ($data['failure'] == 1 && $data['success'] == 0)
            //     {
            //         \App\BrowserTokensFCM::where('id', $token->id)->delete();
            //         continue;
            //     }

            //     $token->send_noti = 1;
            //     $token->save();

        // // $this->sendBrowseNoti();
        // exit;


    }
}
