<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use App\Models\Banks;
use App\Models\Currencies;
use App\Models\GeneralCurrencyRates;
use App\Models\Notifications;
use GuzzleHttp\Client;
use GuzzleHttp\Psr7;
use Spatie\Browsershot\Browsershot;

class MobileAppNotifications extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'cronlive:notismobileapp';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'check bank is lost';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }



    private function checkTokenIsNotValid(array $tokens, $fcmResponse)
    {
        $fcmResponse = json_decode($fcmResponse, true);
        $tokensNotValid = [];

        foreach ($tokens as $key => $token)
        {
            if (isset($fcmResponse['results'][$key]['error'])){
                $tokensNotValid[] = $token;
            }
        }

        if (!empty($tokensNotValid)){
            \App\Models\AppDevicesTokens::whereIn('token', $tokensNotValid)->delete();
        }
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $notofications = Notifications::where('sendToMobile', 0)->limit(5)->get();

        if ($notofications == null)
            return;
            
        foreach ($notofications as $key => $notofication) 
        {
            $tokens = \App\Models\AppDevicesTokens::select('token','lang')->limit(10000)->get()->chunk(950);
            // update is_running to true
            $notofication->sendToMobile = 1;
            $notofication->save();
            foreach ($tokens as $item)
            {
                $tokensLangData = [];
                $tokensLangData = $item->mapToGroups(function ($item, $key)
                {
                    return [$item['lang'] => $item['token']];
                })->toArray();

                if (isset($tokensLangData['en']) && $tokensLangData['en'] != null)
                {
                    $dataEN = $this->sendBrowseNoti($tokensLangData['en'], $notofication->title_en);
                    $this->checkTokenIsNotValid($tokensLangData['en'], $dataEN, 'بنك لايف - BankLive',$notofication->to_key, $notofication->to_value);
                }
                
                if(isset($tokensLangData['ar']) && $tokensLangData['ar'] != null)
                {
                    $dataAR = $this->sendBrowseNoti($tokensLangData['ar'], $notofication->title_ar);
                    $this->checkTokenIsNotValid($tokensLangData['ar'], $dataAR, 'بنك لايف - BankLive',$notofication->to_key, $notofication->to_value);
                }
            }
            // session is finish
        }// end of notifications


        
        dd('done');
    }

    public function sendBrowseNoti($token, $content, $title = 'بنك لايف - BankLive', $key = 'home', $value = null)
    {

      $token = (is_array($token)) ? $token : [$token];

      $from = "AAAAwrs311c:APA91bFO2xjTLWIj7eeSrOQQ4LFqdcb-vh-73Lp5AcjAa1B3g4ORUGzLQpUdinqa2uwr1ND9xOgOWXXi_Y0a17ZaK3w03_Jg-Jc0RlhGl4oDplz9MhleeAWcPB7_rkJadkzi2eG7IHxe";
      $message = array(
              'body'      => $content,
              'title'     => $title,
              'vibrate'   => 1,
              'icon'      => 'https://banklive.net/uploads/noti_logo.jpg',
              'sound'     => 'default',
              'color' => "#203E78"
          );
      $fields = array(
                  'registration_ids'  => $token,
                  'notification'      => $message,
                  'priority' => 'high',
                  'data' => ['key' => $key, 'value' => $value],
              );

      $headers = array(
          'Authorization: key=' . $from,
          'Content-Type: application/json'
      );
      //#Send Reponse To FireBase Server
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, 'https://fcm.googleapis.com/fcm/send');
      curl_setopt($ch, CURLOPT_POST, true);
      curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
      curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
      return  curl_exec($ch);
      curl_close($ch);
    }
}
