<?php

namespace App\Console\Commands;

use App\Models\CurrenciesPrices;
use Illuminate\Console\Command;
use App\Models\Archive;
use App\Models\UsdEgpRateBanks;
use App\Models\Notifications as NotificationsModel;


use Carbon\Carbon;

class Notifications extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'notifications:store';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
     * Execute the console command.
     *
     * @return int
     */
    public function handle()
    {
        $this->usdRate();

        
        #reports for USD change in banks
        // if tusday || satrday is holiday after 12pm
        // after 6pm
        // before 8am
    }

    private function usdRate(){
        $latest = CurrenciesPrices::select('bankp_buy_banknote')->where('bankp_cur_id', 1)
                        ->orderByDesc('bankp_buy_banknote')
                        ->first()->bankp_buy_banknote;
            $oldest = UsdEgpRateBanks::first();

            if ($latest != $oldest->price)
            {
                // send notificaton
                if ($latest > $oldest->price)
                {
                $title_ar = ' أرتفاع جديد للدولار الامريكي في البنوك المصريه حيث سجل حتى الان '.priceFormat($latest).' جنيه مصري ';
                $title_en = "A new rise in the exchange rate of the US dollar as it has reached " .priceFormat($latest). " EGP.";
                }else{
                    $title_ar = ' إنخفاض للدولار الامريكي في البنوك المصريه حيث سجل حتى الان '.priceFormat($latest).' جنيه مصري ';
                    $title_en = "A decrease in the exchange rate of the US dollar as it has reached " .priceFormat($latest). " EGP";
                }
                
                $notifications = New NotificationsModel();
                $notifications->title_ar = $title_ar;
                $notifications->title_en = $title_en;
                $notifications->device_type = 'all';
                $notifications->link = 'https://banklive.net/exchange-rate-USD-to-EGP-today';
                $notifications->link_en = 'https://banklive.net/en/exchange-rate-USD-to-EGP-today';
                $notifications->to_key = 'home';
                // $notifications->sendToMobile = 1;
                // $notifications->is_done = 1;
                $notifications->save();

                $oldest->price = $latest;
                $oldest->save();
            }
    }
    private function today()
    {
        $startDate = Carbon::now()->subDays(7)->startOfDay();
        $endDate   = Carbon::yesterday()->endOfDay();

        $oldest = Archive::where('a_curn_id', 1)
                    ->where(function ($query) use ($startDate,$endDate)
                    {
                        $query->whereBetween('created_at', [$startDate, $endDate])
                        ->orWhere('created_at', '<', Carbon::now()->yesterday()->endOfDay());
                    })
                    
                    ->where('a_option', 'buy')
                    ->orderByDesc('created_at')
                    ->orderByDesc('a_price')
                    ->first();

        $oldestPrice = $oldest->a_price;

        $startDate = Carbon::now()->startOfDay();
        $endDate   = Carbon::now()->endOfDay();

        $latest = Archive::where('a_curn_id', 1)
                    ->whereBetween('created_at', [$startDate, $endDate])
                    ->where('a_option', 'buy')
                    ->latest('a_price')
                    ->first();

        $latestPrice = $latest->a_price;
    }
}
