<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use App\Models\Silver;
use App\Models\SilverPrices;
use Illuminate\Support\Facades\Cache;


class SilverHandler extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'cronlive:silver';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'get silver price in egypt';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        
      $Content = strtolower(getCrul('https://currencyprices.net/silver-price-egypt.html/'));

      config(['app.debug' => true, 'app.env' => 'local']);
      // create new DOMDocument
      $document = new \DOMDocument('1.0', 'UTF-8');
      // set error level
      $internalErrors = libxml_use_internal_errors(true);
      // load HTML
      $document->loadHTML($Content);
      $xpath = new \DOMXPath($document);
      //*[starts-with(@class,"row-")]//text()
      $row = $xpath->query("//*[contains(name(), 'table')]");

      // save general price
      foreach($row->item(0)->getElementsByTagName('tr') as $index => $tr)
      {
        if ($index == 0)
          continue;


            // $type         = ($tr->getElementsByTagName('th')->item(0)->nodeValue);

            $egyPrice     = (trim(trim($tr->getElementsByTagName('td')->item(0)->nodeValue, 'egp')));
            $generalPrice = (trim(trim($tr->getElementsByTagName('td')->item(1)->nodeValue, 'usd')));

            // dump($egyPrice);

            $silver_id = $index;


            // check if this price with this kind is same in db or not
            $silverDB =  SilverPrices::where('p_kind', $silver_id)->first();
            if (null == $silverDB)
            {
                $SilverPrices = new SilverPrices();
                $SilverPrices->p_kind = $silver_id;
                $SilverPrices->p_price = $egyPrice;
                $SilverPrices->change_status     = 'up';
                $SilverPrices->change_percentage = '100';
                $SilverPrices->change_amount     = $egyPrice;

                $SilverPrices->usd_price = $generalPrice;
                $SilverPrices->usd_change_status     = 'up';
                $SilverPrices->usd_change_percentage = '100';
                $SilverPrices->usd_change_amount     = $generalPrice;
                $SilverPrices->save();
                continue;
            }


            if ( null !== $silverDB && $silverDB['p_price'] == $egyPrice)
                continue;
                


            $change_amount  = ($egyPrice - $silverDB['p_price']);
            if ( $egyPrice > $silverDB['p_price'] )
            {
                $status = 'up';
                $change_percent = ($change_amount * 100) / $egyPrice;

            }elseif ( $egyPrice < $silverDB['p_price'] )
            {
                $status = 'down';
                $change_percent = ($change_amount * 100) / $silverDB['p_price'];
            }

            // check usd price status
            $change_amount_usd  = ($generalPrice - $silverDB['usd_price']);
            $changeInUSD = false;
            if ( $generalPrice > $silverDB['usd_price'] )
            {
                $statusUSD = 'up';
                $change_percent_usd = ($change_amount_usd * 100) / $generalPrice;
                $changeInUSD = true;
            }elseif ( $generalPrice < $silverDB['usd_price'] )
            {
                $statusUSD = 'down';
                $change_percent_usd = ($change_amount_usd * 100) / $silverDB['usd_price'];
                $changeInUSD = true;
            }


            // update it
            $silverDB->p_price = $egyPrice;
            $silverDB->change_status     = $status;
            $silverDB->change_percentage = $change_percent;
            $silverDB->change_amount     = $change_amount;


            if ($changeInUSD)
            {
                $silverDB->usd_price = $generalPrice;
                $silverDB->usd_change_status     = $statusUSD;
                $silverDB->usd_change_percentage = $change_percent_usd;
                $silverDB->usd_change_amount     = $change_amount_usd;
            }
            



            $silverDB->save();

            Cache::forget('eg_local_silver_price');


            // // add it in archive
            \DB::table('bp_silver_archive')->insert(['archive_kind'=> $silver_id, 'archive_price'=> $egyPrice]);
      }

    }
}
