<?php

namespace App\Console\Commands;

use App\Models\Countries;
use App\Models\Currencies;
use Illuminate\Console\Command;
use App\Models\GeneralCurrencyRates;
use App\Models\MetalPrices;
use GuzzleHttp\Client;
use GuzzleHttp\Psr7;

class getGeneralCurrency extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'cronlive:generalcurrency';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    private function handlerPrice($price)
    {
        $pureRate = 100 / $price / 100;
        $intval = intval($pureRate);

        if ($intval != 0) {
            // return '-';
            return number_format($pureRate, 2);
        }

        $new = number_format($pureRate, 5);
        if ($new < 0.009) {
            $new = number_format($pureRate, 4);
        } elseif ($new < 0.0008) {
            $new = number_format($pureRate, 5);
        } elseif ($new < 0.08) {
            $new = number_format($pureRate, 3);
        }

        return $new;
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        // $price = '0.00934782354633236';
        // $c = number_format($price, 5, '.', '');
        // $c = rtrim($c, 0);
        // $x = explode('.', $c)[1];
        // $zeroCount = substr_count($x, '0');

        // if ($zeroCount < 3)
        // {
        //     $c = number_format($price, 4, '.', '');
        //     $c = rtrim($c, 0);
        //     $x = explode('.', $c)[1];
        //     $zeroCount = substr_count($x, '0');
        //     if ($zeroCount == 2)
        //     {
        //         dd($c);
        //     }
        // }
        // dd($c);
        // $this->metalPrice('EGP');
        // $this->metalPrice('USD');
        // $this->metalPrice('BTC');
        // dd(100/ 1866.8533520019 / 100);
        dd($this->exchangeRate('SYP'));
        // $this->exchangeRate('USD');


    }




    public function exchangeRate($baseCurrency = 'USD')
    {
        $baseCurrency = strtoupper($baseCurrency);
        $fx = $this->liveMetalPrices($baseCurrency);
        $fx = json_decode($fx, true);
        dd($fx);
        if (!isset($fx['baseCurrency']) || $baseCurrency != $fx['baseCurrency'] || isset($fx['message']) || !isset($fx['rates']))
        {
            return 'no data ' . time();
        }
        
        dd($fx);
        try {
            $currenciesRates = collect($fx['rates'])
            ->map(function ($item) {
                return $this->handlerPrice($item);
            })
            ->toArray();
        } catch (\Throwable $th) {
            dump($fx);
            dd($th->getMessage());
        }
        
        if (!isset($currenciesRates)) {
            return;
        }
        
        
        $baseCurrency = Currencies::where('cur_code', $baseCurrency)->first();
        $toBaseCurrencyId = $baseCurrency->cur_id;

        $foundUpdate = false;
        
        foreach ($currenciesRates as $currency_code => $value) {
            $value = str_replace(',', '',$value);
            // get currency id
            $currency = Currencies::where('cur_code', $currency_code)->first();
            // dd($currency);

            if ($currency === null) {
                continue;
            }

            // get currency rates
            $currency_rates = GeneralCurrencyRates::where('from_cur_id', $currency->cur_id)
                ->where('to_cur_id', $toBaseCurrencyId)
                ->first();

            // $cost = (100 / $value) / 100;
            $cost = rtrim($value, '0');
            // $cost = number_format ( $cost, 3);

            // $cost         = number_format ( round( $value, 3) , 3);
            $oldCost = $currency_rates->current_price ?? 0;
            $changeAmount = 0;
            $calPercent = 0;

            if (null === $currency_rates) {
                try {
                    $currency_rates = new GeneralCurrencyRates();
                    $currency_rates->from_cur_id = $currency->cur_id;
                    $currency_rates->to_cur_id = $toBaseCurrencyId;
                    $currency_rates->current_price = $cost;
                    $currency_rates->previous_price = 0;
                    $currency_rates->change_status = 'up';
                    $currency_rates->change_percent = 100;
                    $currency_rates->change_amount = $cost;
                    $currency_rates->save();
                } catch (\Throwable $th) {
                    dump($th->getMessage());
                    // dd($th->getMessage());
                    dump($currenciesRates);
                    dump($currency_code);
                    dump($value);
                    dd($cost);
                }
                $currency->cur_last_update = (int) time();
                $currency->save();
            }

            if ($cost == $currency_rates->current_price) {
                continue;
            }

            $changeAmount = $cost - $currency_rates->current_price;

            if ($cost < $currency_rates->current_price) {
                $calPercent = $cost - $currency_rates->current_price;
                $calPercent = ($calPercent * 100) / $currency_rates->current_price;
                $changeStatus = 'down';
                $foundUpdate = true;
            } elseif ($cost > $currency_rates->current_price) {
                $calPercent = $cost - $currency_rates->current_price;
                $calPercent = ($calPercent * 100) / $cost;
                $changeStatus = 'up';
                $foundUpdate = true;
            }

            if ($foundUpdate === true) {
                // save data
                $currency_rates->from_cur_id = $currency->cur_id;
                $currency_rates->to_cur_id = $toBaseCurrencyId;
                $currency_rates->current_price = $cost;
                $currency_rates->previous_price = $oldCost;
                $currency_rates->change_status = $changeStatus;
                $currency_rates->change_percent = $calPercent;
                $currency_rates->change_amount = $changeAmount;
                $currency_rates->save();

                $currency->cur_last_update = (int) time();
                $currency->save();
            }
            $foundUpdate = false;
        }

        
    }

    private function metalPrice($baseCurrency = 'EGP')
    {
        // $Countries = Countries::get();
        // foreach ($Countries as $country) {
        // $baseCurrency = $country->cur_code;
        $fx = $this->liveMetalPrices($baseCurrency, 'XAU,XAG,PA,PL');
        $fx = json_decode($fx, true);
        $foundUpdate = false;
        foreach ($fx['rates'] as $key => $newPrice) {
            $oldRecord = MetalPrices::where(['metal_type' => $key, 'currency' => $baseCurrency])->first();

            if ($oldRecord) {
                $changeAmount = $newPrice - $oldRecord->price;
                if ($newPrice < $oldRecord->price) {
                    $changePercent = $newPrice - $oldRecord->price;
                    $changePercent = ($changePercent * 100) / $oldRecord->price;
                    $changeStatus = 'down';
                    $foundUpdate = true;
                } elseif ($newPrice > $oldRecord->price) {
                    $changePercent = $newPrice - $oldRecord->price;
                    $changePercent = ($changePercent * 100) / $newPrice;
                    $changeStatus = 'up';
                    $foundUpdate = true;
                }

                if ($foundUpdate) {
                    MetalPrices::updateOrInsert(
                        ['metal_type' => $key, 'currency' => $baseCurrency],
                        [
                            'price' => $newPrice,
                            'change_status' => $changeStatus,
                            'change_amount' => number_format($changeAmount, 3),
                            'change_percent' => number_format($changePercent, 3),
                            'currency' => $baseCurrency,
                        ],
                    );
                }
            } else {
                MetalPrices::create([
                    'metal_type' => $key,
                    'price' => $newPrice,
                    'change_status' => null,
                    'change_amount' => null,
                    'change_percent' => null,
                    'currency' => $baseCurrency,
                ]);
            }
        }
        // }
    }

    private function liveMetrialRequestExchange($from, $to)
    {
        //https://live-metal-prices.p.rapidapi.com
        $curl = curl_init();
        curl_setopt_array($curl, [
            CURLOPT_URL => "https://currency-converter18.p.rapidapi.com/api/v1/convert?from={$from}&to={$to}&amount=1",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => ['x-rapidapi-host: currency-converter18.p.rapidapi.com', 'x-rapidapi-key: 8b070b17f4msh094b932a54eedcdp1bce5bjsn64dec87a7059'],
        ]);

        // curl_setopt_array($curl, [
        //   CURLOPT_URL => "https://live-metal-prices.p.rapidapi.com/v1/latest/TRY,LBP,SDG,YER/EGP",
        // 	CURLOPT_RETURNTRANSFER => true,
        // 	CURLOPT_FOLLOWLOCATION => true,
        // 	CURLOPT_ENCODING => "",
        // 	CURLOPT_MAXREDIRS => 10,
        // 	CURLOPT_TIMEOUT => 30,
        // 	CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        // 	CURLOPT_CUSTOMREQUEST => "GET",
        // 	CURLOPT_HTTPHEADER => [
        // 		"x-rapidapi-host: live-metal-prices.p.rapidapi.com",
        // 		"x-rapidapi-key: 8b070b17f4msh094b932a54eedcdp1bce5bjsn64dec87a7059"
        // 	],
        // ]);

        $response = curl_exec($curl);
        curl_close($curl);
        return json_decode($response, true)['result']['convertedAmount'];
    }

    private function fastforex($from = 'EGP')
    {
        $client = new Client();
        $response = $client->request('GET', 'https://api.fastforex.io/fetch-all?api_key=af37bbc69c-f6a89398aa-rhlwui&from=' . $from, [
            'headers' => [
                'Accept' => 'application/json',
            ],
        ]);

        return json_decode($response->getBody(), true)['results'];
    }

    private function liveMetalPrices($from = 'EGP', $to = null)
    {
        $curl = curl_init();
        $to = $to != null ? $to : 'BTC,AED,AFN,ALL,AMD,ANG,AOA,ARS,AUD,AWG,AZN,BAM,BBD,BDT,BGN,BHD,BIF,BMD,BND,BOB,BRL,BSD,BTN,BWP,BYN,BZD,CAD,CDF,CHF,CLP,CNY,COP,CRC,CUC,CUP,CVE,CZK,DJF,DKK,DOP,DZD,EEK,EGP,ERN,ETB,EUR,FJD,FKP,GBP,GEL,GHS,GIP,GMD,GNF,GTQ,GYD,HKD,HNL,HRK,HTG,HUF,IDR,IMP,INR,IQD,IRR,ISK,JMD,JOD,JPY,KES,KGS,KHR,KMF,KPW,KRW,KWD,KYD,KZT,LAK,LBP,LKR,LRD,LSL,LTL,LYD,MAD,MDL,MGA,MKD,MMK,MNT,MOP,MRU,MTL,MUR,MVR,MWK,MXN,MYR,MZN,NAD,NGN,NIO,NOK,NPR,NZD,OMR,PAB,PEN,PGK,PHP,PKR,PLN,PYG,QAR,RON,RSD,RUB,RWF,SAR,SBD,SCR,SDG,SEK,SGD,SHP,SLL,SOS,SRD,SVC,SYP,SZL,THB,TJS,TMT,TND,TOP,TRY,TTD,TWD,TZS,UAH,UGX,USD,UYU,UZS,VND,XAF,XCD,XOF,XPF,YER,ZAR,ZMW';
        curl_setopt_array($curl, [
            CURLOPT_URL => "https://live-metal-prices.p.rapidapi.com/v1/latest/{$to}/{$from}",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => ['X-RapidAPI-Host: live-metal-prices.p.rapidapi.com', 'X-RapidAPI-Key: d808683ce3mshc0b04186ba5e0f1p1d2e0fjsnc70fc9f2201c'],
        ]);

        $response = curl_exec($curl);
        // $err = curl_error($curl);

        curl_close($curl);

        return $response;
    }
}
