<?php

namespace App\Http\Controllers\Api\v2;

use App\Http\Controllers\Api\v2\ApiService;
use App\Models\AppDevicesTokens;
use Illuminate\Http\Request;

class AuthApplicationController extends ApiService
{

  public function storeDeviceToken()
  {

    config(['app.debug' => true]);
      // pass vars
      $MobileToken = request()->header('MobileToken');
      $DeviceType  = request()->header('DeviceType');
      $Language    = request()->header('Language');

      // check if Mobile_id is exists in table
      AppDevicesTokens::updateOrCreate([
        'token' => $MobileToken
      ], [
        
        'device_type' => in_array($DeviceType, ['ios', 'android']) ? $DeviceType : 'android',
        'lang' => in_array($Language, ['ar', 'en']) ? $Language : 'ar',
      ]);

    return ApiService::generateNewResponse();
  }



  public function checkAppUpdate()
  {
    $resultAppUpdate = [
        'v_code'    => '1.8',
        'message'   => 'برجاء تحميل الإصدار الجديد من تطبيق بنك لايف',
        'periority' => 'low', // low
    ];
        return ApiService::generateNewResponse($resultAppUpdate);
  }// end of method




}
