<?php

namespace App\Http\Controllers\Api\v2;

use App\Http\Controllers\Api\v2\ApiService;
use App\Models\Currencies;
use App\Models\CurrenciesPrices;
use GuzzleHttp\Client;
use Illuminate\Http\Request;

class CalculatorController extends ApiService
{

  // get all banks
  public function index(Request $request)
  {
    config(['app.debug' => true]);
    $rCalculator = [];

    $amount   = $request->get('amount');
    $from     = strtoupper($request->get('from'));
    $to       = strtoupper($request->get('to'));

    $fromDB     = Currencies::where('cur_code', $from)->first();
    $toDB       = Currencies::where('cur_code', $to)->first();


    // if ( $fromDB->cur_banks_support == 0 && $toDB->cur_banks_support == 0 )
    //   $rCalculator = $this->__resultFromGlobalMarket($amount, $from, $to);


    $rCalculator['text'] = __('main.calculator_result', ['amount' => $amount,'from' => removeAlefLam($fromDB->name),'to' => removeAlefLam($toDB->name)]);
    if ($to == 'EGP' && $fromDB->cur_banks_support == 1)
    {
      $rCalculator['is_banks_support'] = true;
      $rCalculator['rates_banks'] = [];
      $ratesOnBanks = $this->__ratesFromBanksByCurID($fromDB->cur_id);
      foreach ($ratesOnBanks as $key => $ratesOnBank) 
      {
          $rCalculator['rates_banks'][$key]['bank_info']['bank_name'] = $ratesOnBank->bank->name;
          $rCalculator['rates_banks'][$key]['bank_info']['bank_logo'] = url(('uploads/35x35/' . $ratesOnBank->bank_image));
          $rCalculator['rates_banks'][$key]['price']           = number_format(rounded($amount * $ratesOnBank->bankp_buy_banknote), 2) . ' ' . $to;
          //$rCalculator['rates_banks'][$key]['sell']['price']          = rounded($amount * $ratesOnBank->bankp_sell_banknote). ' ' . $to;
          $rCalculator['rates_banks'][$key]['text'] = __('main.byBuyResult') . ' ' . rounded($ratesOnBank->bankp_buy_banknote);
      }

    }else if ( $from == 'EGP' && $toDB->cur_banks_support == 1)
    {
      $rCalculator['is_banks_support'] = true;
      $rCalculator['rates_banks'] = [];
      $ratesOnBanks = $this->__ratesFromBanksByCurID($toDB->cur_id);
      foreach ($ratesOnBanks as $key => $ratesOnBank) 
      {
          $rCalculator['rates_banks'][$key]['bank_info']['bank_name'] = $ratesOnBank->bank->name;
          $rCalculator['rates_banks'][$key]['bank_info']['bank_logo'] = url(('uploads/35x35/' . $ratesOnBank->bank_image));
          //$rCalculator['rates_banks'][$key]['buy']['price']           = rounded($amount / $ratesOnBank->bankp_buy_banknote) . ' ' . $to;
          $rCalculator['rates_banks'][$key]['price']          = number_format(rounded($amount / $ratesOnBank->bankp_sell_banknote), 2) . ' ' . $to;
          $rCalculator['rates_banks'][$key]['text'] = __('main.bySellResult') . ' ' .  rounded($ratesOnBank->bankp_sell_banknote);

      }
    }else 
    {
      $rCalculator['is_banks_support'] = false;
      // get general result
       $resultAmount = $this->__resultFromGlobalMarket($amount, $from, $to);

       $rCalculator['result_amount'] = rtrim(number_format(rounded($resultAmount[$to]), 5), 0) . ' ' . $to;
       $rCalculator['rate'] =  rtrim(number_format(rounded($resultAmount['rate']), 5), 0);

       $rCalculator['rate_text'][0] = '1 ' . $from . ' = ' . rtrim(number_format(rounded($resultAmount['rate']), 5), 0) .' '.  $to;
      $rCalculator['rate_text'][1] = '1 ' . $to . ' = ' . rtrim(number_format( 1 / rounded($resultAmount['rate']), 5), 0) . ' ' . $from;
    }


    return ApiService::generateNewResponse($rCalculator);
  }// end of method

  private function __resultFromGlobalMarket($amount, $from, $to)
  {

    // $curl = curl_init();
    // curl_setopt_array($curl, [
    //   CURLOPT_URL => "https://currency-converter18.p.rapidapi.com/api/v1/convert?from={$from}&to={$to}&amount=1",
    //   CURLOPT_RETURNTRANSFER => true,
    //   CURLOPT_FOLLOWLOCATION => true,
    //   CURLOPT_ENCODING => "",
    //   CURLOPT_MAXREDIRS => 10,
    //   CURLOPT_TIMEOUT => 30,
    //   CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    //   CURLOPT_CUSTOMREQUEST => "GET",
    //   CURLOPT_HTTPHEADER => [
    //     "x-rapidapi-host: currency-converter18.p.rapidapi.com",
    //     "x-rapidapi-key: 8b070b17f4msh094b932a54eedcdp1bce5bjsn64dec87a7059"
    //   ],
    // ]);

    // $response = curl_exec($curl); 
    // curl_close($curl);
    // $response = json_decode($response, true);
    // return ['rate' => $response['result']['convertedAmount'], $to => $response['result']['convertedAmount'] * $amount];


    $curl = curl_init();

    curl_setopt_array($curl, [
      CURLOPT_URL => "https://live-metal-prices.p.rapidapi.com/v1/latest/". $to ."/" . $from,
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 30,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "GET",
      CURLOPT_HTTPHEADER => [
        "X-RapidAPI-Host: live-metal-prices.p.rapidapi.com",
        "X-RapidAPI-Key: d808683ce3mshc0b04186ba5e0f1p1d2e0fjsnc70fc9f2201c"
      ],
    ]);
    
    $response = curl_exec($curl); 
    curl_close($curl);
    $response = json_decode($response, true);

    return [$to => $response['rates'][$to] * $amount, 'rate' => $response['rates'][$to]] ;


    // return $response;



    // $client = new Client();
    // $response = $client->request('GET', "https://api.fastforex.io/convert?from={$from}&to={$to}&amount={$amount}&api_key=af37bbc69c-f6a89398aa-rhlwui", [
    //   'headers' => [
    //     'Accept' => 'application/json',
    //   ],
    // ]);
    // return json_decode($response->getBody(), true)['result'];
  }
  private function __ratesFromBanksByCurID($cur_id){
    return CurrenciesPrices::selectRaw('bankp_bank_id,bankp_buy_banknote,bankp_sell_banknote,bp_banks.bank_id,bp_banks.bank_name_ar,bp_banks.bank_name_en,bp_banks.bank_image')
      ->join('bp_banks', 'bp_banks.bank_id', '=', 'bankp_bank_id')
      ->where('bp_banks.active', 1)
      ->where('bp_banks.is_lost', 0)
      ->where('bp_bank_price.is_active', 1)
      ->where('bankp_cur_id', $cur_id)
      ->where('bankp_buy_banknote', '!=', 0)
      ->where('bankp_sell_banknote', '!=', 0)
      ->orderBy('bankp_buy_banknote', 'desc')
      ->get(); 

  }



}