<?php

namespace App\Http\Controllers\Api\v2;

use App\Http\Controllers\Api\v2\ApiService;
use App\Models\Currencies;
use App\Models\CurrenciesPrices;
use App\Models\GeneralCurrencyRates;
use Carbon\Carbon;

class GlobalMarketController extends ApiService
{
    // get all banks
    public function index()
    {
        // config(['app.debug' => true]);

        $rhome = [];
        $currencies = Currencies::select(['cur_id', 'cur_flag', 'cur_code', 'cur_name_ar', 'cur_name_en', 'cur_last_update', 'cur_sort'])->where('is_active', 1)->orderByRaw('cur_sort = 0, cur_sort asc')->with('globalmarket:from_cur_id,current_price,change_status')->get();


        foreach ($currencies as $key => $currency) 
        {

            $rhome[$key]['id'] = $currency->cur_id;
            $rhome[$key]['cur_sort'] = $currency->cur_sort;
            $rhome[$key]['code'] = $currency->cur_code;
            $rhome[$key]['name'] = $currency->name;
            $rhome[$key]['rates'] = rounded($currency['globalmarket'][0]['current_price']);
            $rhome[$key]['change_status'] = $currency['globalmarket'][0]['change_status'];

            $rhome[$key]['currency_flag_slug'] = $currency->cur_flag;
            $rhome[$key]['currency_flag'] = url($currency->smallflag);
            $rhome[$key]['updated_at_humans'] = Carbon::createFromTimestamp($currency->cur_last_update)->diffForHumans();
            $rhome[$key]['updated_at'] = Carbon::createFromTimestamp($currency->cur_last_update)->toDateTimeString();
        }

        return ApiService::generateNewResponse($rhome);

    }// end of method
}