<?php

namespace App\Http\Controllers\Api\v2;

use App\Http\Controllers\Api\v2\ApiService;
use App\Models\GoldPrices;
use App\Models\MetalPrices;
use \Carbon\Carbon;

class GoldController extends ApiService
{
  // get all banks
  public function index()
  {
    $goldPrices = GoldPrices::select('p_kind', 'p_price', 'p_status', 'p_status_percentage', 'p_last_update')->with('kind')->get();
    $metalPrice = MetalPrices::where('metal_type', 'XAU')->where('currency', 'USD')->first();

    $lastUpdate = '';
    $rGold = [];
    $rGold['rates'][0]['gold_type_name']     = __('main.us_gold_onz_price');
    $rGold['rates'][0]['gold_price']         = '$'.priceFormat($metalPrice->price);
    $rGold['rates'][0]['gold_change_status'] = $metalPrice->change_status;
    $rGold['rates'][0]['gold_change_amount'] = '(' . priceFormat($metalPrice->change_percent) . '%)';
    foreach ($goldPrices as $key => $goldPrice) 
    {
      $key++;
        $rGold['rates'][$key]['gold_type_name']     = ucwords(str_replace(['golhd', 'ذhهب'], [], strtolower($goldPrice->kind->name)));
        $rGold['rates'][$key]['gold_price']         = number_format($goldPrice->p_price) . ' ' . __('main.egCurr');
        $rGold['rates'][$key]['gold_change_status'] = $goldPrice->p_status;
        $rGold['rates'][$key]['gold_change_amount'] = $goldPrice->p_status_percentage;
        $rGold['rates'][$key]['updated_at_humans']  = Carbon::createFromTimestamp($goldPrice->p_last_update)->diffForHumans();
        $rGold['rates'][$key]['updated_at']         = Carbon::createFromTimestamp($goldPrice->p_last_update)->toDateTimeString();
        $lastUpdate = $rGold['rates'][$key]['updated_at'];
    }
    // $onzPrice = count($rGold['rates']);

    // dd($metalPrice->updated_at);

    // $rGold['rates'][$onzPrice]['updated_at_humans']  = Carbon::createFromTimestamp($metalPrice->updated_at)->diffForHumans();
    // $rGold['rates'][$onzPrice]['updated_at']         = Carbon::createFromTimestamp($metalPrice->updated_at)->toDateTimeString();


    $rGold['info']['updated_at'] = $lastUpdate;
    return ApiService::generateNewResponse($rGold);
  }// end of method

}