<?php

namespace App\Http\Controllers\Api\v2;

use App\Http\Controllers\Api\v2\ApiService;
use App\Models\Currencies;
use App\Models\CurrenciesPrices;
use App\Models\GeneralCurrencyRates;
use \Carbon\Carbon;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Cache;

class HomeController extends ApiService
{
  // get all banks
  public function index()
  {
            // config(['app.debug' => true]);


        $rhome = [];
        // 6 عملات الاعلى اليوم والاكثر تداولاً
        // get best buy
        $currencies = ['USD', 'EUR', 'SAR', 'KWD'];
        foreach ($currencies as $key => $currency) 
        {
            $currency = Currencies::select('cur_id', 'cur_name_ar', 'cur_name_en', 'cur_flag')->where('cur_code', $currency)->first(); 
            $bestBuy  = CurrenciesPrices::selectRaw('bankp_bank_id,bankp_buy_banknote,bankp_status_buy,buy_change_amount,buy_change_percent,bp_bank_price.updated_at,bp_banks.bank_id,bp_banks.bank_name_ar,bp_banks.bank_name_en,bp_banks.bank_image')
            ->join('bp_banks', 'bp_banks.bank_id', '=', 'bankp_bank_id')
            ->where('bp_banks.active', 1)
            ->where('bp_banks.is_lost', 0)
            ->where('bp_bank_price.is_active', 1)
            ->where('bankp_cur_id', $currency->cur_id)
            ->where('bankp_buy_banknote', '!=', 0)
            ->orderBy('bankp_buy_banknote', 'desc')
            ->first(); 
            $rhome['best_buy_today'][$key]['currency_name']     = $currency->name;
            $rhome['best_buy_today'][$key]['currency_id']     = $currency->cur_id;
            $rhome['best_buy_today'][$key]['currency_logo']     = url($currency->smallflag);
            $rhome['best_buy_today'][$key]['bank_id']           = $bestBuy->bank_id;
            $rhome['best_buy_today'][$key]['bank_name']         = $bestBuy->bank->name;
            $rhome['best_buy_today'][$key]['price']             = rounded($bestBuy->bankp_buy_banknote) . ' ' . __('main.egCurr');
            $rhome['best_buy_today'][$key]['change_status']     = ($bestBuy->bankp_status_buy);
            $rhome['best_buy_today'][$key]['change_amount']     = rounded($bestBuy->buy_change_amount);
            $rhome['best_buy_today'][$key]['change_percent']    = rounded($bestBuy->buy_change_percent) . '%';
            $rhome['best_buy_today'][$key]['bank_logo_slug']    = $bestBuy->bank_image;
            $rhome['best_buy_today'][$key]['bank_logo']         = url(('uploads/35x35/' . $bestBuy->bank_image));
        }
        
        // سعر الدولار في 7 بنوك 
        $rhome['usd_rates'] = $this->getRatesBuy('USD', 7);
        // سعر اليورو في 7 بنوك
        $rhome['eur_rates'] = $this->getRatesBuy('EUR', 7);

        // عدد خمس عملات غير مدعومه في البنوك
        // $currenciesNotSupported = ['RUB', 'TRY', 'IQD', 'DZD', 'SDG', 'YER'];
        // foreach ($currenciesNotSupported as $key => $currency) 
        // {
        //     $currency = Currencies::select('cur_id', 'cur_name_ar', 'cur_name_en', 'cur_flag')->where('cur_code', $currency)->first(); 
        //     $rates = GeneralCurrencyRates::select(['current_price', 'change_status' ,'change_percent', 'change_amount', 'updated_at'])->where('from_cur_id', $currency->cur_id)->first();

        //     $rhome['global_currencies'][$key]['currency_name']     = $currency->name;
        //     $rhome['global_currencies'][$key]['price']             = rounded($rates->current_price) . ' ' . __('main.egCurr');
        //     $rhome['global_currencies'][$key]['change_status']     = ($rates->change_status);
        //     $rhome['global_currencies'][$key]['change_amount']     = rounded($rates->change_amount);
        //     $rhome['global_currencies'][$key]['change_percent']    = rounded($rates->change_percent) . '%';
        //     $rhome['global_currencies'][$key]['currency_flag_slug']    = $currency->cur_flag;
        //     $rhome['global_currencies'][$key]['currency_flag']         = url($currency->smallflag);
        // }
        
        


        // Chart




        return ApiService::generateNewResponse($rhome);



    }// end of method

    private function getChart($bank_id, $currencyCode, $durations = 'week')
    {
        // 30 day
        // 60 day
        // 90 day
        

    }
    private function getRatesBuy($currencyCode, $limitBanks)
    {
        $currency = Currencies::select('cur_id', 'cur_name_ar', 'cur_name_en', 'cur_flag')->where('cur_code', $currencyCode)->first(); 
        $usdRates  = CurrenciesPrices::selectRaw('bankp_sell_banknote, bankp_status_sell, bankp_bank_id,bankp_buy_banknote,bankp_status_buy,buy_change_amount,buy_change_percent,bp_bank_price.updated_at,bp_banks.bank_id,bp_banks.bank_name_ar,bp_banks.bank_name_en,bp_banks.bank_image')
            ->join('bp_banks', 'bp_banks.bank_id', '=', 'bankp_bank_id')
            ->where('bp_banks.active', 1)
            ->where('bp_banks.is_lost', 0)
            ->where('bp_bank_price.is_active', 1)
            ->where('bankp_cur_id', $currency->cur_id)
            ->where('bankp_buy_banknote', '!=', 0)
            ->orderBy('bankp_buy_banknote', 'desc')
            ->limit($limitBanks)
        ->get();

        $rhome['info']['currency_id']        = $currency->cur_id;
        $rhome['info']['currency_code']      = $currencyCode;
        $rhome['info']['currency_title']     = __('main.currencyTitleApp', ['cur_name' => str_ireplace(' الأمريكي', '', $currency->name)]);
        $rhome['info']['currency_name']      = $currency->name;
        $rhome['info']['currency_flag_slug'] = $currency->cur_flag;
        $rhome['info']['currency_flag']      = url($currency->smallflag);

        foreach ($usdRates as $key => $usdRate) {
            $rhome['rates'][$key]['bank_id']           = $usdRate->bank_id;
            $rhome['rates'][$key]['bank_name']         = $usdRate->bank->name;
            $rhome['rates'][$key]['price']             = rounded($usdRate->bankp_buy_banknote);
            $rhome['rates'][$key]['change_status']     = (empty($usdRate->bankp_status_buy) ? 'up': $usdRate->bankp_status_buy);
            $rhome['rates'][$key]['sell_price']             = rounded($usdRate->bankp_sell_banknote);
            $rhome['rates'][$key]['sell_change_status']     = empty($usdRate->bankp_status_sell) ? 'up' : $usdRate->bankp_status_sell;
            // $rhome['rates'][$key]['change_amount']     = rounded($usdRate->buy_change_amount);
            // $rhome['rates'][$key]['change_percent']    = rounded($usdRate->buy_change_percent) . '%';
            $rhome['rates'][$key]['bank_logo_slug']    = $usdRate->bank_image;
            $rhome['rates'][$key]['bank_logo']         = url(('uploads/35x35/' . $usdRate->bank_image));
        }

        return $rhome;
    }



    public function settings()
    {
        $rhome['intro_title'] = 'بنك لايف - بوابة سعر الصرف على مدار الساعه';
        $rhome['app_version'] = '1.0';
        return ApiService::generateNewResponse($rhome);
    }
}