<?php

namespace App\Http\Controllers\Api\v2;

use App\Http\Controllers\Api\v2\ApiService;
use App\Models\petroleumPrice;
use \Carbon\Carbon;

class PetroleumController extends ApiService
{
  // get all banks
  public function index()
  {
    
    $petrolPrices = petroleumPrice::select('petroleum_type_id', 'price', 'change_amount', 'change_percentage', 'change_type', 'updated_at')->with('types:id,name_ar,name_en,unit_type')->get();

    $rPetrol = [];
    foreach ($petrolPrices as $key => $petrolPrice) 
    {
        $rPetrol[$key]['petrol_unit_name']     =  __('main.' . $petrolPrice->types->unit_type) . ' ' . $petrolPrice->types->name;
        $rPetrol[$key]['price']                =  $petrolPrice->price . ' ' . __('main.egCurr');
        $rPetrol[$key]['change_status']        =  $petrolPrice->change_type;
        $rPetrol[$key]['change_details']       =  $petrolPrice->change_amount . ' (' . $petrolPrice->change_percentage . ')';
        $rPetrol[$key]['updated_at_humans']    = Carbon::parse($petrolPrice->updated_at)->diffForHumans();
        $rPetrol[$key]['updated_at']           = Carbon::parse($petrolPrice->updated_at)->format('Y-m-d');
    }

    return ApiService::generateNewResponse($rPetrol);
  }// end of method

}