<?php

namespace App\Http\Controllers\Api\v2;

use App\Http\Controllers\Api\v2\ApiService;
use App\Models\SilverPrices;
use \Carbon\Carbon;

class SilverController extends ApiService
{
  // get all banks
  public function index()
  {
    $silverPrices = SilverPrices::select('p_kind', 'updated_at', 'usd_change_amount', 'usd_change_percentage', 'usd_change_status', 'usd_price', 'p_price', 'change_status', 'change_percentage', 'change_amount')->with(['kind' => function ($query){$query->select('s_id', 's_name_ar', 's_name_en');}])->get();
    
    $lastUpdate = '';
    $rSilver = [];
    foreach ($silverPrices as $key => $silverPrice) 
    {
        $rSilver['rates'][$key]['silver_unit_name']     = ucwords(str_replace(['silver gram', 'جرام فضة'], [], strtolower($silverPrice->kind->name)));
        $rSilver['rates'][$key]['egp_price']['price']             =  $silverPrice->p_price;
        $rSilver['rates'][$key]['egp_price']['change_status']     =  $silverPrice->change_status;
        $rSilver['rates'][$key]['egp_price']['change_details']    =  $silverPrice->change_amount . ' (' . $silverPrice->change_percentage.'%)';
        // $rSilver['rates'][$key]['egp_price']['change_amount']     =  ;

        $rSilver['rates'][$key]['usd_price']['price']             =  $silverPrice->usd_price . '$';
        $rSilver['rates'][$key]['usd_price']['change_status']     =  $silverPrice->usd_change_status;
        $rSilver['rates'][$key]['usd_price']['change_details']    =  $silverPrice->usd_change_amount . '$ (' . $silverPrice->usd_change_percentage.'%)';

        $rSilver['rates'][$key]['updated_at_humans']  = Carbon::parse($silverPrice->updated_at)->diffForHumans();
        $rSilver['rates'][$key]['updated_at']         = Carbon::parse($silverPrice->updated_at)->toDateTimeString();
        $lastUpdate = $rSilver['rates'][$key]['updated_at'];
    }

    $rSilver['info']['updated_at'] = $lastUpdate;
    return ApiService::generateNewResponse($rSilver);
  }// end of method

}