<?php

namespace App\Http\Controllers;

use App\Models\CurrenciesPrices;
use App\Models\Golden;
use App\Models\petroleumTypes;
use App\Models\Silver;
use Illuminate\Http\Request;
use App\Models\Query;
use SEO;
use App\BrowserTokensFCM;
use App\Models\Banks;
use App\Models\Currencies;
use GuzzleHttp\Client;
use App\Models\GeneralCurrencyRates;
use App\Models\Pages;

class CalculatorController extends Controller
{
    public function getBankCurrencies(Request $request)
    {
        if (!$request->ajax()) {
            return response()->json([]);
        }

        // $locale = session('locale', app()->getLocale());
        // \LaravelLocalization::setLocale($locale);
    
        $bankId = (int) $request->input('bank');

        $bank = Banks::select('bank_slug')->where('is_lost', 0)->where('active', 1)->where('bank_id', $bankId)->first();
        if ($bank == null) {
            return response()->json([]);
        }

        $curencies = CurrenciesPrices::where('bankp_buy_banknote', '!=', '0')->select('bankp_cur_id')->where('bankp_bank_id', $bankId)->get()->pluck('bankp_cur_id')->toArray();


        $curencies = Currencies::whereIn('cur_id', $curencies)->get();
        $dataCurrenies = [];
        foreach ($curencies as $key => $curency) {
            $dataCurrenies[$key]['cur_id'] = $curency->cur_id;
            $dataCurrenies[$key]['cur_name'] = $curency->name;
        }

        // // إرجاع البيانات كاستجابة JSON
        return response()->json($dataCurrenies);
    }

    public function getCurrencyRates(Request $request)
    {
        if (!$request->ajax()) {
            return response()->json([]);
        }

        $bank_id = (int) $request->input('bank_id');
        $currency_id = (int) $request->input('currency_id');

        $currency = Currencies::select('cur_name_ar', 'cur_name_en', 'cur_id', 'cur_code', 'cur_flag')->where('cur_id', $currency_id)->first();

        $rates = CurrenciesPrices::select('bankp_buy_banknote', 'bankp_sell_banknote')->where('bankp_buy_banknote', '!=', '0')->where('bankp_bank_id', $bank_id)->where('bankp_cur_id', $currency_id)->first();

        if ($rates == null) {
            return response()->json([]);
        }
 
        return response()->json([
            'currency' => [
                'currency_name' => $currency->name,
                'currency_flag' => $currency->smallflag,
                'currency_code' => $currency->cur_code,
            ],
            'buy_rate' => number_format($rates->bankp_buy_banknote, 5, '.', ''),
            'sell_rate' => number_format($rates->bankp_sell_banknote, 5, '.', ''),
        ]);
    }
}
