<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;


use App\Models\CurrenciesPrices;
use App\Models\Banks;
use App\Models\Currencies;
use App\Models\GeneralCurrencyRates;
use App\Models\Query;
class CurrenciesController extends Controller
{

  public function index()
  {
    $currencies = Currencies::whereHas('rates', function ($query)
    {
      return $query->whereNotNull('current_price');
    })
    ->with('rates')
    ->where('is_active', 1)
    ->where('is_lost', 0)->get();
    return view('index.all_currencies')->with(compact('currencies'));
  }
  public function showCurrency($from, $to = 'egp')
  {
    // check this Currency 
    
    if ($from == '100JPY')
    {
      return redirect(route('currency', ['c_from' => 'JPY', 'c_to' => 'EGP']));
    }
    
    $currency = Query::getCurrRatesWithBanks($from);

    
    if ($currency === null )
      return abort(404);

      $title = ' سعر الـ '  . $currency->cur_name_ar  . ' مقابل الجنية المصري';

      
// if (request()->ip() == '41.35.7.121')
//         {
//             config(['app.debug' => true, 'app.env' => 'local']);

//             // dd($currency);
//         }


    $keywords = ["{$currency->name} مقابل الجنيه المصري",
    "سعر {$currency->name} اليوم في مصر",
    "سعر {$currency->name} اليوم مصر",
    "سعر {$currency->name} اليوم",
    "سعر {$currency->name} مقابل الجنية المصري",
    "{$currency->name} في مصر",
    "سعر {$currency->name} اليوم بنك مصر",
    "سعر {$currency->name} اليوم في بنك مصر",
    "اسعار {$currency->name} اليوم في مصر",
    "سعر {$currency->name} اليوم في البنوك المصرية",
    "سعر {$currency->name} اليوم",
    "{$currency->name} مقابل الجنية المصري",
    "سعر {$currency->name}",
    "{$currency->name}",
    "Egyptian banks",
    "{$currency->name} في البنوك المصري",
    "سعر {$currency->name} اليوم تحديث مباشر",
    "سعر {$currency->name} مصر",
    "{$currency->cur_code} to EGP",
    "{$currency->cur_code} to egypt pound",
    "{$currency->cur_code} to egyptian pound",
    "{$currency->cur_code} in egypt",
    "{$currency->cur_code} to egp",
    "egypt pound to {$currency->cur_code}",
    "{$currency->cur_code} In exchange for the Egyptian pound",
    "سعر {$currency->name} في السوق السوداء",
    // "بنك لايف",
    // "Bank Live",
    // "Banklive",
    // "egypt rates",
    // "اسعار العملات",
    // "اسعار العملات في مصر",
    // "اسعار العملات اليوم في مصر",
    // "البنوك المصريه",
    // "rates in egypt",
    // "currency in egypt",
    // "egypt pound" ,
    // "egypt pound to usd",
    // "egypt pound to euro",
    // "Currency exchange rates",
    // "Currency exchange rates in Egypt",
    // "Currency exchange rates",
    // "foreign exchange rates",
    // "live currency",
    // "live currency in Egypt",
  ];

    if ($currency->cur_banks_support == 0)
    { 
      $currency->rates = GeneralCurrencyRates::where('from_cur_id', $currency->cur_id)->first();
      return view('index.general_currency')->with(compact('currency'));
    }else{ 
      $generalRates = GeneralCurrencyRates::select('current_price', 'change_status','change_percent','change_amount')->where('from_cur_id', $currency->cur_id)->first();
      $bestRates = Query::get_best_prices([$currency->cur_code], 1, false);
      return view('index.currency')->with(compact('bestRates', 'currency', 'title', 'keywords', 'generalRates'));
    }

  }// end of show this Currency


  // public function calculator()
  // {


  //     return view('index.cal')->with(['title' => 'calculator']);
  // }// end of get converter

  // public function calculator_result(Request $request)
  // {
  //   // check ajax
  //   if ( $request->ajax() )
  //   {

  //     if ( $request->action === 'getconverter' )
  //     {
  //       /*
  //       "currency_id" => "1"
  //       "bank_id" => "16"
  //       "quantity_id" => "232"
  //       */
  //       $currency_id = (int) $request->currency_id;
  //       $bank_id     =  $request->bank_id;
  //       $amount      = (int) $request->quantity_id;
  //       $get_best    = false;
  //       if ( $bank_id == 'all' )
  //       {
  //         $get_best     = true;
  //         // get this currency
  //         $currency  = Currencies::select('*')->where('cur_id', $currency_id)->first();
  //         // get best banks
  //         $bankRates  = Query::get_best_prices([$currency->cur_code], 1);

  //       }else{
  //         // get this bank
  //         $bankRates   = Query::calculatorBanks($bank_id, $currency_id, $amount);
  //       }

  //       return view('calculator.ajax_data', compact('bankRates', 'get_best', 'amount'));
  //     }
  //     // check this currency
  //     if ( $request->action === 'check' )
  //     {

  //       if ( $request->currency_id !== 'all' )
  //       {
  //         $currencyID = (int) $request->currency_id;
  //         $banks      = Query::banksSupportthisCurrency($currencyID);
  //       }else{
  //         $banks      = Banks::where('active', 1)->get();
  //       }// get banks

  //       $data = '<option value="all">البحث عن افضل سعر في البنوك</option>';
  //       foreach ($banks as $key)
  //         $data .= '<option value="'.$key['bank_id'].'">'.$key[__('main.db_bank_name')].'</option>';

  //       return $data;
  //     }// end of action is check
  //   }// end of ajax request check
  // }// end of post converter

  public function getRate(Request $request)
  {
    if (!$request->ajax())
    {
      return response()->json(['rates' => 'try again'], 200);
    }
 
    $fromCurrency   = $request->input('from_currency_id');
    $toCurrency     = $request->input('to_currency_id');
    $toAmount       = $request->input('to_amount');
    $fromAmount     = $request->input('from_amount');
    $typeExchange   = $request->input('type_exchange');
    
    if ($typeExchange == 'defualt')
    {
      $amount  = $fromAmount;
      $from    = $fromCurrency;
      $to      = $toCurrency;
    }else{
      $amount  = $toAmount;
      $from    = $toCurrency;
      $to      = $fromCurrency;
    }
    
    $fCurrencyId = Currencies::select('cur_id')->where('cur_code', strtoupper($from))->first()->cur_id;
    $tCurrencyId = Currencies::select('cur_id')->where('cur_code', strtoupper($to))->first()->cur_id;


    $rate = GeneralCurrencyRates::select('current_price')->where('from_cur_id', $fCurrencyId)->where('to_cur_id', $tCurrencyId)->first();

    
    $rateReverse = GeneralCurrencyRates::select('current_price')->where('from_cur_id', $tCurrencyId)->where('to_cur_id', $fCurrencyId)->first();
    
    if ($rateReverse == null && $rate != null)
    {
      $rateReverse = (100 / $rate->current_price) / 100;
    }else{
      $rateReverse = $rateReverse->current_price;
    }


    if ($rateReverse != null && $rate == null)
    {
      $rate = 1 / $rateReverse;
    }else{
      $rate = $rate->current_price;
    }
    

    $finalAmount = $rate * $amount;

    $results = [
      'result' => str_replace(',', '', priceFormat($finalAmount,5)),
      'rate' => "1 {$from} = {$rate} {$to}",
      'rate_reverse' => "1 {$to} = {$rateReverse} {$from}",
    ];
    return response()->json($results, 200);
  }

  private function __resultFromGlobalMarket($amount, $from, $to)
  {

    $curl = curl_init();

    curl_setopt_array($curl, [
      CURLOPT_URL => "https://live-metal-prices.p.rapidapi.com/v1/latest/". $to ."/" . $from,
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 30,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "GET",
      CURLOPT_HTTPHEADER => [
        "X-RapidAPI-Host: live-metal-prices.p.rapidapi.com",
        "X-RapidAPI-Key: d808683ce3mshc0b04186ba5e0f1p1d2e0fjsnc70fc9f2201c"
      ],
    ]);
    
    $response = curl_exec($curl); 
    curl_close($curl);
    $response = json_decode($response, true);
    
    return $response['rates'][$to] * $amount;
  }
}
