<?php

namespace App\Http\Controllers;

use App\Models\GoldArchive;
use App\Models\Golden;
use App\Models\GoldPrices;
use Illuminate\Http\Request;
use Carbon\Carbon;

class GoldController extends Controller
{
  public function show(){
    $gold_prices = Golden::with('rate')->orderBy('sort', 'ASC')->get();

    $goldInFaq = [];
    foreach ($gold_prices as $key => $gold) {
       if (in_array($gold->slug, ['karat-21', 'karat-18', 'karat-24']))
        $goldInFaq[$gold->slug] = $gold->rate->buy_price;
    }

    return view('index.gold_price')->with('gold_prices', $gold_prices)->with('goldInFaq', $goldInFaq);
  }

  public function showKarat($slug){

    // $data = GoldArchive::where('created_at', null)->limit(10000)->get();
    // foreach ($data as $key => $archive) {
    //   $archive->created_at = $archive->archive_date;
    //   $archive->save();
    // }
    // dd($data);


    $goldKarat = Golden::with('price')->where('slug', $slug)->first();
    if ($goldKarat == null)
      abort(404);
    

      
    $goldOnzEgy = Golden::with('rate')->where('slug', 'ounce-gold')->first();

    $gold_prices = Golden::with('rate')->orderBy('sort', 'asc')->get();
    $metalPrice = \App\Models\MetalPrices::where('currency','USD')->where('metal_type', 'XAU')->first();

    // $yesterday = Carbon::yesterday();
    

    // $startOfDayTimestamp = $yesterday->startOfDay()->timestamp;
    // $endOfDayTimestamp = $yesterday->endOfDay()->timestamp;

    $previousClosures = GoldArchive::where('archive_date', '<', Carbon::today()->timestamp)
    ->where('archive_kind', $goldKarat->g_id)
    ->where('archive_price', '!=', $goldKarat->price->p_price)
    ->where('price_type', 'buy')
    ->orderBy('archive_date', 'desc')
    ->first();

    $previousClosuresPrice = [];
    $previousClosuresPrice['price'] = $previousClosures->archive_price;
    $previousClosuresPrice['change_amount'] = $goldKarat->price->p_price - $previousClosures->archive_price;
    $previousClosuresPrice['change_percent'] = ($goldKarat->price->p_price - $previousClosures->archive_price) / $previousClosures->archive_price * 100;
    $previousClosuresPrice['status'] = $previousClosuresPrice['change_amount'] < 0 ? 'down' : 'up';

    $filter = request('days');
    $filter = isset($filter) ? $filter : 30;

    
    if (in_array($filter, [1,7,30]))
     $getArchivePrices = GoldArchive::getArchivePrices($goldKarat, $filter, 'days');
    elseif(in_array($filter, [90,180]))
    $getArchivePrices = GoldArchive::getArchivePrices($goldKarat, $filter, 'months');
    elseif(in_array($filter, [365,'all']))
    $getArchivePrices = GoldArchive::getArchivePrices($goldKarat, $filter, 'years');
      else{
        $getArchivePrices = GoldArchive::getArchivePrices($goldKarat, 30, 'days');
      }
    return view('index.gold_price_karat')
    ->with('previousClosuresPrice',  ($previousClosuresPrice))
    ->with('goldKarat', $goldKarat)
    ->with('getArchivePrices', $getArchivePrices)
    ->with('filter', $filter)
    ->with('goldOnzEgy', $goldOnzEgy)
    ->with('goldOnz', $metalPrice)
    ->with('gold_prices', $gold_prices);
  }
  


}
