<?php

namespace App\Http\Controllers;

use App\Models\Notifications;
use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        config(['app.debug' => true]);
        return view('home');
    }


    public function send_notifications(){
        return view('dashboard.notifications.create');
    }
    public function store_notifications(Request $request){
        config(['app.debug' => true]);

        $request->validate([
            'title_ar' => 'required|string|max:250',
            'title_en' => 'nullable|string|max:250',
            'is_pin' => 'required|boolean',
            // 'device_type' => 'required|in:web,android,ios,all',
            // 'priority' => 'required|in:high,low',
            'link' => 'required|url',
            'link_en' => 'nullable|url',
        ]);

        $notification = new Notifications();
        $notification->title_ar = $request->input('title_ar');
        $notification->title_en = $request->input('title_en');
        $notification->is_pin = $request->input('is_pin');
        // $notification->device_type = $request->input('device_type');
        // $notification->priority = $request->input('priority');
        $notification->link = $request->input('link');
        $notification->link_en = $request->input('link_en');

        $notification->save();


        return redirect()->route('notifications.create')->with('success', 'Notification added successfully');

    }
}
