<?php

namespace App\Http\Controllers;

use App\Models\PetroleumPrice;
use App\Models\PetroleumPriceArchive;
use App\Models\PetroleumTypes;
use Carbon\Carbon;
use Illuminate\Http\Request;

class PetroleumController extends Controller
{
    public function index()
    {
        
        $petroleumPrice = PetroleumPrice::with('types')->get();
        
        return view('index.petroleum')->with('petroleumPrice', $petroleumPrice);
    }


    public function show($slug)
    {
        $petroleumPrice = PetroleumTypes::where('slug', $slug)->with('rate')->first();
        if ($petroleumPrice == null)
            abort(404);

        $allGasPrices = PetroleumPrice::with('types')->get();


        

        $previousClosures = PetroleumPriceArchive::where('created_at', '<', Carbon::today())
        ->where('petroleum_type_id', $petroleumPrice->id)
        ->where('price', '!=', $petroleumPrice->rate->price)
        ->orderBy('created_at', 'desc')
        ->first();
        $previousClosuresPrice = [];
        $previousClosuresPrice['price'] = $previousClosures->price;
        $previousClosuresPrice['change_amount'] = number_format($petroleumPrice->rate->price - $previousClosures->price, 2);
        $previousClosuresPrice['change_percent'] = ($petroleumPrice->rate->price - $previousClosures->price) / $previousClosures->price * 100;
        $previousClosuresPrice['change_percent'] = number_format($previousClosuresPrice['change_percent'], 2);
        $previousClosuresPrice['status'] = $previousClosuresPrice['change_amount'] < 0 ? 'down' : 'up';


        $getArchivePrices = PetroleumPriceArchive::getArchivePrices($petroleumPrice);

        return view('index.petroleumtype')->with('petroleumPrice', $petroleumPrice)
            ->with('allGasPrices', $allGasPrices)
            ->with('previousClosuresPrice',  ($previousClosuresPrice))
            ->with('getArchivePrices', $getArchivePrices);
            // ->with('filter', $filter);
    }

}
