<?php

namespace App\Http\Controllers;

use App\Models\Silver;
use App\Models\SilverArchive;
use App\Models\SilverPrices;
use Carbon\Carbon;
use Illuminate\Http\Request;

class SilverController extends Controller
{


  public function show(){
    $silver_prices = SilverPrices::with('kind')->get();
    return view('index.silver_price')->with('silver_prices', $silver_prices);
  }
  

  public function showKarat($slug){
    
    $silverKarat = Silver::with('price')->where('slug', $slug)->first();
    if ($silverKarat == null)
      abort(404);

      
      
    $silver_prices = SilverPrices::with('kind')->get();

    $metalPrice = \App\Models\MetalPrices::where('currency','USD')->where('metal_type', 'XAG')->first();
    $metalPriceEgp = \App\Models\MetalPrices::where('currency','EGP')->where('metal_type', 'XAG')->first();


    $previousClosures = SilverArchive::where('created_at', '<', Carbon::today())
    ->where('archive_kind', $silverKarat->s_id)
    ->where('archive_price', '!=', $silverKarat->price->p_price)
    ->orderBy('created_at', 'desc')
    ->first();
    $previousClosuresPrice = [];
    $previousClosuresPrice['price'] = $previousClosures->archive_price;
    $previousClosuresPrice['change_amount'] = $silverKarat->price->p_price - $previousClosures->archive_price;
    $previousClosuresPrice['change_percent'] = ($silverKarat->price->p_price - $previousClosures->archive_price) / $previousClosures->archive_price * 100;
    $previousClosuresPrice['change_percent'] = number_format($previousClosuresPrice['change_percent'], 2);
    $previousClosuresPrice['status'] = $previousClosuresPrice['change_amount'] < 0 ? 'down' : 'up';




    $filter = request('days');
    $filter = isset($filter) ? $filter : 30;


    
    
    if (in_array($filter, [1,7,30]))
     $getArchivePrices = SilverArchive::getArchivePrices($silverKarat, $filter, 'days');
    elseif(in_array($filter, [90,180]))
    $getArchivePrices = SilverArchive::getArchivePrices($silverKarat, $filter, 'months');
    elseif(in_array($filter, [365,'all']))
    $getArchivePrices = SilverArchive::getArchivePrices($silverKarat, $filter, 'years');
      else{
        $getArchivePrices = SilverArchive::getArchivePrices($silverKarat, 30, 'days');
      }
      
    return view('index.silver_price_karat')
    ->with('previousClosuresPrice',  ($previousClosuresPrice))
    ->with('silverKarat', $silverKarat)
    ->with('getArchivePrices', $getArchivePrices)
    ->with('filter', $filter)
    ->with('metalPrice', $metalPrice)
    ->with('metalPriceEgp', $metalPriceEgp)
    ->with('silver_prices', $silver_prices);
    
  }


}
