<?php

if ( ! function_exists('getExpPrices'))
{
    function getExpPrices(){
        return [1,5,10,50,100,500,1000,5000,10000,50000,100000];
    }
}
if ( ! function_exists('egyPetrolUrl'))
{
    function egyPetrolUrl($petrol){
        return url(route('petrolUnit', ['slug' => $petrol->slug]));
    }
}
if ( ! function_exists('checkPlus'))
{
    function checkPlus($status) {
        return $status == 'up' ? '+' : '';
    }
    
}

if ( ! function_exists('getGaramsUntis'))
{
    function getGaramsUntis(){
        return [1,5,10,15,20 ,25,50,100 ,250,500,1000];
    }
}

if ( ! function_exists('getSetting'))
{
    function getSetting($key)
    {
        return (config('mainSettings')[$key]) ?? config('mainSettings')[$key];
    }
}

if ( ! function_exists('siteName'))
{
    function siteName()
    {
        return config('app.locale') == 'ar' ? config('mainSettings')['site_name_ar'] : config('mainSettings')['site_name_en'];
    }
}

if ( ! function_exists('priceFormat'))
{
    function priceFormat($price, $mark = 2){
        $formattedPrice = rtrim(rtrim(number_format($price, $mark), '0'), '.');
         if (strpos($formattedPrice, '.') !== false) {
            $decimalPart = explode('.', $formattedPrice)[1];
            if (strlen($decimalPart) === 1) {
                $formattedPrice .= '0'; // Add one trailing zero
            }
        }
        return $formattedPrice;
    }

}

function diffForHumans($date){
    return \Carbon\Carbon::parse($date)->diffForHumans();
}
if ( ! function_exists('statusBG'))
{
    function statusBG($status){
        return $status == 'down' ? 'danger' : 'success';
    }
}


if ( ! function_exists('getStatusSign'))
{
    function getStatusSign($sign)
    {
        switch($sign){

            case 'up' :
                return '<i class="up fas fa-caret-up" aria-hidden="true"></i>';
                break;
            case 'down' :
                return '<i class="down fas fa-caret-down" aria-hidden="true"></i>';
                break;

            case 'pause' :
                return '<i class="pause far fa-pause-circle" aria-hidden="true"></i>';
                break;
            default :
                return '<i class="pause far fa-pause-circle" aria-hidden="true"></i>';
                break;
        }

    }
}

function rounded($number)
{
  $plus = ( strpos($number, '+') !== false  ? '+' : '');
  return $plus . (float)number_format((float)$number, 4, '.', '');
}

    function handleCurrenHref($curren)
    {
        $title = 'سعر ';
        $title .= $curren;
        $title .= ' مقابل الجنية المصري في كل البنوك المصرية';
        return hrefHandle($title);

    }
    function handleBankHref($bankName)
    {
        $title = 'اسعار العملات في ';
        return hrefHandle($title . $bankName);

    }
    function bank_title($bank){
        $bankLang = __('main.db_bank_name');
        return  __('main.bank_title', ['bank_name' => $bank->$bankLang]);
    }
  function curr_title($currency){ 
      $currLang = __('main.db_curr_name');
      return  __('main.curr_title', ['curr' => $currency->$currLang]);
  }

function news_url(array $data_news){
    return url('news/' . date('d-m-Y/',$data_news['news_time_add']) . $data_news['news_id'] . '/' . str_slug(str_replace('/', '-', $data_news['news_title']), '-', false));
}

function bank_url($bank){
    return url(route('bank_price', [$bank['bank_slug']]));
}

function bank_currency_url($bank, $currency){
    return url(route('bank_currency_price', ['slug' => $bank->bank_slug, 'currency' => strtolower($currency->cur_code)]));
    // return url(route('bank_price', [$bank['bank_slug']]));
}
function currency_url(array $cur){
    return route('currency', ['c_from' => $cur['cur_code'], 'c_to' => 'EGP']);
    //return url('currency/'. strtoupper($cur['cur_code']) .'/' . handleCurrenHref($cur['cur_name_ar']));
}
function bankCurrencyUrl($bankSlug, $currency){
    return route('bank_currency_price', ['slug' => $bankSlug, 'currency' => strtolower($currency)]);
}
function page_url(array $page){
    return url('page/' . ($page['page_slug']));
}

function new_img($img)
{
    $info = pathinfo($img);
    return asset($info['dirname'] . '/xs/' . $info['basename']);
}

if ( ! function_exists('back'))
{
  function back()
  {
      redirect($_SERVER["HTTP_REFERER"]);
  }
}
    function admin_url($url = '')
    {
        return url('adminControlPanel/' . $url);
    }

    function error(){
         ini_set("display_errors","On");
    }
    class arabicDate
    {
        //مصفوفة ايام الاسبوع
        var $arabicDay=array(0  => "الاحد",1  => "الاثنين", 2  => "الثلاثاء", 3  => "الاربعاء", 4  => "الخميس",
        5  => "الجمعه",6  => "السبت");
        //مصفوفة ايام الاسبوع
        var $arabicMonth=array(1=>"يناير",2=>"فبراير",3=>"مارس",4=>"إبريل",5=>"مايو",6=>"يونيو",7=>"يوليو",
        8=>"اغسطس",9=>"سبتمبر",10=>"اكتوبر",11=>"نوفمبر",12=>"ديسمبر");

        function m()
        {
            for($i=0; $i<=count($this->arabicMonth); $i++)
            {
                if(date('n')==$i)
                {
                    return  $this->arabicMonth[$i];
                    break;
                }
            }
        }

        function d()
        {
            for($i=0; $i<count($this->arabicDay); $i++)
            {
                if(date('w')==$i)
                {
                    return  $this->arabicDay[$i];
                    break;
                }
            }
        }

        public function getDate()
        {
            return $this->d() . ' ' . date('d') . ' ' . $this->m() . ' ' . date('Y');
        }

        public function datetitle()
        {
            return $this->d() . ' ' . date('d') . '-' . date('m') . '-' . date('Y');
        }

    }

    function date_news_title()
    {
        $date = new  arabicDate;
        return $date->datetitle();
    }
    function date_arabic()
    {
        $date = new arabicDate;
        return $date->getDate();
    }
    function date_formate($lang = 'ar')
    {
        if ($lang === 'ar')
        {
          $date = new arabicDate;
          return $date->getDate();
        }else{
            return date('D d M Y');
        }
    }
    function getCrul ($url)
    {

        // get domain name
        $parse = parse_url($url);

        $ch = curl_init();
        curl_setopt ($ch, CURLOPT_URL, $url);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt ($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.6) Gecko/20070725 Firefox/2.0.0.6");
        curl_setopt ($ch, CURLOPT_TIMEOUT, 999999999999);
        curl_setopt ($ch, CURLOPT_REFERER, $parse['host']);
        curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HEADER,0);
        $result = curl_exec ($ch);
        $info = curl_getinfo($ch);
        if ($info['http_code'] != 200)
          return false;

        preg_match_all('/^Set-Cookie:\s*([^;]*)/mi', $result, $matches);
        $cookies = array();
        foreach($matches[1] as $item) {
            parse_str($item, $cookie);
            $cookies = array_merge($cookies, $cookie);
        }


        foreach($cookies as $key => $value)
        {
            setcookie($key, $value, time()+9999999, '', '.banklive.net', false, true);
        }


        return $result;
        curl_close($ch);
    }

    function HandleItems($code, $Content)
    {
        preg_match_all('/'.$code.'/', $Content, $output_array);
        return $output_array;
    }

    function priceFilter($price)
    {
        if (null !== $price && !empty($price) && 0 != $price)
        {
            $exPrice = explode('.', $price);
            if (isset($exPrice[1]))
                $PriceAfterSign = $exPrice[1];
            else
                $PriceAfterSign = 0;
            if ( strlen($exPrice[0]) == 4 )
            {
                $fPrice = substr($exPrice[0], 0, 2);
                $tPrice = substr($exPrice[0], 2, 4);
                $price =  $fPrice . '.' . $tPrice . $PriceAfterSign;
            }elseif ( strlen($exPrice[0]) == 3 ){
                $fPrice = substr($exPrice[0], 0, 1);
                $tPrice = substr($exPrice[0], 1, 3);
                $price =  $fPrice . '.' . $tPrice . $PriceAfterSign;
            }
            return (double) $price;
        }
        return 0;
    }

    function sendMail($subject, $content, $to_email = 'm.gamalayoub@gmail.com')
    {
      $name     = '';
      $email    = 'cron@banklive.net';

      Mail::send([], [], function ($message) use($to_email, $name, $email, $subject, $content)
      {
            $message->to($to_email)
              ->from($email, 'BankLive')
              ->subject($subject)
              ->setBody("<div style='text-align: left;'>{$content}", 'text/html'); // for HTML rich messages

      });
    }
    function filertString($CurCode){
        return preg_replace('/[\x00-\x1F\x80-\xFF]/', '', $CurCode);
    }


    //PhantomJScloud
    function scrapAPISystem($urlWebsite)
    {
        
        // ini_set("allow_url_fopen", true);
        
        $url = 'https://PhantomJScloud.com/api/browser/v2/ak-24q45-mhqdv-p0fs5-55d1h-9p505/';
        // $options = array(
        //     'http' => array(
        //         'header'  => "Content-type: application/json\r\n",
        //         'method'  => 'POST',
        //         'content' => json_encode(['url' => $urlWebsite,'renderType' => 'html'])
        //     )
        // );
        // $context  = stream_context_create($options);
        // return  file_get_contents($url, false, $context);




        $curl = curl_init();
        $data = array("lang" => "en");
        $data = json_encode(['url' => $urlWebsite,'renderType' => 'html']);
                curl_setopt ($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array("Content-type: application/json"));
        curl_setopt($curl, CURLOPT_URL, $url);
        // curl_setopt ($curl, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.6) Gecko/20070725 Firefox/2.0.0.6");
        curl_setopt ($curl, CURLOPT_TIMEOUT, 999999999999);
        curl_setopt ($curl, CURLOPT_FOLLOWLOCATION, 0);
        curl_setopt ($curl, CURLOPT_RETURNTRANSFER, 1);

        $result = curl_exec($curl);
        return $result;
        curl_close($curl);
    }

    function removeAlefLam($text)
    {
        $text = explode(' ', $text); 

        $newText = '';
        foreach ($text as $word) {
            $alefLam = mb_substr($word, 0, 2, 'UTF-8');
            if ($alefLam == 'ال')
                $newText .=  mb_substr($word, 2, mb_strlen($word, 'UTF-8'), 'UTF-8') . ' ';
            else{
                $newText .=  $word . ' ';;
            }
        }

        return trim($newText);
    }
    function filterCode($currency)
    {
        //echo $currency,"\n";

        $arabic = $currency;


        $result = preg_replace("/[^a-zA-Z\s]+/", "", $currency);
        $currency   = (strtolower(filertString(trim($result))));
        $currencies = array(

            'USD' => array(utf8_encode('دولار أمريكى'), 'american dollar', 'u.s. dollars', 'us dollars', 'us dollar', 'usd', utf8_encode('دولار امريكى'), utf8_encode('دولار'), utf8_encode('الدولار'), utf8_encode('دولار امريكي')),
            'EUR' => array('euro', 'eur', 'euro currency', utf8_encode('اليورو'), utf8_encode('يورو')),
            'GBP' => array(utf8_encode('جنيــه إسترليـنى'), 'english pound', 'sterl pounds', 'pound sterling', 'gbp', 'gb pound', 'british pound', 'sterling pound', utf8_encode('جنيه استرلينى'), utf8_encode('جنيه استرليني'), utf8_encode('إسترليني')),
            'CHF' => array('swiss franc', 'chf', utf8_encode('فرنك سويسري'), utf8_encode('فرنك سويسرى')),
            'DKK' => array(utf8_encode('كرون دانمركى'), 'danish krones', 'danish krone', 'dkk', 'denmark krone', utf8_encode('كرونا دنماركي')),
            'KWD' => array(utf8_encode('دينــار كويتى'), 'kuwait dinars', 'kuwaiti dinar', 'kwd', 'kuwait dinar', utf8_encode('دينار كويتى'), utf8_encode('دينار كويتي')),
            'SAR' => array('saudi riyal', 'sar', 'saudi arabian riyal', 'saudi rial',utf8_encode('ريـــال سعـــودى'), utf8_encode('ريال سعودى'), 'saudi rials', utf8_encode('ريال'), utf8_encode('سعودي'), utf8_encode('ريال سعودي'), utf8_encode('الريال السعودي')),
            'JOD' => array('jordan dinar', 'jordanian dinar', 'jod', utf8_encode('دينار اردني'), utf8_encode('دينـار اردنـى')),
            'BHD' => array('bahraini dinar', 'bhd', 'bahrain dinar', 'bad', utf8_encode('دينار بحريني'), utf8_encode('دينــار البحــرين')),
            'QAR' => array('qatari rials', 'qatari riyal', 'qar', 'qatari rial', 'qatar rial', 'qtr', utf8_encode('ريال قطري'), utf8_encode('ريـــال قطــــرى')),
            'OMR' => array('omani riyal', 'omr', 'oman riyal', 'omani rial', utf8_encode('ريال عماني'), utf8_encode('ريـــال عمـــانى')),
            'AED' => array('united arab emirates dirham', 'emirat dirham', 'emirati dirham', 'aed', 'u.a.e dirham', 'uae dirham', 'arab emirates dirham', utf8_encode('درهم الإمارات'), utf8_encode('درهم اماراتى'), utf8_encode('درهم إماراتى')),
            'SEK' => array('swedish krona', 'sek', 'swidish krone', 'swedish krone', utf8_encode('كرونا سويدى'), utf8_encode('كرون ســويدى')),
            'NOK' => array('norweg krone', 'norwegian krone', 'nok', 'norway krone', utf8_encode('كرون نرويجي'), utf8_encode('كرون نرويجى')),
            'CAD' => array(utf8_encode('دولار كنـدى'), 'canad dollar', 'canadian dollar', 'cad', 'canada dollar', utf8_encode('دولار كندي')),
            'AUD' => array('australian dollars', 'australian dollar', 'aud', 'australia dollar', utf8_encode('دولار استرالي'), utf8_encode('دولار اســـترالى')),
            'JPY' => array('japanese yens', 'japan yen', 'jpy', 'japanese yen', 'yen', utf8_encode('ين ياباني')),
            '100JPY' => array('YENS(100)' ,'japanese yen 100', '100jpy', utf8_encode('لكل 100 ين يابانى'), utf8_encode('100 ين يابانى')),
            'CNY' => array('chinese yuan', 'cny', 'yuan', utf8_encode('يوان صينى')),
            'CYP' => array('cyprus pound', 'cyp'),
            'THB' => array('thai baht', 'thb', utf8_encode('البات التايلندي')),
            'LBP' => array('LBP'),
        );

        $curCode = '';
        foreach($currencies as $currencyCode => $synonymous)
        {
            if ( ! empty($currency) OR ! empty($arabic))
            {
                if( in_array($currency, $synonymous) )
                {
                    $curCode = $currencyCode;
                }elseif(in_array(utf8_encode($arabic), $synonymous)){
                    $curCode = $currencyCode;
                }
            }
        }

        $arabic_data = iconv("WINDOWS-1256" , "UTF-8" , $arabic);

        if (empty($curCode) AND ( strlen($currency) > 3 OR mb_strlen($arabic_data, 'UTF-8') > 3 )  )
        {
            //echo ($currency) . '  -  ' . $arabic . "\n";
             // sendMail("BankLive  لم نعثر على هذه العملة في النظام ","<h1>$currency</h1>");
            return null;
        }
        return $curCode;
    }

    function getCrulCIB ($url)
    {
        $curl = curl_init();
        $data = array("lang" => "en");
        $data = json_encode($data);
                curl_setopt ($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array("Content-Type: application/json;charset=utf-8"));
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt ($curl, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.6) Gecko/20070725 Firefox/2.0.0.6");
        curl_setopt ($curl, CURLOPT_TIMEOUT, 999999999999);
        curl_setopt ($curl, CURLOPT_FOLLOWLOCATION, 0);
        curl_setopt ($curl, CURLOPT_RETURNTRANSFER, 1);

        $result = curl_exec($curl);
        return $result;
        curl_close($curl);
    }
    function DOMRemove(DOMNode $from) {
        $sibling = $from->firstChild;
        do {
            $next = $sibling->nextSibling;
            $from->parentNode->insertBefore($sibling, $from);
        } while ($sibling = $next);
        $from->parentNode->removeChild($from);
    }

function timeago($t)
{
    $timesArr = array(  's'=> trans('main.s'),
                        'S'=> trans('main.S'),
                        'i'=> trans('main.i'),
                        'I'=> trans('main.I'),
                        'h'=> trans('main.h'),
                        'H'=> trans('main.H'),
                        'd'=> trans('main.d'),
                        'D'=> trans('main.D'),
                        'w'=> trans('main.w'),
                        'W'=> trans('main.W'),
                        'm'=> trans('main.m'),
                        'M'=> trans('main.M'),
                        'y'=> trans('main.y'),
                        'Y'=> trans('main.Y')
                    );
    $timeDiff = time()-$t;
    if($timeDiff < 60)
    {
        if($timeDiff<1)
        {
            $arr[] = 's';
            $arr[] = '0';
        }
        else if($timeDiff<3 or $timeDiff>10)
        {
            $arr[] = 's';
            $arr[] = $timeDiff;
        }
        else
        {
            $arr[] = 'S';
            $arr[] = $timeDiff;
        }
    }
    else if(($temp=(int)($timeDiff/60)) < 60)
    {
        if($temp<3 or $temp>10)
        {
            $arr[] = 'i';
        }
        else
        {
            $arr[] = 'I';
        }
        $arr[] = $temp;
    }
    else if(($temp=(int)($timeDiff/(60*60))) < 24)
    {
        if($temp<3 or $temp>10)
        {
            $arr[] = 'h';
        }
        else
        {
            $arr[] = 'H';
        }
        $arr[] = $temp;
    }
    else if(($temp=(int)($timeDiff/(60*60*24))) < 7)
    {
        if($temp<3)
        {
            $arr[] = 'd';
        }
        else
        {
            $arr[] = 'D';
        }
        $arr[] = $temp;
    }
    else if(($temp=(int)($timeDiff/(60*60*24*7))) < 4)
    {
        if($temp<3)
        {
            $arr[] = 'w';
        }
        else
        {
            $arr[] = 'W';
        }
        $arr[] = $temp;
    }
    else if(($temp=(int)($timeDiff/(60*60*24*7*4))) < 12)
    {
        if($temp<3 or $temp>10)
        {
            $arr[] = 'm';
        }
        else
        {
            $arr[] = 'M';
        }
        $arr[] = $temp;
    }
    else
    {
        $temp = (int)($timeDiff/(60*60*24*30*12));
        if($temp<3 or $temp>10)
        {
            $arr[] = 'y';
        }
        else
        {
            $arr[] = 'Y';
        }
        $arr[] = $temp;
    }
    return $arr[1].' '.$timesArr[$arr[0]];
}

    function hrefHandle($title)
    {
        // letters Numbers Spaces Hypens only
        $slug = preg_replace('/[^\x{0600}-\x{06FF}\-\s\pN\pL]+/u', '', mb_strtolower($title, 'UTF-8'));
        // spaces Duplicatted Hypens
        $slug = preg_replace('/[\-\s]+/', '-', $slug);
        $slug = trim($slug, '-');
        return $slug;
    }


    if ( ! function_exists('myPassword'))
    {
        /**
         * myPassword
         *
         * Crypt string to password hash with encryption_key in config File
         *
         * @param   string  password decrypt
         * @param   int     lenght of hash
         * @return  string  password hash encrypt
         */
        function myPassword ($string, $lenght = 100)
        {
            return substr(hash('sha512', $string . config_item('encryption_key')), 0, $lenght);
        }
    }

    function ads($type = 'auto')
    {
      /*
        return '
        <script async src="//pagead2.googlesyndication.com/pagead/js/adsbygoogle.js"></script>
        <ins class="adsbygoogle"
             style="display:block"
             data-ad-client="ca-pub-2671865764581416"
             data-ad-slot="1229263642"
             data-ad-format="'.$type.'"
             data-full-width-responsive="true"></ins>
        <script>
        (adsbygoogle = window.adsbygoogle || []).push({});
        </script>';*/
    }
    //////////////////////////////////////////
    //----------------------------------------
    //      Handle Pages
    //----------------------------------------
    //////////////////////////////////////////

    // gold price page
    if ( ! function_exists('gold_url'))
    {
        function gold_url(){
            return url(route('goldprice'));
        }
    }

    // silver price page
    if ( ! function_exists('silver_url'))
    {
        function silver_url(){
            return url(route('silverprice'));
        }
    }


    function lurl($url = '/'){
        return LaravelLocalization::localizeUrl($url);
    }
    // currency link like -> exchange rate usd in egypt

?>
