<?php

namespace App\Jobs;

use Illuminate\Support\Facades\Log;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldBeUnique;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;

class SendBrowserNotifications implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    private $notification;
    private $tokensPatch;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct($notification, $tokensPatch)
    {
        $this->notification = $notification;
        $this->tokensPatch  = $tokensPatch;
    }

    public function sendBrowseNoti($token, $title = 'welcome to Banklive', $url = 'https://banklive.net')
    {
      $token = (is_array($token)) ? $token : [$token];

      $from = "AAAAy3Nw9zw:APA91bEclVvPE0FJSUUiSFLwwdib170cG8DoeNAC-psPF_F1ZZWwQ012o89uyU-ZVvo2M37vCe8Wa76A7hzQuqxqhivEtQVdCN3t8x7hfrI_pyx_Rf5CReo6u8pIqCAn8zDJUUMOxvoo";

      $message = array(
              'body'      => $title,
              'title'     => 'بنك لايف - BankLive',
              'vibrate'   => 1,
              'icon'      => 'https://banklive.net/uploads/noti_logo.jpg',
              'sound'     => 1,
              "click_action" => $url,
              'time_to_live' => 3600
          );
      $fields = array(
                  'registration_ids'  => $token,
                  'notification'      => $message,
                  'priority' => "high",
                  
              );
      $headers = array(
          'Authorization: key=' . $from,
          'Content-Type: application/json'
      );
      //#Send Reponse To FireBase Server
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, 'https://fcm.googleapis.com/fcm/send');
      curl_setopt($ch, CURLOPT_POST, true);
      curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
      curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
      return  curl_exec($ch);
      curl_close($ch);
    }
    private function checkTokenIsNotValid(array $tokens, $fcmResponse)
    {
        $fcmResponse = json_decode($fcmResponse, true);
        $tokensNotValid = [];

        foreach ($tokens as $key => $token)
        {
            if (isset($fcmResponse['results'][$key]['error'])){
                $tokensNotValid[] = $token;
            }
        }

        if (!empty($tokensNotValid)){
            \App\BrowserTokensFCM::whereIn('token_id', $tokensNotValid)->delete();
        }
    }
    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $tokensLangData = [];
        $tokensLangData = $this->tokensPatch->mapToGroups(function ($item, $key)
        {
            return [$item['lang'] => $item['token_id']];
        })->toArray();


        if (isset($tokensLangData['en']) && $tokensLangData['en'] != null)
        {
            $dataEN = $this->sendBrowseNoti($tokensLangData['en'], $this->notification->title_en, $this->notification->link_en);
            $this->checkTokenIsNotValid($tokensLangData['en'], $dataEN);

            // Log::channel('jobs')->info(json_encode($tokensLangData['en']) . "\n\r" . $this->notification->title_en. "\n\r" .  $this->notification->link_en);
        }
        
        if(isset($tokensLangData['ar']) && $tokensLangData['ar'] != null)
        {
            $dataAR = $this->sendBrowseNoti($tokensLangData['ar'], $this->notification->title_ar, $this->notification->link);
            $this->checkTokenIsNotValid($tokensLangData['ar'], $dataAR);

            // Log::channel('jobs')->info(json_encode($tokensLangData['ar']) . "\n\r" . $this->notification->title_ar. "\n\r" .  $this->notification->link);
        }


        // Log::channel('jobs')->info($data);

        // $data = $this->notification;
        
    }
}
