<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Banks extends Model
{

    protected $primaryKey = 'bank_id';
    protected $table      = 'bp_banks';
    protected $fillable   = [];
    public    $timestamps = false;
    protected $dates = [
        'created_at',
        'updated_at'
    ];

    public function getNameAttribute(){
        return (app()->getLocale() == "en") ? ucwords(trim($this->bank_name_en))  : trim($this->bank_name_ar);
    }

    // currency name
    public function prices()
    {
      return $this->hasMany('\App\Models\CurrenciesPrices', 'bankp_bank_id', 'bank_id')
      ->with('currency');
    }// end of inner for currency price table
    public function currencyPrices()
    {
      return $this->hasOne('\App\Models\CurrenciesPrices', 'bankp_bank_id', 'bank_id');
    }// end of inner for currency price table
    

    public function getImgPathAttribute(){
      return asset( 'uploads/35x35/'. $this->bank_image);
    }// end of img path

    public function getImgBigAttribute(){
      return asset( 'uploads/420x420/'. $this->bank_image);
    }// end of img path



    // public function allPrices()
    // {
    //     return $this->hasMany(CurrenciesPrices::class, 'bankp_bank_id', 'bank_id');
    // }

}
