<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Currencies extends Model
{
    protected $primaryKey = 'cur_id';
    protected $table = 'bp_currencies';
    protected $fillable = [];
    public $timestamps = false;

    public function getNameAttribute()
    {
        return app()->getLocale() == 'en' ? ucwords(trim(strtolower($this->cur_name_en))) : trim($this->cur_name_ar);
    }

    public function getShortNameAttribute()
    {
        return app()->getLocale() == 'ar' ? trim($this->cur_name_ar) : $this->cur_code;
    }

    public function getSmallFlagAttribute()
    {
        return '/flags/1x1/' . $this->cur_flag;
    }

    public function getFlagAttribute()
    {
        return '/flags/4x3/' . $this->cur_flag;
    }
    // currency name
    public function globalMarket()
    {
        return $this->hasMany('\App\Models\GeneralCurrencyRates', 'from_cur_id', 'cur_id');
    } // end of inner for currency price table
    public function rates()
    {
        return $this->hasOne('\App\Models\GeneralCurrencyRates', 'from_cur_id', 'cur_id');
    } // end of inner for currency price table

    public function bankRate($bankId)
    {
        return $this->hasOne('\App\Models\CurrenciesPrices', 'bankp_cur_id', 'cur_id')->where('bankp_bank_id', $bankId)->first();
    }

    public function banksRateBanks($banksId)
    {
        return $this->hasMany('\App\Models\CurrenciesPrices', 'bankp_cur_id', 'cur_id')->with('bank')->whereIn('bankp_bank_id', $banksId);
    }

    public function allPrices()
    {
        return $this->hasOne(CurrenciesPrices::class, 'bankp_cur_id', 'cur_id');
    }
}
