<?php
namespace App\Models;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Casts\Attribute;

class GeneralCurrencyRates extends Model
{
  protected $table = 'bp_general_currency_rates';
  protected $fillable   = [];
  public    $timestamps = false;
/**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = [
      'created_at',
      'updated_at'
  ];
  // currency name
  public function currency()
  {
    return $this->hasOne('\App\Models\Currencies', 'cur_id', 'from_cur_id')->selectRaw('cur_id,cur_code,cur_flag,cur_name_ar,cur_name_en,cur_sort,updated_at');
  }
  

  protected function currentPrice(): Attribute
  {
      return Attribute::make( 
          get: fn ($value) => priceFormat($value,5),
      );
  }

  protected function changePercentSign(): Attribute
  {
      return Attribute::make( 
          get: fn ($value) => priceFormat($value,6),
      );
  }
  protected function changeAmount(): Attribute
  {
      return Attribute::make( 
          get: fn ($value) => priceFormat($value,6),
      );
  }




}
