<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Golden extends Model
{
    protected $table = 'bp_gold_kind';

    public function getNameAttribute(){
        return (app()->getLocale() == "en") ? ucwords(trim($this->g_name_en))  : trim($this->g_name_ar);
    }
    

    public function price(){
        return $this->belongsTo(GoldPrices::class, 'g_id', 'p_kind');
    }

    public function rate()
    {
      return $this->hasOne('\App\Models\GoldPrices', 'p_kind', 'g_id');
    }// end of inner for currency price table

    public function getFullUrlAttribute()
    {
      return url(route('gold_karat', ['karat' => $this->slug]));
    }// end of inner for currency price table
}
