<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class MetalPrices extends Model
{
  protected $table = 'metal_prices';


  public static function getAllPrices()
  {
    $metalPrices = self::where('currency', 'USD')->get();
    return $metalPrices->mapWithKeys(function ($metal)
    {
        return [strtolower($metal->metal_type) => [
          
            'current_price' => '$'.  priceFormat($metal->price, 2),
            // 'previous_price' => $metal->previous_price,
            'change_status' => $metal->change_status,
            'change_amount' => priceFormat($metal->change_amount, 4),
            'change_percent' => checkPlus($metal->change_status) . priceFormat($metal->change_percent, 4) .'%',
        ]];
    }
    );

  }

}
