<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class PetroleumPrice extends Model
{
    protected $primaryKey = 'id';
    protected $table      = 'petroleum_price';
    protected $fillable   = [];
    public    $timestamps = false;
    protected $dates = [
        'updated_at'
    ];

    public function types(){
        return $this->hasOne('\App\Models\PetroleumTypes', 'id','petroleum_type_id');
    }
    public static function getOktan92(){
        $price = self::where('petroleum_type_id', 2)->first();
        return [
            'current_price' => priceFormat($price->price), 
            'change_status' => $price->change_type, 
            'change_amount' => $price->change_amount, 
            'change_percent' => checkPlus($price->change_type) . number_format(priceFormat($price->change_percentage, 3), 2) .'%'
        ];
    }
    

}
