<?php

namespace App\Models;

use Carbon\Carbon;
use Illuminate\Database\Eloquent\Model;

class PetroleumPriceArchive extends Model
{ 
    
    protected $primaryKey = 'id';
    protected $table      = 'petroleum_price_archive';
    protected $fillable   = [];
    public    $timestamps = false;




    public static function getArchivePrices($gas)
    {
        // switch ($timeType) {
        //     case 'days':
        //         $numberOfDays = $timePeriod;
        //         break;
        //     case 'months':
        //         $numberOfDays = $timePeriod; // تمثل 6 أشهر
        //         break;
        //     case 'years':
        //         $numberOfDays = ($timePeriod == 'all') ? 365 * 10 : $timePeriod; // تمثل سنتين
        //         break;
        //     default:
        //         $numberOfDays = $timePeriod;
        // }
    
        // $daysAgo = Carbon::today()->subDays($numberOfDays);
    
        $prices = self::where('petroleum_type_id', $gas->id)
            // ->whereDate('created_at', '>=', $daysAgo)
            ->orderBy('created_at', 'desc')
            ->get()
            ->groupBy(function($date){
                return Carbon::parse($date->created_at)->format('Y-m-d');
            })->toArray();
    
        $dates = [];
        $pricesList = [];
        $dates[] = Carbon::parse($gas->rate->updated_at)->format('Y-m-d');
        $pricesList[] = $gas->rate->price;
        foreach ($prices as $date => $price) {
            $dates[] = $date;
            $lastPriceOfMonth = $price[0]['price'];
            $pricesList[] = $lastPriceOfMonth;
        }

        // dd($dates);
        return ['dates' => array_reverse($dates), 'prices' => array_reverse($pricesList)];
    }

}
