<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Silver extends Model
{
    protected $table = 'bp_silver_kind';
    protected $primaryKey = 's_id';
    public $timestamps = false;


    public function getNameAttribute(){
        return (app()->getLocale() == "en") ? ucwords(trim($this->s_name_en))  : trim($this->s_name_ar);
    }

    public function getShortNameAttribute(){
        return (app()->getLocale() == "en") ? (($this->short_name_en))  : ($this->short_name_ar);
    }
    public function price(){
        return $this->belongsTo(SilverPrices::class, 's_id', 'p_kind');
    }
    public function getFullUrlAttribute()
    {
      return url(route('silver_karat', ['karat' => $this->slug]));
    }// end of inner for currency price table


}
