<?php

namespace App\Providers;

use Illuminate\Support\ServiceProvider;
use View;
use App\Models\Banks;
use App\Models\Currencies;
use App\Models\GeneralCurrencyRates;
use App\Models\GoldPrices;
use App\Models\MetalPrices;
use App\Models\PetroleumPrice;
use App\Models\Query;
use Illuminate\Support\Facades\Cache;
use Illuminate\Support\Facades\Auth;
use Carbon\Carbon;
use Illuminate\Support\Facades\App;

class AppServiceProvider extends ServiceProvider
{
    /**
     * Register any application services.
     *
     * @return void
     */
    public function register()
    {
    }

    /**
     * Bootstrap any application services.
     *
     * @return void
     */
    public function boot()
    {
        

        date_default_timezone_set('Africa/Cairo');
        // if (request()->header('CF-Connecting-IP') == '197.60.91.200')
        // {
            // dump(request()->server('HTTP_REFERER'));
            // dump(request()->headers->get('referer'));
            // dump(request()->getSchemeAndHttpHost());
            // dd(URL::previous());
            // config(['app.debug' => true, 'app.env' => 'locale']);
        // }
        //     \Debugbar::enable();
        // Cache::forget('mailSettings');

        // apis for BankLiveApp
        if ( request()->header('x-api-key') == 'BankLiveApp')
            return;

            // config( ['app.debug' => true, 'app.env' => 'locale'] );

        // if ( request()->ip() == '197.60.196.228' )
        // {
        //     
        // }
        $sitePages = Cache::rememberForever('mainSitePages', function () {
            return \App\Models\Pages::where('page_active', 1)->orderBy('page_sort', 'asc')->get();
        });

        $MailDataSettings = Cache::remember('mailSettings', 6000000, function () {
            $mainData = (\App\Models\Settings::all())->toArray();
            $MailDataSettings    = array();
            foreach($mainData as $row)
                $MailDataSettings[$row['key']] = $row['value'];

            return $MailDataSettings;
        });
        
        config(['mainSettings' => $MailDataSettings]);

        

        // $allCurrencies = Cache::remember('allCurrencies', 6000000, function () {
        //     return Currencies::selectRaw('cur_code,cur_flag,cur_name_ar,cur_name_en,cur_sort,cur_last_update')->orderByRaw('cur_sort = 0, cur_sort asc')->get();
        // });

        // = Cache::remember('allBanks', 6000000, function () {
            // $allBanks = Banks::selectRaw('bank_id,bank_image,bank_last_update,bank_slug,bank_name_ar,bank_name_en')->where('active', 1)->orderByRaw('bank_sort = 0, bank_id asc')->get();
       // });
        
       $fastLable = Query::get_best_prices(['usd', 'sar', 'eur', 'gbp','kwd',  'CHF'], 1);

       

    //    $centralBank = Cache::rememberForever('centralBank', function () {
        $centralBank =  Banks::selectRaw('bank_id,bank_image,updated_at,bank_slug,bank_name_ar,bank_name_en')->with(['prices' => function ($q){$q->selectRaw('bankp_cur_id,bankp_bank_id,bankp_sell_banknote,bankp_buy_banknote,bankp_status_buy,bankp_status_sell,bankp_percent_buy,bankp_percent_sell')->take(5);}])->where('bank_id', 22)->first();
        // });


        
        // navbar prices
        $metalPrices  = MetalPrices::getAllPrices();
        $navbarPrices = 
        [
            'usdBank'       => [
                'current_price'  => priceFormat($fastLable['usd']['buy'][0]['bankp_buy_banknote']),
                'change_amount'  => priceFormat($fastLable['usd']['buy'][0]['buy_change_amount']),
                'change_percent' => checkPlus($fastLable['usd']['buy'][0]['bankp_status_buy']) . priceFormat($fastLable['usd']['buy'][0]['buy_change_percent']). '%',
                'change_status'  => $fastLable['usd']['buy'][0]['bankp_status_buy'],
            ],
            'eurBank'       => [
                'current_price'  => priceFormat($fastLable['eur']['buy'][0]['bankp_buy_banknote']),
                'change_amount'  => priceFormat($fastLable['eur']['buy'][0]['buy_change_amount'],4),
                'change_percent' => checkPlus($fastLable['eur']['buy'][0]['bankp_status_buy']) . priceFormat($fastLable['eur']['buy'][0]['buy_change_percent'],4). '%',
                'change_status'  => $fastLable['eur']['buy'][0]['bankp_status_buy'],
            ],
            'sarBank'       => [
                'current_price'  => priceFormat($fastLable['sar']['buy'][0]['bankp_buy_banknote']),
                'change_amount'  => priceFormat($fastLable['sar']['buy'][0]['buy_change_amount'],4),
                'change_percent' => checkPlus($fastLable['sar']['buy'][0]['bankp_status_buy']) . priceFormat($fastLable['sar']['buy'][0]['buy_change_percent'],4). '%',
                'change_status'  => $fastLable['sar']['buy'][0]['bankp_status_buy'],
            ],
            'usdegp'        => GeneralCurrencyRates::select('current_price', 'change_status', 'change_percent', 'change_amount')->where('from_cur_id', 1)->first()->toArray(),
            'gold_karat21'  => GoldPrices::getKarat21(),
            'xau_usd'       => $metalPrices['xau'],// gold
            'xag_usd'       => $metalPrices['xag'],// silver
            'octan92'       => PetroleumPrice::getOktan92(),
        ];
        // dd($navbarPrices);
        // header -> #026fc8
        // footer -> #003366

        
            // dd($date);
        // setlocale(LC_TIME, 'ar');
        // $date = Carbon::now();
        // $formattedDate = $date->format('l Y-m-d الساعة h:i A');
        // dd(strftime('%A %Y-%m-%d الساعة %I:%M %p', $date));

        View::Share([
            //   'banks'         => $allBanks,
              'settings'    => $MailDataSettings,
              'central_bank'  => $centralBank,
                //   'silver_prices' => SilverPrices::with('kind')->get(),
                //   'gold_prices'   => GoldPrices::with('kind')->get(),
               'fast_news' => $fastLable,
               'navbarPrices' => $navbarPrices,
               'sitePages' => $sitePages
              //'news_block'    => News::orderBy('news_id', 'desc')->limit(8)->get(),
            ]);

    }
    
}
