<?php 
$nameLang = 'اللغه العربيه';
$siteName = $settings['site_name_en'];
$siteMiniDesc = $settings['site_mini_desc_en'];
$siteDesc = $settings['site_desc_en'];
if (LaravelLocalization::getCurrentLocale() == 'ar') {
    $siteName = $settings['site_name_ar'];
    $siteMiniDesc = $settings['site_mini_desc_ar'];
    $siteDesc = $settings['site_desc_ar'];
    $nameLang = 'English';
}
$sitename = $siteName;
$desc_meta = !view()->hasSection('description') ? $siteDesc : '';
$img_meta = !view()->hasSection('meta') ? url('/assets/img/bank_live_logo.png') : '';
$currentTime = \Carbon\Carbon::now();
$dateTime = $currentTime->format('d/m/Y h:i:s');
$typeTime = $currentTime->format('A') == 'AM' ? __('main.am') : __('main.pm');
$dateTime = $dateTime . ' ' . $typeTime;
// بيانات الـ Organization 
$organizationSchema = [
    "@context" => "http://schema.org",
    "@type" => "Organization",
    "name" => $siteName,
    "url" => "https://banklive.net",
    "logo" => [
        "@type" => "ImageObject",
        "width" => 190,
        "height" => 60,
        "url" => "https://banklive.net/assets/logo2.png"
    ],
    "sameAs" => [
        "https://www.facebook.com/BankLive.net/",
        "https://x.com/BankLive_net"
    ]
];
$websiteSchema = [
    "@context" => "http://schema.org",
    "@type" => "WebSite",
    "name" => $siteName,
    "url" => "https://banklive.net"
];
$organizationJsonLd = json_encode($organizationSchema, JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE);
$websiteJsonLd = json_encode($websiteSchema, JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE);
$keywords = __('main.main_site_keywords');
$keywordsText = implode(', ', $keywords);
?>
<!DOCTYPE html>
<html prefix="og: http://ogp.me/ns#" dir="{{ __('main.dir') }}"
    lang="{{ LaravelLocalization::getCurrentLocale() }}">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="dns-prefetch" href="https://pagead2.googlesyndication.com" />
    <link rel="dns-prefetch" href="https://cdn.jsdelivr.net" />
    <link rel="dns-prefetch" href="https://cdnjs.cloudflare.com" />
    <link rel="dns-prefetch" href="https://fundingchoicesmessages.google.com" />
    <link rel="dns-prefetch" href="https://www.gstatic.com" />
    <link rel="dns-prefetch" href="https://www.googletagmanager.com" />
    <link rel="dns-prefetch" href="https://connect.facebook.net" />
    <link rel="preload" href="{{ url('/css/fonts/DroidKufi-Regular.ttf') }}" as="font" type="font/ttf" crossorigin="anonymous">
    <link rel="preload" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.2/webfonts/fa-solid-900.woff2" as="font" type="font/woff2" crossorigin="">
    <link rel="preload" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.2/webfonts/fa-regular-400.woff2" as="font" type="font/woff2" crossorigin="">
    <link rel="preload" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.2/webfonts/fa-brands-400.woff2" as="font" type="font/woff2" crossorigin="">
    <meta name="author" content="BankLive">
    <meta name="google-site-verification" content="07i4VjOytbizxZJbuMs9ygXSAuNLsE4ckq1ruL3Tvms">
    <title>
        @hasSection('title')
            @yield('title') |
            {{ $sitename }}@else{{ $sitename . ' - ' . config('mainSettings.site_mini_desc_' . __('main.lang')) }}
        @endif
    </title>
    <link rel="alternate" href="{{ LaravelLocalization::getNonLocalizedURL(Request::url()) }}" hreflang="x-default">
    <link rel="alternate" href="{{ LaravelLocalization::getLocalizedURL('ar', null, [], true) }}" hreflang="ar-EG"/>
    <link rel="alternate" href="{{ LaravelLocalization::getLocalizedURL('en', null, [], true) }}" hreflang="en">
    <meta name="description" content="@hasSection('description')
@yield('description')@else{{ $desc_meta }}
@endif">
    <link rel="canonical" href="{{ url()->current() }}">
    <meta name="robots" content="all">
    <meta name="keywords"
        content="@hasSection('keywords')
@yield('keywords')@else{{ $keywordsText }}
@endif">
    <meta property="og:title"
        content="@hasSection('title')
@yield('title') | {{ $sitename }}@else{{ $sitename . ' - ' . config('mainSettings.site_mini_desc_' . __('main.lang')) }}
@endif" />
    <meta property="og:description" content="@hasSection('description')@yield('description')@else{{ $desc_meta }}
@endif">
    <meta property="og:type" content="@hasSection('type')
@yield('type')@else{{ 'website' }}
@endif">
    <meta property="og:url" content="{{ url()->current() }}">
    <meta property="og:image" content="@hasSection('img')
@yield('img')@else{{ $img_meta }}
@endif">
    <meta property="og:site_name" content="{{ $sitename }}">
    @hasSection('article_tage')
        @yield('article_tage')
    @else
        @foreach ($keywords as $tag)
            <meta property="article:tag" content="{{ $tag }}" />
        @endforeach
    @endif
    @yield('article')
    <meta name="twitter:site" content="@BankLive_net" />
    <meta name="twitter:title"
        content="@hasSection('title')
@yield('title') | {{ $sitename }}@else{{ $sitename . ' - ' . config('mainSettings.site_mini_desc_' . __('main.lang')) }}
@endif" />
    <meta name="twitter:description" content="@hasSection('description')@yield('description')@else{{ $desc_meta }}@endif" />
    <meta name="twitter:image" content="@hasSection('img')
@yield('img')@else{{ $img_meta }}
@endif" />
    {{-- <link rel="apple-touch-icon" sizes="57x57" href="/assets/favicons/apple-icon-57x57.png">
    <link rel="apple-touch-icon" sizes="60x60" href="/assets/favicons/apple-icon-60x60.png">
    <link rel="apple-touch-icon" sizes="72x72" href="/assets/favicons/apple-icon-72x72.png">
    <link rel="apple-touch-icon" sizes="76x76" href="/assets/favicons/apple-icon-76x76.png">
    <link rel="apple-touch-icon" sizes="114x114" href="/assets/favicons/apple-icon-114x114.png">
    <link rel="apple-touch-icon" sizes="120x120" href="/assets/favicons/apple-icon-120x120.png">
    <link rel="apple-touch-icon" sizes="144x144" href="/assets/favicons/apple-icon-144x144.png">
    <link rel="apple-touch-icon" sizes="152x152" href="/assets/favicons/apple-icon-152x152.png">
    <link rel="apple-touch-icon" sizes="180x180" href="/assets/favicons/apple-icon-180x180.png">
    <link rel="icon" type="image/png" sizes="192x192" href="/assets/favicons/android-icon-192x192.png">
    <link rel="icon" type="image/png" sizes="32x32" href="/assets/favicons/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="96x96" href="/assets/favicons/favicon-96x96.png">
    <link rel="icon" type="image/png" sizes="16x16" href="/assets/favicons/favicon-16x16.png">
    <link rel="manifest" href="{{url('/assets/favicons/manifest.json')}}">
    <meta name="msapplication-TileColor" content="#ffffff">
    <meta name="msapplication-TileImage" content="/assets/favicons/ms-icon-144x144.png">
    <meta name="theme-color" content="#ffffff"> --}}
    <meta name="csrf-token" content="{{ csrf_token() }}" />
    {{-- <link rel="alternate" type="application/rss+xml" title="RSS Feed for banklive.net" href="/en/rss.xml" />
    <link rel="sitemap" type="application/xml" title="Sitemap for banklive.net" href="/en/sitemap.xml" />
    <link rel="alternate" type="application/rss+xml" title="RSS Feed for banklive.net" href="/ar/rss.xml" />
    <link rel="sitemap" type="application/xml" title="Sitemap for banklive.net" href="/ar/sitemap.xml" /> --}}
    @include('includes.css')
    @yield('css')
    <style>.iconDispaly{font-size:14px!important}</style>
    {{-- {!! SEOMeta::generate() !!}
    {!! OpenGraph::generate() !!}
    {!! Twitter::generate() !!}
        --}}
    {!! JsonLd::generate() !!}
    <script type="application/ld+json">
        {!! $organizationJsonLd !!}
    </script>
    <script type="application/ld+json">
        {!! $websiteJsonLd !!}
    </script>
    @laravelPWA
    <!-- Global site tag (gtag.js) - Google Analytics -->
    <script async src="https://www.googletagmanager.com/gtag/js?id=G-7RW7G8SRZ5"></script>
    <script>
    window.dataLayer = window.dataLayer || [];
    function gtag(){dataLayer.push(arguments);}
    gtag('js', new Date());
    gtag('config', 'G-7RW7G8SRZ5');
    </script>
    <script async src="https://fundingchoicesmessages.google.com/i/pub-2671865764581416?ers=1" nonce="JEFR_PaH1rAWWHNNKkboHA"></script><script nonce="JEFR_PaH1rAWWHNNKkboHA">(function() {function signalGooglefcPresent() {if (!window.frames['googlefcPresent']) {if (document.body) {const iframe = document.createElement('iframe'); iframe.style = 'width: 0; height: 0; border: none; z-index: -1000; left: -1000px; top: -1000px;'; iframe.style.display = 'none'; iframe.name = 'googlefcPresent'; document.body.appendChild(iframe);} else {setTimeout(signalGooglefcPresent, 0);}}}signalGooglefcPresent();})();</script>
    <script async data-ad-client="ca-pub-2671865764581416" src="https://pagead2.googlesyndication.com/pagead/js/adsbygoogle.js"></script>
<!-- Hotjar Tracking Code for Site 5079239 (name missing) -->
<script>
    (function(h,o,t,j,a,r){
        h.hj=h.hj||function(){(h.hj.q=h.hj.q||[]).push(arguments)};
        h._hjSettings={hjid:5079239,hjsv:6};
        a=o.getElementsByTagName('head')[0];
        r=o.createElement('script');r.async=1;
        r.src=t+h._hjSettings.hjid+j+h._hjSettings.hjsv;
        a.appendChild(r);
    })(window,document,'https://static.hotjar.com/c/hotjar-','.js?sv=');
</script>
</head>
<body>
    <header>
        @include('includes.menu_sidebar')
        @include('includes.navbar')
        @include('includes.prices_in_lable')
    </header>
    <main>
        <div class="text-center" style="display: block;margin-top: 123px;height: 280px;">
            <ins class="adsbygoogle"
                style="display: block; height: 280px;"
                data-ad-client="ca-pub-2671865764581416"
                data-ad-slot="9776759422"
                data-ad-format="auto"
                data-full-width-responsive="true"></ins>
            <script>
                (adsbygoogle = window.adsbygoogle || []).push({});
            </script>
        </div>
        @yield('content')
    </main>
    @include('includes.footer')
    {{-- <div class="modal fade" id="importantMessageModal" data-modal-active="false" tabindex="-1" aria-labelledby="importantMessageModalLabel"
        aria-hidden="true" data-bs-backdrop="static" data-bs-keyboard="false">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header bg-danger text-light">
                    <h5 class="modal-title" id="importantMessageModalLabel"><i
                            class="fas fa-exclamation-triangle me-2"></i>تنبيه هام</h5>
                </div>
                <div class="modal-body">
                    <p style="    font-size: .9rem;
    line-height: 26px;
    text-align: center !important;"
                        class="text-center mb-3">ينوه موقع بنك لايف بأن أسعار العملات الخاصة بالبنوك والمعروضة في موقع
                        بنك لايف هي من المواقع الرسمية للبنوك المصرية. قد يتأخر البنك في تحديث تلك المعلومات والبيانات
                        في موقعه الرسمي.</p>
                    <p style="    font-size: .9rem;
    line-height: 26px;
    text-align: center !important;"
                        class="text-center">لذلك ننوه قبل اتخاذ أي قرار للبيع أو الشراء يرجى التأكد من السعر من خلال
                        الدخول إلى موقع البنك الرسمي أو الاتصال مباشرةً بالخط الساخن للبنك.</p>
                </div>
                <div class="modal-footer">
                    <button type="button" id="confirmButton" class="btn btn-danger" data-bs-dismiss="modal">
                        <i class="fas fa-thumbs-up"></i> موافق
                    </button>
                </div>
            </div>
        </div>
    </div> --}}

    {{-- <div id="fb-root"></div>
    <div id="fb-customer-chat" class="fb-customerchat"></div> --}}

    @php
        $langFormat = __('main.time_format');
        $currentDateNow = \Carbon\Carbon::now()->locale(config('app.locale'))->translatedFormat($langFormat);
    @endphp
    <script>
        var am = "{{ __('main.am') }}";
        var pm = "{{ __('main.pm') }}";
        const urlAjaxFCMSubscribe = "{{ route('SaveFCMTokens') }}";
        const urlAjaxCurrencyRate = "{{ route('get.currency.rate') }}";
        const buy_price = "{{ __('main.price_buy') }}";
        const sell_price = "{{ __('main.price_sell') }}";
        const select_currency = "{{ __('main.select_currency') }}";
        const current_time_now = "";
        var FIREBASE_API_KEY = "AIzaSyD2DvZxukqIVQnm2BtAL9I8-0mj25IXoUU";
        var FIREBASE_AUTH_DOMAIN = "banklivebrowsernoti.firebaseapp.com";
        var FIREBASE_PROJECT_ID = "banklivebrowsernoti";
        var FIREBASE_STORAGE_BUCKET = "banklivebrowsernoti.appspot.com";
        var FIREBASE_MESSAGING_SENDER_ID = "873815144252";
        var FIREBASE_APP_ID = "1:873815144252:web:35865a00aedb5957659039";

    </script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="{{ url('/plugins/bootstrap-5.3.3/js/bootstrap.bundle.min.js') }}"></script>
    <script src="https://www.gstatic.com/firebasejs/5.5.9/firebase-app.js"></script>
    <script src="https://www.gstatic.com/firebasejs/5.5.9/firebase-messaging.js"></script>
    <script src="{{ url('/js/app.min.js?v=5.107') }}"></script>
    
    @yield('js')    
    {{-- general calculator --}}
    <script>
        $(document).ready(function() {
            function fetchRate(typeExchange = 'defualt') {
                let fromCurrencyId = $('#currency-selector-from').val();
                let toCurrencyId = $('#to-currency-selector').val();
                let toAmount = $('#to_amount').val();
                let fromAmount = $('#from_amount').val();
                let inputData = $('#to_amount');
                if (typeExchange != 'defualt') {
                    inputData = $('#from_amount');
                }
                $.ajax({
                    url: urlAjaxCurrencyRate,
                    type: 'POST',
                    data: {
                        _token: $('meta[name="csrf-token"]').attr('content'),
                        from_currency_id: fromCurrencyId,
                        to_currency_id: toCurrencyId,
                        to_amount: toAmount,
                        from_amount: fromAmount,
                        type_exchange: typeExchange
                    },
                    success: function(response) {
                        // console.log();
                        inputData.val(response.result);
                        $('#rate').html(response.rate);
                        $('#rate_reverse').html(response.rate_reverse);
                    },
                    error: function(xhr) {
                        $('#rate').text('Error fetching rate');
                    }
                });
            }
            $('#currency-selector-from').on('changed.bs.select', function(e, clickedIndex, isSelected,
                previousValue) {
                var fromCurrencyId = $('#currency-selector-from').val();
                var toCurrencyId = $('#to-currency-selector').val();
                if (fromCurrencyId == toCurrencyId) {
                    $('#to-currency-selector').val('').selectpicker('refresh');
                } else {
                    fetchRate();
                }
            });
            $('#to-currency-selector').on('changed.bs.select', function(e, clickedIndex, isSelected,
                previousValue) {
                var fromCurrencyId = $('#currency-selector-from').val();
                var toCurrencyId = $('#to-currency-selector').val();
                if (fromCurrencyId == toCurrencyId) {
                    $('#currency-selector-from').val('').selectpicker('refresh');
                } else {
                    fetchRate();
                }
            });
            $('#from_amount').on('keyup', function() {
                fetchRate();
            });
            $('#to_amount').on('keyup', function() {
                fetchRate('reverse');
            });
        });
    </script>
    {{-- MultiBanks calculator --}}
    <script>
        $(document).ready(function() {
            const bankSelectMulti = $('#bank_multi');
            const currencySelectMulti = $('#currency_calculator_multi');
            const fromInputMulti = $('#from_multi');
            const toInputMulti = $('#to_multi');
            const fromCurrencyFlagMulti = $('#fromCurrencyFlag_multi');
            const toCurrencyFlagMulti = $('#toCurrencyFlag_multi');
            const fromCurrencyCodeMulti = $('#fromCurrencyCode_multi');
            const toCurrencyCodeMulti = $('#toCurrencyCode_multi');
            const btnExchangeMulti = $('#btnExchange_multi');
            const buyRateMulti = $('#buyRate_multi');
            const sellRateMulti = $('#sellRate_multi');
            const buyRateInputMulti = $('#buy_rate_multi');
            const sellRateInputMulti = $('#sell_rate_multi');
            let isReversedMulti = false; // Flag to check if the conversion direction is reversed
            currencySelectMulti.prop('disabled', true);
            fromInputMulti.prop('disabled', true);
            toInputMulti.prop('disabled', true);
            bankSelectMulti.change(function() {
                const selectedBank = bankSelectMulti.val();
                if (selectedBank) {
                    $.ajax({
                        url: '/calculator/get-bank-currencies',
                        type: 'POST',
                        contentType: 'application/json',
                        data: JSON.stringify({
                            bank: selectedBank
                        }),
                        headers: {
                            'X-CSRF-TOKEN': '{{ csrf_token() }}'
                        },
                        success: function(data) {
                            console.log(data);
                            // Clear previous options
                            currencySelectMulti.html('<option selected disabled value="">' +
                                select_currency + '</option>');
                            currencySelectMulti.prop('disabled', false);
                            // Add new options
                            $.each(data, function(index, currency) {
                                currencySelectMulti.append(
                                    $('<option></option>')
                                    .val(currency.cur_id)
                                    .text(currency.cur_name)
                                );
                            });
                        },
                        error: function(error) {
                            console.error('Error:', error);
                        }
                    });
                }
            });
            currencySelectMulti.change(function() {
                fromInputMulti.prop('disabled', false);
                toInputMulti.prop('disabled', false);
                const selectedCurrency = currencySelectMulti.val();
                const selectedBank = bankSelectMulti.val();
                if (selectedCurrency && selectedBank) {
                    $.ajax({
                        url: '/calculator/get-currency-rates',
                        type: 'POST',
                        contentType: 'application/json',
                        data: JSON.stringify({
                            bank_id: selectedBank,
                            currency_id: selectedCurrency
                        }),
                        headers: {
                            'X-CSRF-TOKEN': '{{ csrf_token() }}'
                        },
                        success: function(data) {
                            console.log(data);
                            // Update hidden fields with received values
                            buyRateInputMulti.val(data.buy_rate);
                            sellRateInputMulti.val(data.sell_rate);
                            // Update visible fields
                            fromCurrencyCodeMulti.text(data.currency.currency_code);
                            fromCurrencyFlagMulti.attr('src', data.currency.currency_flag);
                            fromCurrencyFlagMulti.attr('alt', data.currency.currency_code);
                            toCurrencyCodeMulti.text('EGP');
                            toCurrencyFlagMulti.attr('src', '/flags/1x1/eg.svg');
                            toCurrencyFlagMulti.attr('alt', 'EGP');
                            buyRateMulti.text(buy_price + ` - ${data.buy_rate}`);
                            sellRateMulti.text(sell_price + ` - ${data.sell_rate}`);
                            // Update conversion
                            updateConversionMulti();
                        },
                        error: function(error) {
                            console.error('Error:', error);
                        }
                    });
                }
            });
            function updateConversionMulti() {
                const buyPrice = parseFloat(buyRateInputMulti.val());
                const sellPrice = parseFloat(sellRateInputMulti.val());
                const amount = parseFloat(fromInputMulti.val());
                if (isReversedMulti) {
                    fromInputMulti.val((amount / sellPrice).toFixed(4));
                } else {
                    toInputMulti.val((amount * buyPrice).toFixed(4));
                }
            }
            function reverseUpdateConversionMulti() {
                const buyPrice = parseFloat(buyRateInputMulti.val());
                const sellPrice = parseFloat(sellRateInputMulti.val());
                const amount = parseFloat(toInputMulti.val());
                if (isReversedMulti) {
                    fromInputMulti.val((amount * sellPrice).toFixed(4));
                } else {
                    fromInputMulti.val((amount / buyPrice).toFixed(4));
                }
            }
            fromInputMulti.on('input', updateConversionMulti);
            toInputMulti.on('input', reverseUpdateConversionMulti);
            // btnExchangeMulti.click(function() {
            //     isReversedMulti = !isReversedMulti; // Toggle the conversion direction
            //     // Swap input values
            //     const tempValue = fromInputMulti.val();
            //     fromInputMulti.val(toInputMulti.val());
            //     toInputMulti.val(tempValue);
            //     // Update conversion based on the new direction
            //     updateConversionMulti();
            // });
            // Initial update
            // updateConversionMulti();
        });
    </script>
</body>
</html>