<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
     @import url("https://fonts.googleapis.com/css?family=Roboto");
/* DEMO STYLES */
* {
  box-sizing: border-box;
  margin: 0;
  padding: 0;
}

body {
  padding: 20px;
  font-family: "Roboto", sans-serif;
  color: #888;
  max-width: 600px;
  margin: auto;
  background: #efefef;
}

.container {
  display: flex;
  flex-direction: column;
  margin: auto;
  background: #fff;
  padding: 20px;
  border-radius: 10px;
  border: 1px solid #eaeaea;
  box-shadow: -2px 4px 12px 0px #dcdcdc;
  overflow: hidden;
}

ul {
  list-style: none;
  overflow-y: scroll;
  max-height: 50vh;
}

.parent {
  width: 300px;
  margin-bottom: 15px;
}

.title {
  margin-bottom: 25px;
}

/* styles */
.custom-select {
  position: relative;
}

.custom-select-options {
  background: #fff;
  position: absolute;
  top: 45px;
  left: 0;
  z-index: 9;
  max-height: 0;
  overflow: hidden;
  border-radius: 5px;
  box-shadow: 0 3px 6px rgba(0, 0, 0, 0.06), 0 3px 6px rgba(0, 0, 0, 0.03);
  overflow: hidden;
}
.custom-select-options li {
  position: relative;
  padding: 10px;
  border-bottom: 1px solid #ebebeb;
  cursor: pointer;
}
.custom-select-options li .custom-select-img-container {
  width: 20px;
  height: 20px;
  margin-right: 15px;
  display: inline-block;
  position: absolute;
  left: 10px;
  top: 50%;
  transform: translateY(-50%);
  overflow: hidden;
}
.custom-select-options li .custom-select-img-container img {
  width: 100%;
}
.custom-select-options li.is-highlighted {
  background: #3CA64F;
  color: #fff;
}
.custom-select-options li.is-highlighted:hover {
  color: #f0f0f0;
}
.custom-select-options li.label {
  color: #333;
}
.custom-select-options li:last-of-type {
  border-bottom: none;
}
.custom-select-options li:hover {
  color: #3CA64F;
}
.custom-select-options.is-active {
  transition: max-height 0.8s;
  max-height: 800px;
  font-size: 14px;
}
.custom-select-options.has-images li {
  padding-left: 35px;
}

.custom-select-active {
  background: #fff url('data:image/svg+xml;utf8,<svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill="#888" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" viewBox="0 0 36.4 100" style="enable-background:new 0 0 36.4 80;" xml:space="preserve"><g><path d="M18.2,50.1c-0.6,0-1.1-0.2-1.5-0.6L0.6,33.4c-0.8-0.8-0.8-2.1,0-3c0.8-0.8,2.1-0.8,3,0l14.6,14.6l14.6-14.6   c0.8-0.8,2.1-0.8,3,0c0.8,0.8,0.8,2.1,0,3L19.7,49.5C19.3,49.9,18.7,50.1,18.2,50.1z"/></g></svg>') no-repeat;
  background-position: calc(100% - 15px) center;
  border-radius: 5px;
  height: 40px;
  padding-right: 45px;
  padding-left: 15px;
  border: 1px solid #ddd;
  line-height: 40px;
  cursor: pointer;
}

.custom-select-searchbox {
  background: #fff url('data:image/svg+xml;utf8, <svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" fill="#888" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" viewBox="0 0 100 125" xml:space="preserve"><path d="M79.1,76.2L63,60.1c7.9-9.4,7.5-23.4-1.3-32.2c-9.3-9.3-24.4-9.3-33.7,0c-9.3,9.3-9.3,24.4,0,33.7  c4.6,4.6,10.8,7,16.9,7c5.5,0,10.9-1.9,15.4-5.6l16.1,16.1L79.1,76.2z M30.8,58.8c-7.7-7.7-7.7-20.3,0-28c3.9-3.9,8.9-5.8,14-5.8  c5.1,0,10.2,1.9,14,5.8c7.7,7.7,7.7,20.3,0,28C51.1,66.5,38.5,66.5,30.8,58.8z"/></svg>') no-repeat;
  background-position: calc(100% - 10px) center;
  width: 100%;
  height: 40px;
  padding: 0 15px;
  border: 1px solid #ddd;
  border-radius: 5px 5px 0 0;
  outline: none;
  box-shadow: 0 1px 3px rgba(0, 0, 0, 0.06), 0 3px 6px rgba(0, 0, 0, 0.03);
}
    </style>
</head>
<body>
    
<div class="container">
	 <h3 class="title">Customizable Javascript select box with icon with no Dependancies </h3>
	 <h4 class="title">Examples without Icons</h4>
	<div class="parent">
		<div class="custom-select">
			<select>
				<option value="richard">Richard Hendricks</option>
				<option value="erlich">Erlich Bachman</option>
				<option value="big">Big Head</option>
				<option value="bert" selected>Bertram Gilfoyle</option>
				<option value="dinesh"> Dinesh Chugtai</option>
			</select>
		</div>
	</div>
	<h4 class="title">Examples with Icons</h4>
	<div class="parent">
			<div class="custom-select icon-imgs select-search">
			<select>
				<option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
				<option value="Sheldon" selected  data-img-url="https://banklive.net/flags/1x1/us.svg">Sheldon Cooper</option>
				<option value="howard" data-img-url="https://banklive.net/flags/1x1/us.svg">Howard Wolowitz</option>
				<option value="raj" data-img-url="https://banklive.net/flags/1x1/us.svg">Raj Koothrappali </option>
        <option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
				<option value="Sheldon" selected  data-img-url="https://banklive.net/flags/1x1/us.svg">Sheldon Cooper</option>
				<option value="howard" data-img-url="https://banklive.net/flags/1x1/us.svg">Howard Wolowitz</option>
				<option value="raj" data-img-url="https://banklive.net/flags/1x1/us.svg">Raj Koothrappali </option>

        <option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
				<option value="Sheldon" selected  data-img-url="https://banklive.net/flags/1x1/us.svg">Sheldon Cooper</option>
				<option value="howard" data-img-url="https://banklive.net/flags/1x1/us.svg">Howard Wolowitz</option>
				<option value="raj" data-img-url="https://banklive.net/flags/1x1/us.svg">Raj Koothrappali </option>

        <option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
				<option value="Sheldon" selected  data-img-url="https://banklive.net/flags/1x1/us.svg">Sheldon Cooper</option>
				<option value="howard" data-img-url="https://banklive.net/flags/1x1/us.svg">Howard Wolowitz</option>
				<option value="raj" data-img-url="https://banklive.net/flags/1x1/us.svg">Raj Koothrappali </option>

        <option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
				<option value="Sheldon" selected  data-img-url="https://banklive.net/flags/1x1/us.svg">Sheldon Cooper</option>
				<option value="howard" data-img-url="https://banklive.net/flags/1x1/us.svg">Howard Wolowitz</option>
				<option value="raj" data-img-url="https://banklive.net/flags/1x1/us.svg">Raj Koothrappali </option>

        <option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
				<option value="Sheldon" selected  data-img-url="https://banklive.net/flags/1x1/us.svg">Sheldon Cooper</option>
				<option value="howard" data-img-url="https://banklive.net/flags/1x1/us.svg">Howard Wolowitz</option>
				<option value="raj" data-img-url="https://banklive.net/flags/1x1/us.svg">Raj Koothrappali </option>

        <option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
				<option value="Sheldon" selected  data-img-url="https://banklive.net/flags/1x1/us.svg">Sheldon Cooper</option>
				<option value="howard" data-img-url="https://banklive.net/flags/1x1/us.svg">Howard Wolowitz</option>
				<option value="raj" data-img-url="https://banklive.net/flags/1x1/us.svg">Raj Koothrappali </option>

        <option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
				<option value="Sheldon" selected  data-img-url="https://banklive.net/flags/1x1/us.svg">Sheldon Cooper</option>
				<option value="howard" data-img-url="https://banklive.net/flags/1x1/us.svg">Howard Wolowitz</option>
				<option value="raj" data-img-url="https://banklive.net/flags/1x1/us.svg">Raj Koothrappali </option>

        <option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
				<option value="Sheldon" selected  data-img-url="https://banklive.net/flags/1x1/us.svg">Sheldon Cooper</option>
				<option value="howard" data-img-url="https://banklive.net/flags/1x1/us.svg">Howard Wolowitz</option>
				<option value="raj" data-img-url="https://banklive.net/flags/1x1/us.svg">Raj Koothrappali </option>

        <option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
				<option value="Sheldon" selected  data-img-url="https://banklive.net/flags/1x1/us.svg">Sheldon Cooper</option>
				<option value="howard" data-img-url="https://banklive.net/flags/1x1/us.svg">Howard Wolowitz</option>
				<option value="raj" data-img-url="https://banklive.net/flags/1x1/us.svg">Raj Koothrappali </option>

        <option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
				<option value="Sheldon" selected  data-img-url="https://banklive.net/flags/1x1/us.svg">Sheldon Cooper</option>
				<option value="howard" data-img-url="https://banklive.net/flags/1x1/us.svg">Howard Wolowitz</option>
				<option value="raj" data-img-url="https://banklive.net/flags/1x1/us.svg">Raj Koothrappali </option>

        <option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
				<option value="Sheldon" selected  data-img-url="https://banklive.net/flags/1x1/us.svg">Sheldon Cooper</option>
				<option value="howard" data-img-url="https://banklive.net/flags/1x1/us.svg">Howard Wolowitz</option>
				<option value="raj" data-img-url="https://banklive.net/flags/1x1/us.svg">Raj Koothrappali </option>

			</select>
		</div>
	</div>

	<h4 class="title">Examples with Search </h4>
	<div class="parent">
			<div class="custom-select select-search">
				<select>
					<option value="rachel">Rachel Green</option>
					<option value="monica">Monica Geller</option>
					<option value="phoebe">Phoebe Buffay</option>
					<option value="joey" >Joey Tribbiani</option>
					<option value="chandler" selected>Chandler Bing</option>
          <option value="ross">Ross Geller</option>
				</select>
		</div>
	</div>
    
    	<h4 class="title">Examples with icons and Search and optgroup </h4>
	<div class="parent">
			<div class="custom-select select-search icon-imgs">
				<select>
          <optgroup label="The big Bang Theory">
            <option value="leonard" data-img-url="https://banklive.net/flags/1x1/us.svg">Leonard Hofstadter</option>
          </optgroup>
          <optgroup label="friends">
             <option value="ross" data-img-url="https://banklive.net/flags/1x1/us.svg">Ross Geller</option>
          </optgroup>
					 <optgroup label="Silicon Valley">
              <option value="Richard" data-img-url="https://banklive.net/flags/1x1/us.svg">Richard Hendricks</option>
          </optgroup>
				</select>
		</div>
	</div>

</div>


<script>
 (function () {
  "use strict";
  var allSelect = Array.from(document.querySelectorAll(".custom-select"));

  allSelect.forEach(function (select, index) {
    var selectElm = select.querySelector("select");
    selectElm.style.display = "none";
    // GETTING ARRAY OF OPTIONS IN SELECT
    var options = Array.from(selectElm.children);
    var mainContainer = document.createElement("div");
    // APPENDING OPTIONS
    var ul = document.createElement("ul");
    mainContainer.className = "custom-select-options";
    if (select.classList.contains("icon-imgs")) {
      mainContainer.classList.add("has-images");
    }
    mainContainer.setAttribute(
      "data-select-head",
      "custom-select" + index + ""
    );

    var SelectHead = document.createElement("div");
    // CREATING ACTIVE ELEMENT Appending Select Box with and Checking Default Value And Appending Search Box with
    createHead(SelectHead);
    // ITERATING OVER OPTIONS
    var liContainer = "";
    // CHECKING IF IT CONTAINS SELECT-SEARCH AND APPEND SELECT BOX
    appendingOptions(options);

    var activeHead = select.querySelector(".custom-select-active");
    var SelectOptionsList = document.querySelector(
      ".custom-select-options[data-select-head=" + "custom-select" + index + "]"
    );

    function createHead(headElem) {
      var DefaultSelectedValue =
        selectElm.querySelector("[selected]") ||
        selectElm.querySelector("option");
      Object.assign(headElem, {
        className: "custom-select-active",
        innerHTML: DefaultSelectedValue.textContent
      });
      //headElem.className = "custom-select-active";
      headElem.setAttribute("data-select-index", "custom-select" + index + "");
      //headElem.innerHTML = DefaultSelectedValue.textContent;
      select.appendChild(headElem);
      document.body.appendChild(mainContainer);
      mainContainer.appendChild(ul);
      appendSearchBox();
    }
    // ITERATING OVER OPTIONS
    function appendingOptions(list) {
      var code = "";
      for (var x = 0; x < list.length; x++) {
        if (list[x].tagName == "OPTION") {
          code =
            "<li data-value=" +
            list[x].value +
            ">" +
            list[x].textContent +
            "</li>";
        } else {
          var head =
            "<li class='label'><h3>" +
            list[x].getAttribute("label") +
            "</li></h3>";
          var lists = "";
          var optgroupChildren = Array.from(list[x].children);
          for (var i = 0; i < optgroupChildren.length; i++) {
            lists +=
              "<li data-value=" +
              optgroupChildren[i].value +
              ">" +
              optgroupChildren[i].textContent +
              "</li>";
          }
          code = head + lists;
        }
        // CONDITION TO CHECK IF CHECKBOX HAS IMAGES
        if (select.classList.contains("icon-imgs") && list[x].dataset.imgUrl) {
          code =
            "<li data-value=" +
            list[x].value +
            "> <div class='custom-select-img-container'><img src='" +
            list[x].dataset.imgUrl +
            "'></div>" +
            list[x].textContent +
            "</li>";
        }
        liContainer += code;
      }

      ul.innerHTML = liContainer;
    }
    // FILTERING OPTIONS
    function filterOptions(val) {
      var pattern = new RegExp(val, "i");
      var optionsToShow = options.filter(function (option) {
        if (pattern.test(option.textContent) === true) {
          return option;
        }
      });
      liContainer = "";
      appendingOptions(optionsToShow);
      ul.innerHTML = liContainer;
      ul.querySelector("li[data-value]").classList.add("is-highlighted");
    }
    // SEARCH CHECK
    function appendSearchBox() {
      if (select.classList.contains("select-search")) {
        var Search = document.createElement("div");
        var input = document.createElement("input");
        input.type = "text";
        mainContainer.classList.add("has-search");
        input.className = "custom-select-searchbox";
        input.placeholder = "Enter your Search Here";
        Search.className = "search-list";
        Search.appendChild(input);
        //mainContainer.prepend(Search);
        mainContainer.insertBefore(Search, ul);
      }
    }
    // ADJUST SIZE + WIDTH
    function adjustSize() {
      mainContainer.style.width = SelectHead.offsetWidth + "px";
      mainContainer.style.left = SelectHead.getBoundingClientRect().left + "px";
      if (mainContainer.classList.contains("has-search")) {
        mainContainer.style.top =
          SelectHead.getBoundingClientRect().top + window.pageYOffset + "px";
      } else {
        mainContainer.style.top =
          SelectHead.getBoundingClientRect().bottom +
          5 +
          window.pageYOffset +
          "px";
      }
    }
    // DEBOUNCE FUNCTION
    function debounce(func, wait, immediate) {
      var timeout;
      return function () {
        var context = this,
          args = arguments;
        var later = function () {
          timeout = null;
          if (!immediate) func.apply(context, args);
        };
        var callNow = immediate && !timeout;
        clearTimeout(timeout);
        timeout = setTimeout(later, wait);
        if (callNow) func.apply(context, args);
      };
    }
    // ADJUST SIZE OF MENU ON WINDOW RESIZE
    window.addEventListener("resize", function () {
      debounce(adjustSize());
    });
    // HANDLING CLICK ON HEAD
    activeHead.addEventListener("click", function (e) {
      var thisSelectIndex = this.getAttribute("data-select-index");
      var thisList = document.querySelector(
        ".custom-select-options[data-select-head=" + thisSelectIndex + "]"
      );
      if (thisList.classList.contains("is-active")) {
        thisList.classList.remove("is-active");
      } else {
        filterOptions();
        // PREVENT EVENT FROM BUBBLING
        e.stopPropagation();
        // CLOSING ALL OPEN LISTS
        var allLists = Array.from(
          document.querySelectorAll(".custom-select-options")
        );
        allLists.forEach(function (list) {
          if (list.classList.contains("is-active")) {
            list.classList.remove("is-active");
          }
        });
        // ADJUST THE POSITION AND SIZE OF LIST
        adjustSize();
        SelectOptionsList.classList.add("is-active");
        // RESET SEARCH VALUE AND MAKE IT FOCUSED
        if (mainContainer.querySelector(".custom-select-searchbox")) {
          mainContainer.querySelector(".custom-select-searchbox").focus();
          mainContainer.querySelector(".custom-select-searchbox").value = "";
        }
      }
      // Keyboard Support
      ul.querySelector("li[data-value]").classList.add("is-highlighted");
    });
    // HANDLING CLICK ON UL
    SelectOptionsList.addEventListener("click", function (e) {
      // FUNCTION TO CHECK IF THE ELEMENT HAVE DATA VALUE
      function findParentWithData(elem) {
        try {
          if (elem.getAttribute("data-value")) return elem;
        } catch (e) {
          return false;
        }
        while (!elem.getAttribute("data-value")) {
          return findParentWithData(elem.parentNode);
        }
      }
      var li = findParentWithData(e.target);
      if (li !== false) {
        var selectedValue = findParentWithData(e.target).textContent;
        SelectOptionsList.classList.remove("is-active");
        SelectHead.textContent = selectedValue;
        selectElm.value = findParentWithData(e.target).getAttribute(
          "data-value"
        );
        // TRIGGER CHANGE EVENT ON SELECT ELEMENT
        var event = new Event("change");
        selectElm.dispatchEvent(event);
      }
    });
    // HANDLING CLICK ON Search
    var searchBoxes = Array.from(
      SelectOptionsList.querySelectorAll(".search-list")
    );
    searchBoxes.forEach(function (selectbox) {
      var search = selectbox.querySelector("input");
      selectbox.addEventListener("click", function (e) {
        e.stopPropagation();
      });
      // HANDLICK TYPING ON SEARCH
      search.addEventListener("keyup", function (event) {
        if (
          event.keyCode !== 38 &&
          event.keyCode !== 40 &&
          event.keyCode !== 13
        ) {
          filterOptions(this.value);
        }
        // TYPING ENTER ON SEARCH BOX
        if (event.keyCode == 13 && ul.children.length > 0) {
          var highlightedLi = ul.querySelector(".is-highlighted");
          SelectHead.textContent = highlightedLi.textContent;
          selectElm.value = highlightedLi.getAttribute("data-value");
          SelectOptionsList.classList.remove("is-active");
        }
        // TYPING ESCAPE ON SEARCH BOX
        else if (event.keyCode == 27) {
          SelectOptionsList.classList.remove("is-active");
        }
      });
    });
  });
  // HANDLING CLICK OUTSIDE
  var allOptions = Array.from(
    document.querySelectorAll(".custom-select-options")
  );
  // KEYBOARD EVENTS
  document.addEventListener("keydown", function (event) {
    var activeOption =
      document.querySelector(".custom-select-options.is-active ul") || "";
    var activeUl =
      document.querySelector(".custom-select-options.is-active") || "";
    if (activeOption) {
      var selcted = activeUl.getAttribute("data-select-head");
      var selectedLi = activeOption.querySelector(
        "li[data-value].is-highlighted"
      );
      var SelectHead = document.querySelector(
        "[data-select-index=" + selcted + "]"
      );
      var selectElm = SelectHead.parentElement.previousSibling;
      if (event.keyCode == 40) {
        if (selectedLi && selectedLi.nextSibling !== null) {
          if (selectedLi.nextSibling.getAttribute("data-value")) {
            selectedLi.classList.remove("is-highlighted");
            selectedLi.nextSibling.classList.add("is-highlighted");
          } else if (
            selectedLi.nextSibling.nextSibling.getAttribute("data-value") !==
            null
          ) {
            selectedLi.classList.remove("is-highlighted");
            selectedLi.nextSibling.nextSibling.classList.add("is-highlighted");
          }
        } else {
          selectedLi.classList.remove("is-highlighted");
          activeOption
            .querySelector("li[data-value]")
            .classList.add("is-highlighted");
        }
      } else if (event.keyCode == 38) {
        if (selectedLi.previousSibling !== null) {
          if (selectedLi.previousSibling.getAttribute("data-value")) {
            selectedLi.classList.remove("is-highlighted");
            selectedLi.previousSibling.classList.add("is-highlighted");
          } else if (
            selectedLi.previousSibling.previousSibling !== null &&
            selectedLi.previousSibling.previousSibling.getAttribute(
              "data-value"
            ) !== null
          ) {
            selectedLi.classList.remove("is-highlighted");
            selectedLi.previousSibling.previousSibling.classList.add(
              "is-highlighted"
            );
          }
        } else {
          selectedLi.classList.remove("is-highlighted");
          activeOption.lastChild.classList.add("is-highlighted");
        }
      } else if (event.keyCode == 13) {
        var selectElement = document.querySelector(
          ".custom-select-options.is-active li.is-highlighted"
        );
        SelectHead.textContent = selectElement.textContent;
        selectElm.value = selectElement.getAttribute("data-value");
        activeUl.classList.remove("is-active");
      }
    }
  });
  document.addEventListener("click", function () {
    allOptions.forEach(function (option) {
      option.classList.remove("is-active");
    });
  });
})();

</script>
</body>
</html>







<?php
exit;
//SELECT DISTINCT a_price, from_unixtime(a_time, '%Y-%m-%d %H:%m:%S') as realtime FROM `bp_archive` WHERE `a_curn_id` = 1 and a_option = 'buy' 
//and a_time BETWEEN UNIX_TIMESTAMP('2022-05-27 00:00:00') AND UNIX_TIMESTAMP('2022-05-27 23:59:59') #group by a_price ORDER BY `bp_archive`.`a_price` DESC

 $buy_prices  = \DB::table('bp_archive')->selectRaw("distinct (`a_price`) as price, (FROM_UNIXTIME(a_time, '%Y-%m-%d')) as time")
                                 ->where('a_curn_id', '1')
                                 ->where('a_bank_id', 15)
                                 ->where('a_option', 'buy')
                                 ->whereRaw("a_time BETWEEN UNIX_TIMESTAMP('2022-05-20 00:00:00') AND UNIX_TIMESTAMP('2022-05-27 23:59:59')")
                                //  ->groupBy('time')
                                 ->orderBy('time', 'asc')
                                //  ->orderBy('price', 'desc')

                                //  ->take(100)
                                 ->get();

?>


<!DOCTYPE HTML>
<html itemscope itemtype="http://schema.org/WebPage" prefix="og: http://ogp.me/ns#" dir="rtl" lang="ar">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">
	<meta http-equiv="content-type" content="text/html" />
	<meta name="author" content="gencyolcu" />
	<title>Untitled 2</title>
</head>
<body dir="rtl">

      <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
      <script type="text/javascript">
        google.charts.load('current', {'packages':['corechart']});
        google.charts.setOnLoadCallback(drawChart);
  
        function drawChart() {
          var data = google.visualization.arrayToDataTable([
            ['الوقت', 'سعر الدولار'],
            @foreach($buy_prices as $buy_price)
            ['{{$buy_price->time}}',  {{rounded($buy_price->price)}}],
                @endforeach
          ]);
  
          var options = {
            title: 'سعر الدولار',
            curveType: 'function',
            legend: { position: 'bottom' }
          };
  
          var chart = new google.visualization.LineChart(document.getElementById('curve_chart'));
  
          chart.draw(data, options);
        }
      </script>
      

      <div id="curve_chart" style="width: 900px; height: 500px"></div>



{{-- <script src="https://cdn.jsdelivr.net/npm/chart.js@3.8.0/dist/chart.min.js"></script>

<div class="chart-container" style="position: relative; height:20vh; width:30vw">
  <canvas dir="rtl" id="myChart"></canvas>
</div>


<script>
const ctx = document.getElementById('myChart').getContext('2d');
const myChart = new Chart(ctx, {
    type: 'line',
    data: {
        labels: [
          @foreach($buy_prices as $buy_price)
                    '{{$buy_price->time}}',
                @endforeach
          ],
        datasets: [{
            label: '#',
            data: [
               @foreach($buy_prices as $buy_price)
                    '{{rounded($buy_price->price)}}',
                @endforeach
            ],
            backgroundColor: [
                'rgba(255, 99, 132, 0.2)',
                'rgba(54, 162, 235, 0.2)',
                'rgba(255, 206, 86, 0.2)',
                'rgba(75, 192, 192, 0.2)',
                'rgba(153, 102, 255, 0.2)',
                'rgba(255, 159, 64, 0.2)'
            ],
            borderColor: [
                'rgba(255, 99, 132, 1)',
                'rgba(54, 162, 235, 1)',
                'rgba(255, 206, 86, 1)',
                'rgba(75, 192, 192, 1)',
                'rgba(153, 102, 255, 1)',
                'rgba(255, 159, 64, 1)'
            ],
            borderWidth: 3,
            fill: false,
    borderColor: 'rgb(75, 192, 192)',
    tension: 0.1,
    rtl: true

        }]
    },
    options: {
        scales: {
            y: {
                beginAtZero: false
            }
        },
        plugins: {
          legend: {
            rtl: true
            }
        }
    }
});
</script> --}}

</body>
</html>