@extends('layouts.app')
@section('content')
<div class="container">
        <h2>Create Notification</h2>

        @if(session('success'))
            <div class="alert alert-success">
                {{ session('success') }}
            </div>
        @endif

        @if(session('error'))
            <div class="alert alert-danger">
                {{ session('error') }}
            </div>
        @endif

        <form action="{{ route('notifications.store') }}" method="POST">
            @csrf
            <div class="mb-3">
                <label for="title_ar" class="form-label">Title AR</label>
                <input type="text" class="form-control" id="title_ar" name="title_ar" required>
            </div>
            <div class="mb-3">
                <label for="title_en" class="form-label">Title EN</label>
                <input type="text" class="form-control" id="title_en" name="title_en">
            </div>
            <div class="mb-3">
                <label for="is_pin" class="form-label">Is Pin</label>
                <select class="form-select" id="is_pin" name="is_pin" required>
                    <option value="0">No</option>
                    <option value="1">Yes</option>
                </select>
            </div>
            <div class="mb-3">
                <label for="link" class="form-label">Link</label>
                <input type="url" class="form-control" id="link" name="link" value="https://banklive.net/" required>
            </div>
            <div class="mb-3">
                <label for="link_en" class="form-label">Link EN</label>
                <input type="url" class="form-control" id="link_en" name="link_en" value="https://banklive.net/" required>
            </div>
            <button type="submit" class="btn btn-primary">Add Notification</button>
        </form>
    </div>
@endsection