<section class="row" id="fast-price-info">
@foreach($bestRates as $key => $currency)
    <!-- Best Buy Section -->
    <div class="col-12 col-md-6">
        <div class="card  my-3">
            <div class="card-header text-dark d-flex flex-direction-row gap-1 position-absolute end-0">
                <h5>{{ __('main.best_buy') }}</h5>
                <h3>{{ $currency->name }}</h3>
            </div>
            <div class="card-body">
                <div class="priceTypeFancyInfo">{{ __('main.price_buy') }}
                    <div class="font-1 text-end font-lg-5 spinner-grow text-light spinner" role="status"></div>
                </div>
                <div class="d-flex justify-content-between flex-row-reverse align-items-center">
                @foreach($currency->buy as $bank)

                    <div class="bankName">
                        <a title="{{ $bank->bank->name }}" href="{{ bank_currency_url($bank->bank, $currency) }}">
                            <img width="35" alt="{{ $bank->bank->name }} logo" src="{{ '/uploads/35x35/' . $bank->bank->bank_image }}" class="bank-logo-small"/>
                            {{-- <span class="hashTrend">#1</span>  --}}
                            {{ $bank->bank->name }}
                        </a>
                    </div>
                    <div class="text-center">
                        <span class="small">{{ __('main.egCurr') }}</span>
                        <span class="count_money display-6">{{ priceFormat($bank->bankp_buy_banknote,5) }}</span>
                        {{-- <div class="small {{ $bank->bankp_status_buy }}">
                            <i class="fas fa-arrow-{{ $bank->bankp_status_buy }}"></i> 
                            {{ $bank['buy_change_percent'] }}% {{ rounded($bank['buy_change_amount']) }}
                        </div> --}}
                    </div>
                    @endforeach

                </div>
            </div>
        </div>
    </div>

    <!-- Best Sell Section -->
    <div class="col-12 col-md-6">
        <div class="card  my-3">
            <div class="card-header text-dark d-flex flex-direction-row gap-1 position-absolute end-0">
                <h5>{{ __('main.best_sell') }}</h5>
                <h3>{{ $currency->name }}</h3>
            </div>
            <div class="card-body">
                <div class="priceTypeFancyInfo bg-primary">{{ __('main.price_sell') }}
                    <div class="font-1 text-end font-lg-5 spinner-grow text-light spinner" role="status"></div>
                </div>
                <div class="d-flex justify-content-between flex-row-reverse align-items-center">
                    <div class="bankName">
                        @foreach($currency->sell as $bank)
                            <a title="{{ __('main.bank_title', ['bank_name' => $bank->bank->name]) }}" href="{{ bank_currency_url($bank->bank, $currency) }}">
                                <img width="35" alt="{{ $bank->bank->name }} logo" src="{{ '/uploads/35x35/' . $bank->bank->bank_image }}" class="bank-logo-small"/>
                                {{-- <span class="hashTrend">#1</span>  --}}
                                {{ $bank->bank->name }}
                            </a>
                        @endforeach
                    </div>
                    <div class="text-center">
                        <span class="small">{{ __('main.egCurr') }}</span>
                        <span class="count_money display-6">{{ priceFormat($bank->bankp_sell_banknote,5) }}</span>
                        {{-- <div class="small {{ $bank->bankp_status_sell }}">
                            {!! getStatusSign($bank->bankp_status_sell) !!} {{ $bank['sell_change_percent'] }}% {{ priceFormat($bank['sell_change_amount']) }}
                        </div> --}}
                    </div>
                </div>
            </div>
        </div>
    </div>
@endforeach
</section>
