<?php
$dateNow = \Carbon\Carbon::now()->locale(config('app.locale'))->translatedFormat(__('main.time_format'));
?>
@extends('app')
@section('title')
    {{ __('main.allCurrenciesNew') }}
@endsection
@section('type')
    {{ 'article' }}
@endsection
@section('description')
    {{ __('main.curenciesDesc') }}
@endsection
@section('article')
    <meta property="article:tag" content="{{ __('main.allCurrenciesNew') }}" />
@endsection
@section('css')
    <link href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.14.0-beta2/css/bootstrap-select.min.css"
        rel="stylesheet">
@endsection
@section('content')
    <div class="container my-5 text-center text-md-start">
        <nav aria-label="breadcrumb mb-5 fs-6" typeof="BreadcrumbList" vocab="https://schema.org/">
            <ol class="breadcrumb">
                <li class="breadcrumb-item" property="itemListElement" typeof="ListItem">
                    <a property="item" typeof="WebPage" title="{{ __('main.goTo') }} {{ siteName() }}"
                        href="{{ url('/') }}" class="home">
                        <span property="name"><i class="fas fa-home"></i> {{ siteName() }}</span>
                    </a>
                    <meta property="position" content="1">
                </li>
                <li class="breadcrumb-item active" aria-current="page">
                    <span class="post post-post current-item">
                        {{ __('main.allCurrenciesNew') }} </span>
                    <meta property="position" content="2">
                </li>
            </ol>
        </nav>
        <div class="my-5" id="mainTitle">
            <h1 class="text-center fw-bold fs-1">{{ __('main.allCurrenciesNew') }}</h1>
            <span class="text-center d-block mb-5">{{ __('main.timeNow') }}{{ $dateNow }}</span>
        </div>
        <div class="row justify-content-between mt-5">
            <div class="col-12 col-lg-8 mb-5">
                <p class="text-muted text-center opacity-75" style="    font-size: 13px;">
                    {{ __('main.clickOnCurrency') }} {{ __('main.curenciesDesc') }}
                </p>
                <div id="search-btn">
                    <input type="text" id="search" placeholder="{{ __('main.searchForCurrency') }}"
                        class="form-control">
                </div>
                <table class="banklive-table table table-hover text-center" id="rates">
                    <thead>
                        <tr>
                            <th class="text-center border-0">{{ __('main.currency') }}</th>
                            <th class="text-center border-0">{{ __('main.price') }}</th>
                            <th class="text-center border-0">{{ __('main.change') }} %</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach ($currencies as $currency)
                            <tr>
                                <td class="text-start" >
                                    <a   title="{{ __('main.newCurrencyPageTitle', ['cur_from_name' => $currency->name]) }}"
                                        href="{{ currency_url($currency->toArray()) }}">
                                        <div class="d-flex currency-info" style="align-items: self-end;">
                                            <div class="info">
                                            <img loading="lazy" width="25" height="25" alt="{{ $currency->name }}" class="lazyload rounded-5" data-src="{{ $currency->smallflag }}" />
                                                <span class="code">{{ $currency->cur_code }}EGP</span>
                                            </div>
                                            <span class="currency-name">
                                                {{ $currency->name }}
                                            </span>
                                        </div>
                                    </a>
                                </td>
                                <td class="text-center">
                                    <span>{{ __('main.egCurr') }}</span>
                                    {{ $currency->rates->current_price }}
                                </td>
                                <td class="bl-text-xs text-center ltr {{ $currency->rates->change_status }}">
                                    <i class="fas fa-arrow-{{ $currency->rates->change_status }}"></i>
                                    {{ $currency->rates->change_percent }}%

                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
                <div class="d-grid gap-2">
                    <button id="loadMore" class="btn btn-light btn-block text-center">
                        <i class="fas fa-arrow-down"></i>
                        {{ __('main.show_more') }}
                    </button>
                </div>
            </div>
            <div class="col-12 mb-5 col-lg-4">
              @include('partials.__calculator_egy_market_general',['curr'])
            </div>
        </div> <!-- <div class="row justify-content-between mt-5"> -->
    </div> <!-- <div class="container my-5 text-center text-md-start"> -->
@endsection
@section('js')
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.14.0-beta2/js/bootstrap-select.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/lazysizes/5.3.0/lazysizes.min.js" async=""></script>
@endsection