<?php
\Artesaos\SEOTools\Facades\JsonLd::setType('BreadcrumbList');
\Artesaos\SEOTools\Facades\JsonLd::addValue('itemListElement', [
    [
        '@type' => 'ListItem',
        'position' => 1,
        'name' => siteName(),
        'item' => \LaravelLocalization::localizeUrl('/')
    ],
    [
        '@type' => 'ListItem',
        'position' => 2,
        'name' => __('main.contact_us'),
    ]
]);
?>
@extends('app')
@section('title'){{__('main.contact_us')}}@endsection
@section('content')
<div class="container py-5">
    @if (session('success'))
        <div class="alert alert-success alert-dismissible fade show text-center" role="alert">
            {{ session('success') }}
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
    @endif

    @if ($errors->any())
        <div class="alert alert-danger">
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    @if (session('error'))
        <div class="alert alert-danger">
            <ul>
                <li>{{ session('error') }}</li>
            </ul>
        </div>
    @endif
    <h1 class="text-center my-4">
        <i class="fas fa-envelope"></i> {{$title}}
    </h1>
    <div class="content-section text-start border-4 border-start">
    <p class="text-center mb-5">{!! __('main.contact_page_desc') !!}</p>
    <div class="row justify-content-center">
        <div class="col-lg-6">
            <div class="card p-4">
                <form action="{{route('contact')}}" method="post">
                    @csrf
                    <div class="row">
                        <div class="col-md-6 col-12">
                            <div class="mb-3">
                                <label for="name" class="form-label">{{__('main.contact_name')}}</label>
                                <input type="text" id="name" name="name" maxlength="100" class="form-control" required>
                            </div>
                        </div>
                        <div class="col-md-6 col-12">
                        <div class="mb-3">
                        <label for="email" class="form-label">{{__('main.contact_email')}}</label>
                        <input type="email" id="email" name="email" maxlength="100" class="form-control" required>
                    </div>
                        </div>
                    </div>

                    <div class="mb-3">
                        <label for="message" class="form-label">{{__('main.contact_msg')}}</label>
                        <textarea id="message" name="message" maxlength="1000" class="form-control" rows="6" required></textarea>
                    </div>

                    <div class="mb-3">
                        <div id="html_element"></div>
                    </div>

                    <div class="d-grid">
                        <button type="submit" class="btn btn-primary">
                            {{__('main.contact_send')}} <i class="fas fa-paper-plane"></i>
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </div>    </div>

</div>
@endsection

@section('js')
    <script type="text/javascript">
        var verifyCallback = function(response) {
            console.log(response);
        };
        var onloadCallback = function() {
            grecaptcha.render('html_element', {
                'sitekey': "6LeQHAQjAAAAAD7CS96JuNkSQ4MYII1uVYmoKPPw",
                'callback': verifyCallback,
            });
        };
    </script>
    <script src="https://www.google.com/recaptcha/api.js?trustedtypes=true&onload=onloadCallback&render=explicit"></script>
@endsection
@section('css')
<style>
h1 {
    font-family: 'Roboto', sans-serif;
    font-weight: bold;
    color: #2c3e50;
}
.content-section {
    box-shadow: 0 8px 16px 0 rgb(10 14 29 / 2%), 0 8px 64px 0 rgb(119 119 119 / 8%);
    border-radius: 10px;
    background-color: #ffffff;
    padding: 2rem;
    border-color: #2c3e50 !important;
}
.content-section h2, .content-section h3, .content-section h4 {
    margin-top: 1.5rem;
    color: #2c3e50;
}
.content-section p {
    margin-bottom: 1rem;
    text-align: left;
}
.content-section ul, .content-section ol {
    margin-bottom: 1rem;
    padding-left: 1.5rem;
    padding-right: 1.5rem;
}
.content-section ul li, .content-section ol li {
    margin-bottom: 0.5rem;
}
@media (max-width: 768px) {
    .content-section {
        padding: 1rem;
    }
}
</style>
@endsection
