<?php
\Artesaos\SEOTools\Facades\JsonLd::setType('BreadcrumbList');
\Artesaos\SEOTools\Facades\JsonLd::addValue('itemListElement', [
    [
        '@type' => 'ListItem',
        'position' => 1,
        'name' => siteName(),
        'item' => \LaravelLocalization::localizeUrl('/'),
    ],
    [
        '@type' => 'ListItem',
        'position' => 2,
        'name' => __('main.allBanks'),
        'item' => \LaravelLocalization::localizeUrl(route('banks')),
    ],
    [
        '@type' => 'ListItem',
        'position' => 3,
        'name' => ucwords($currency->name),
        'item' => currency_url($currency->toArray()),
    ],
]);
// $metalPrice = \App\Models\MetalPrices::where('metal_type', 'XAU')->first();
$dateNow = \Carbon\Carbon::now()->locale(config('app.locale'))->translatedFormat(__('main.time_format'));
?>
@extends('app')
@section('title'){{ __('main.curr_title', ['curr' => $currency->name]) }}@endsection
@section('type', 'article')
@section('description'){{ __('main.cur_desc_page', [
    'currency' => $currency->name,
]) }}@endsection
    {{-- @section('keywords'){{config('mainSettings.site_keywords')}}, {{__('main.cur_keywords_page', [
'currency' => $currency->name,
'currency_code' => $currency->cur_code,
])}}@endsection --}}
@section('keywords')
    {{ implode(', ', $keywords) }}
@endsection
@section('article_tage')
    @foreach ($keywords as $key)
        <meta property="article:tag" content="{{ $key }}" />
    @endforeach
@endsection
@section('css')
@endsection
@section('content')
    <div class="container my-5 text-center text-md-start">
        <nav aria-label="breadcrumb mb-5 fs-6">
            <ol class="breadcrumb">
                <li class="breadcrumb-item">
                    <a title="{{ __('main.goTo') }} {{ siteName() }}" href="{{ url('/') }}" class="home">
                        <span><i class="fas fa-home"></i> {{ siteName() }}</span>
                    </a>
                </li>
                <li class="breadcrumb-item">
                    <a href="{{ LaravelLocalization::localizeUrl(route('banks')) }}"><i class="fas fa-university"></i>
                        {{ __('main.allBanks') }}</a>
                </li>
                <li class="breadcrumb-item active" aria-current="page">
                    <span class="post post-post current-item">
                        <img width="20" class="currency-flag-small" src="{{ $currency->smallflag }}"
                            alt="{{ $currency->name }}" /> {{ ucwords($currency->name) }}
                    </span>
                </li>
            </ol>
        </nav>

        <div class="my-5">
            <h1 class="text-center fw-bold my-4 fs-1">{{ __('main.curr_title', ['curr' => $currency->name]) }}</h1>
            <span class="text-center d-block mb-5">{{ __('main.timeNow') }}{{ $dateNow }}</span>
        </div>


        <div class="row justify-content-between mt-5">

            <div class="col-12 col-lg-8 mb-5">
                @include('includes.best_prices')
                <section id="morePrices">
                    <div class="row">
                        <div class="col-md-6 col-12">
                            <div class="py-1 px-3 my-2" style="box-shadow:rgba(0, 17, 51, 0.07) 0px 3px 15px;">
                                <div class="item text-start fs-5 align-items-center gap-2 mb-0 d-flex">
                                    <span class="start-head bg-{{ statusBG($generalRates->change_status) }} top-0"></span>
                                    <span class="fs-6">{{ __('main.priceGlobally') }}</span>
                                    <span
                                        class="fs-4 fw-bold color-main-price">{{ priceFormat($generalRates->current_price, 5) }}</span>
                                    <span class="fs-6 ltr {{ $generalRates->change_status }}">
                                        <i class="fas fa-arrow-{{ $generalRates->change_status }}"></i>
                                        {{ priceFormat($generalRates->change_percent, 5) }}%
                                        {{ priceFormat($generalRates->change_amount, 5) }}
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div>
                </section>


                <div class="mt-4 mb-2">
                    <h2 class="text-start fs-5 fw-bold mb-0">
                        <span
                            class="start-head me-2"></span>{{ __('main.currencyPriceInBanks', ['currency' => $currency->name]) }}
                    </h2>
                    <p class="text-start mt-3 bl-text-xs">
                        {{ __('main.bankCurrencyInfo', ['currency' => $currency->name]) }}
                    </p>
                </div>
                <div id="table-container" class="table-wrapper">
                    <table class="banklive-table table table-hover text-center"
                        style="box-shadow: 0 8px 16px 0 rgb(10 14 29 / 2%), 0 8px 64px 0 rgb(119 119 119 / 8%);border-radius: 10px; overflow: hidden;">
                        <thead>
                            <tr>
                                <th style="width: 50%;" class="text-center py-3">{{ __('main.bank') }}</th>
                                <th class="text-center py-3">{{ __('main.price_buy') }}</th>
                                <th class="text-center py-3">{{ __('main.price_sell') }}</th>
                            </tr>
                        </thead>
                        <tbody>
                            @php
                                $counter = 0;
                            @endphp
                            @foreach ($currency->rates as $rate)
                                @if ($rate->is_lost || $rate['bankp_buy_banknote'] == 0)
                                    @continue;
                                @endif

                                @php
                                    $counter++;
                                @endphp
                                <tr class="@if ($rate->is_lost) is_lost no-sort @endif">
                                    <td class="text-start">
                                        <a class="fs-6"
                                            title="{{ __('main.bank_title', ['bank_name' => $rate[__('main.db_bank_name')]]) }}"
                                            href="{{ bank_url($rate, $currency) }}">
                                            <div class="info d-flex align-items-center">
                                                <img width="20" alt="{{ $rate[__('main.db_bank_name')] }}"
                                                    class="bank-logo-small" data-src="/assets/img/loader.png"
                                                    src="/uploads/35x35/{{ $rate['bank_image'] }}" />
                                                {{-- <span class="code">{{ $currency->cur_code }}EGP</span> --}}
                                                <span class="code bl-text-xs fw-normal"><i class="far fa-clock"></i> {{\Carbon\Carbon::parse($rate['updated_at'])->diffForHumans()}}</span>
                                            </div>
                                            <span class="bankName">{{ $rate[__('main.db_bank_name')] }}</span>
                                        </a>
                                        @if ($rate->is_lost)
                                            <small class="is_lost_small"><i
                                                    class="fas fa-1x text-danger fa-heart-broken"></i>
                                                {{ __('main.is_lost') }}</small>
                                        @endif
                                    </td>
                                    <td class="text-center price <?= $rate['bankp_status_buy'] ?>">
                                        <span class="bankRate">{{ priceFormat($rate['bankp_buy_banknote'], 5) }}</span>
                                        <span class="small">{{ __('main.egCurr') }}</span>
                                        <div class="rate-change ltr fs-6 my-2">
                                            <i class="fas fa-arrow-{{ $rate['bankp_status_buy'] }}"></i>
                                            {{ priceFormat($rate['bankp_percent_buy'], 5) }}%
                                        </div>
                                    </td>
                                    <td class="text-center price <?= $rate['bankp_status_sell'] ?>">
                                        <span class="bankRate">{{ priceFormat($rate['bankp_sell_banknote'], 5) }}</span>
                                        <span class="small">{{ __('main.egCurr') }}</span>
                                        <div class="rate-change ltr fs-6 my-2">
                                            <i class="fas fa-arrow-{{ $rate['bankp_status_sell'] }}"></i>
                                            {{ priceFormat($rate['bankp_percent_sell'], 5) }}%
                                        </div>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
            <div class="col-12 mb-2 col-lg-4">
                @include('partials.__calculator_egy_all_banks')

                <div class="mt-5">
                    @include('components.egypt_central_bank')
                </div>

            </div>
        </div>
        <div class="row">
            <div class="col-12 my-5">
                <h2 class="mb-3 text-center">{{ __('main.faq') }}</h2>
                <p class="text-center bl-text-small mt-3">{{ __('main.faqInfo') }}</p>
                <div class="accordion" id="accordionExample">
                    <div class="card accordion-item mb-2">
                        <h2 class="card-header p-0 ">
                            <button class="accordion-button" type="button" data-bs-toggle="collapse"
                                data-bs-target="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
                                {{ __('main.faq_currency_banks1q') }}
                            </button>
                        </h2>
                        <div id="collapseOne" class="accordion-collapse collapse show" data-bs-parent="#accordionExample">
                            <div class="card-body">
                                {{ __('main.faq_currency_banks1a') }}
                            </div>
                        </div>
                    </div>
                    <div class="card accordion-item mb-2">
                        <h2 class="card-header p-0 ">
                            <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse"
                                data-bs-target="#collapseTwo" aria-expanded="false" aria-controls="collapseTwo">
                                {{ __('main.faq_currency_banks2q') }}
                            </button>
                        </h2>
                        <div id="collapseTwo" class="accordion-collapse collapse" data-bs-parent="#accordionExample">
                            <div class="card-body">
                                {!! __('main.faq_currency_banks2a') !!}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div><!-- container mt-4 -->
@endsection
@section('js')
    @php
        $faqSchema = [
            '@context' => 'https://schema.org',
            '@type' => 'FAQPage',
            'mainEntity' => [],
        ];
        $faq = [
            [
                "question" => strip_tags(__('main.faq_currency_banks1q')),
                "answer" => str_replace(["\n", "\r"], '', strip_tags(__('main.faq_currency_banks1a')))
            ],
            [
                "question" => strip_tags(__('main.faq_currency_banks2q')),
                "answer" => str_replace(["\n", "\r"], '', strip_tags(__('main.faq_currency_banks2a')))
            ]
        ];
        foreach ($faq as $item) {
            $faqSchema['mainEntity'][] = [
                '@type' => 'Question',
                'name' => $item['question'],
                'acceptedAnswer' => [
                    '@type' => 'Answer',
                    'text' => $item['answer'],
                ],
            ];
        }

        $jsonLdFaq = json_encode($faqSchema, JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE);

    @endphp

    <script type="application/ld+json">
    {!! $jsonLdFaq !!}
    </script>
@endsection
