<?php
\Artesaos\SEOTools\Facades\JsonLd::setType('BreadcrumbList');
\Artesaos\SEOTools\Facades\JsonLd::addValue('itemListElement', [
    [
        '@type' => 'ListItem',
        'position' => 1,
        'name' => siteName(),
        'item' => \LaravelLocalization::localizeUrl('/')
    ],
    [
        '@type' => 'ListItem',
        'position' => 2,
        'name' => $page->title,
    ]
]);
?>
@extends('app')
@section('title'){{$page->title}}@endsection
@section('article')
<meta property="article:published_time" content="{{ $page->created_at }}"/>
<meta property="article:modified_time" content="{{ $page->updated_at }}"/>
@endsection
@section('content')
<div class="container py-5">
    <h1 class="text-center mb-4 text-primary">{{$page->title}}</h1>
    <div class="content-section text-start border-4 border-start">
        {!! $page->content !!}
        <div class="fs-6 opacity-75">{{ __('main.last_page_updated') }} {{ $page->updated_at->format('d/m/Y') }}</div>
    </div>
</div>
@endsection
@section('css')
<style>
h1 {
    font-family: 'Roboto', sans-serif;
    font-weight: bold;
    color: #2c3e50;
}
.content-section {
    box-shadow: 0 8px 16px 0 rgb(10 14 29 / 2%), 0 8px 64px 0 rgb(119 119 119 / 8%);
    border-radius: 10px;
    background-color: #ffffff;
    padding: 2rem;
    border-color: #2c3e50 !important;
}
.content-section h2, .content-section h3, .content-section h4 {
    margin-top: 1.5rem;
    color: #2c3e50;
}
.content-section p {
    margin-bottom: 1rem;
    text-align: left;
}
.content-section ul, .content-section ol {
    margin-bottom: 1rem;
    padding-left: 1.5rem;
    padding-right: 1.5rem;
}
.content-section ul li, .content-section ol li {
    margin-bottom: 0.5rem;
}
@media (max-width: 768px) {
    .content-section {
        padding: 1rem;
    }
}
</style>
@endsection
