<div class="px-3 rounded py-2 " id="calculator">
    <div class="p-2 font-4 py-4 d-flex justify-content-between align-items-center rounded text-light">
        <div class="text-start">{{ __('main.banks_calculator') }}</div>
        <div class="font-1 text-end font-lg-5 spinner-grow text-light calculator-spinner silver"></div>
    </div>
    @php
        $banks = \App\Models\Banks::where('active', 1)
            ->where('is_lost', 0)
            ->where('active', 1)
            ->get();
    @endphp
    <div class="row">
        <div class="col-12 col-lg-6">
            <select class="form-control form-select p-2 btn-lg mb-4" id="bank_multi">
                <option selected disabled value="">{{ __('main.selct_bank') }}</option>
                @foreach ($banks as $bank)
                    <option value="{{ $bank->bank_id }}">{{ $bank->name }}</option>
                @endforeach
            </select>
        </div>
        <div class="col-12 col-lg-6">
            <select class="form-control form-select p-2 btn-lg mb-4" id="currency_calculator_multi">
                <option selected disabled value="">{{ __('main.select_currency') }}</option>
            </select>
        </div>
    </div>
    <input type="hidden" id="buy_rate_multi">
    <input type="hidden" id="sell_rate_multi">
    <div class="d-flex justify-content-between align-items-center mb-3 gap-3">
    <div class="d-flex flex-column rounded align-items-center bg-light">
        <div class="py-2">
            <span id="fromCurrencyCode_multi" class="fs-4 fw-bold currency-code"></span>
            <img class="rounded" width="40" src="{{ asset('/assets/img/flag_default.png') }}" alt="Currency Flag" id="fromCurrencyFlag_multi">
        </div>
        <input type="number" step="0.01" min="1" max="100000" id="from_multi" class="form-control ml-2 text-center" value="0.00">
    </div>
    {{-- <button class="btn btn-primary mx-3" id="btnExchange_multi">
        <i class="fas fa-exchange-alt"></i>
    </button> --}}
    <div class="d-flex flex-column rounded align-items-center bg-light">
        <div class="py-2">
            <span id="toCurrencyCode_multi" class="fs-4 fw-bold currency-code"></span>
            <img class="rounded" width="40" src="{{ asset('/assets/img/flag_default.png') }}" alt="flag" id="toCurrencyFlag_multi">
        </div>
        <input type="number" step="0.01" min="1" max="100000" id="to_multi" class="form-control ml-2 text-center" value="0.00">
    </div>
</div>
<div class="d-flex justify-content-between p-2 mt-4 mb-2 rounded" style="background: #0075ce52;">
    <span id="buyRate_multi" class="fs-6 fw-bold text-light">{{ __('main.price_buy') }} - 0000</span>
    <span id="sellRate_multi" class="fs-6 fw-bold text-light">{{ __('main.price_sell') }} - 0000</span>
</div>
</div>