<div class="px-3 rounded py-2 " id="calculator">
    <div class="p-2 font-4 py-4 d-flex justify-content-between align-items-center rounded text-light">
        <div class="text-start">{{ __('main.converter') }} / {{ $BPrices->name }}</div>
        <div class="font-1 text-end font-lg-5 spinner-grow text-light calculator-spinner silver"></div>
    </div>
    <select class="form-control form-select p-2 btn-lg mb-4" id="bank_calculator">
        @foreach ($BPrices->rates as $rate)
            @if ($rate['bankp_buy_banknote'] == 0)
                @continue
            @endif
            <option @if ($rate->currency->cur_code == 'USD') selected @endif
                data-currency-code="{{ $rate->currency->cur_code }}" data-currency-flag="{{ $rate->currency->smallflag }}"
                data-buy-price="{{ priceFormat($rate['bankp_buy_banknote'], 4) }}"
                data-sell-price="{{ priceFormat($rate['bankp_sell_banknote'], 4) }}">
                {{ $rate->currency->cur_code }} - {{ $rate->currency->name }}
            </option>
        @endforeach
    </select>
    <div class="d-flex justify-content-between align-items-center mb-3">
        <div class="d-flex flex-column rounded align-items-center bg-light">
            <div class="py-2">
                <span id="fromCurrencyCode" class="fs-4 fw-bold currency-code">USD</span>
                <img class="rounded" width="40" src="/flags/1x1/us.svg" alt="Currency Flag" id="fromCurrencyFlag">
            </div>
            <input type="number" step="0.01" min="1" max="100000" id="from"
                class="form-control ml-2 text-center" value="1">
        </div>
        <button class="btn btn-primary mx-3" id="btnExchange">
            <i class="fas fa-exchange-alt"></i>
        </button>
        <div class="d-flex flex-column rounded align-items-center bg-light">
            <div class="py-2">
                <span id="toCurrencyCode" class="fs-4 fw-bold currency-code">EGP</span>
                <img class="rounded" width="40" src="/flags/1x1/eg.svg" alt="EGP Flag" id="toCurrencyFlag">
            </div>
            <input type="number" step="0.01" min="1" max="100000" id="to"
                class="form-control ml-2 text-center" value="1">
        </div>
    </div>
    <div class="d-flex justify-content-between p-2 mt-4 mb-2 rounded" style="background: #0075ce52;">
        <span id="buyRate" class="fs-6 fw-bold text-light">{{ __('main.price_buy') }} - 0.00</span>
        <span id="sellRate" class="fs-6 fw-bold text-light">{{ __('main.price_sell') }} - 0.00</span>
    </div>
</div>