<div class="py-2 px-2 rounded" id="calculator">
    <div class="p-2 font-4 py-4 d-flex justify-content-between align-items-center rounded text-light">
        <div class="text-start">{{ __('main.calculator_banklive') }}</div>
        <div class="font-1 text-end font-lg-5 spinner-grow text-light calculator-spinner silver"></div>
    </div>
    @php
        $defaultCurrency = isset($baseCurrency) ? $baseCurrency : 'USD';
        $currenciesCalculator = Cache::remember('currenciesCalculators', 999999999, function () {
            return \App\Models\Currencies::whereHas('rates', function ($query) {
                return $query->whereNotNull('current_price');
            })
                ->where('is_active', 1)
                ->where('is_lost', 0)
                ->orderByRaw("CASE WHEN cur_code = 'EGP' THEN 1 ELSE 2 END")
                ->orderByDesc('cur_banks_support')
                ->get();
        });

        $topCurrencies = $currenciesCalculator->take(5); // أول 5 عملات
        $otherCurrencies = $currenciesCalculator->slice(5); // باقي العملات
    @endphp
    <div class="d-flex flex-column justify-content-between align-items-center mb-3 gap-3">
        <div class="container--calculator d-flex flex-row-reverse rounded align-items-center bg-light px-3 ">
            <div class="py-2">
                <select id="currency-selector-from" title="{{ __('main.select_currency') }}" data-width="200px"
                    class="selectpicker form-control" data-live-search="true">
                    @foreach ($topCurrencies as $currency)
                        <option @if ($currency->cur_code == $defaultCurrency) selected @endif value="{{ $currency->cur_code }}"
                            data-tokens="{{ $currency->cur_code }}"
                            data-content='<img loading="lazy" class="flag-icon rounded-circle" width="20" height="20" alt="{{ $currency->name }} flag" src="/flags/1x1/{{ $currency->cur_flag }}"> {{ $currency->name }}'>
                            {{ $currency->name }}</option>
                    @endforeach
                    <option data-divider="true"></option>
                    @foreach ($otherCurrencies as $currency)
                        <option @if ($currency->cur_code == $defaultCurrency) selected @endif
                            data-tokens="{{ $currency->cur_code }}" value="{{ $currency->cur_code }}"
                            data-content='<img loading="lazy" class="flag-icon rounded-circle" width="20" height="20" alt="{{ $currency->name }} flag" src="/flags/1x1/{{ $currency->cur_flag }}"> {{ $currency->name }}'>
                            {{ $currency->name }}</option>
                    @endforeach
                </select>
            </div>
            <input type="number" step="0.01" min="1" class="form-control ml-2 text-center" id="from_amount"
                value="" placeholder="0.00">
        </div>
        <div class="container--calculator d-flex flex-row-reverse rounded align-items-center bg-light px-3">
            <div class="py-2">
                <select id="to-currency-selector" data-width="200px" title="{{ __('main.select_currency') }}"
                    class="selectpicker form-control" data-live-search="true">
                    @foreach ($topCurrencies as $currency)
                        <option @if ($currency->cur_code == 'EGP') selected @endif
                            data-tokens="{{ $currency->cur_code }}" value="{{ $currency->cur_code }}"
                            data-content='<img loading="lazy" class="flag-icon rounded-circle" width="20" height="20" alt="{{ $currency->name }} flag" src="/flags/1x1/{{ $currency->cur_flag }}"> {{ $currency->name }}'>
                            {{ $currency->name }}</option>
                    @endforeach
                    <option data-divider="true"></option>
                    @foreach ($otherCurrencies as $currency)
                        <option data-tokens="{{ $currency->cur_code }}" value="{{ $currency->cur_code }}"
                            data-content='<img loading="lazy" class="flag-icon rounded-circle" width="20" height="20" alt="{{ $currency->name }} flag" src="/flags/1x1/{{ $currency->cur_flag }}"> {{ $currency->name }}'>
                            {{ $currency->name }}</option>
                    @endforeach
                </select>
            </div>
            <input type="number" step="0.01" min="1" class="form-control ml-2 text-center" id="to_amount"
                value="" placeholder="0.00">
        </div>
    </div>
    <div id="rate-container" class="ltr pb-2 fs-5 px-3 text-center d-flex gap-2 flex-column text-light">
        <span style="    background-color: #00467b;
    padding: 5px 10px 5px 10px;
    border-radius: 10px;"
            id="rate"></span>
        <span style="    background-color: #00467b;
    padding: 5px 10px 5px 10px;
    border-radius: 10px;"
            id="rate_reverse"></span>
    </div>
</div>
