<?php

$banksUpdatedAt = \App\Models\Banks::select('updated_at')->orderByDesc('updated_at')->first()->updated_at;
$bankskeywordsText = implode(', ', __('main.all_banks_keywords'));

?>
<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:news="http://www.google.com/schemas/sitemap-news/0.9">

    @foreach (\App\Models\Currencies::where('cur_banks_support', 1)
    ->where('is_active', 1)
    ->where('is_lost', 0)->get() as $currency)
    <url>
        <loc>{{ route('currency', ['c_from' => $currency->cur_code, 'c_to' => 'EGP'])  }}</loc>
        <news:news>
            <news:publication>
                <news:name>{{ sitename() }}</news:name>
                <news:language>{{ \LaravelLocalization::getCurrentLocale() }}</news:language>
            </news:publication>
            <news:publication_date><?= date('Y-m-d\TH:i:s\Z', strtotime($currency->updated_at)) ?></news:publication_date>
            <news:title>{{ __('main.curr_title', ['curr' => $currency->name, 'cur_from_code' => $currency->cur_code]) }}</news:title>
            <news:keywords>{{ implode(',',__('main.cur_keywords_page', ['currency_code' => $currency->cur_code, 'currency' => $currency->name])) }}</news:keywords>
        </news:news>
    </url> 
@endforeach

    @foreach (\App\Models\Banks::where('is_lost', 0)->where('active', 1)->orderByRaw('bank_sort = 0, bank_id asc')->get() as $bank)
        @php
            $BPrices = \App\Models\Query::getCurrRatesByBank($bank->bank_slug);
        @endphp
        @foreach ($BPrices->rates as $rate)
            @if ($rate['bankp_buy_banknote'] == 0)
                @continue
            @endif

            <url>
                <loc>{{ bankCurrencyUrl($BPrices->bank_slug, $rate->currency->cur_code) }}</loc>
                <news:news>
                    <news:publication>
                        <news:name>{{ sitename() }}</news:name>
                        <news:language>{{ \LaravelLocalization::getCurrentLocale() }}</news:language>
                    </news:publication>
                    <news:publication_date><?= date('Y-m-d\TH:i:s\Z', strtotime($bank->updated_at)) ?></news:publication_date>
                    <news:title>{{ __('main.bankCurrencyRate', ['currency' => $rate->currency->name, 'bank' => $bank->name]) }}</news:title>
                    <news:keywords>{{ implode(',', __('main.bank_currency_rate', ['currency' => $rate->currency->name, 'bank' => $bank->name])) }}</news:keywords>
                </news:news>
            </url> 
        @endforeach
    @endforeach
    @foreach (\App\Models\Currencies::where('cur_banks_support', 0)
    ->where('is_active', 1)
    ->where('is_lost', 0)->get() as $currency)
    <url>
        <loc>{{ route('currency', ['c_from' => $currency->cur_code, 'c_to' => 'EGP'])  }}</loc>
        <news:news>
            <news:publication>
                <news:name>{{ sitename() }}</news:name>
                <news:language>{{ \LaravelLocalization::getCurrentLocale() }}</news:language>
            </news:publication>
            <news:publication_date><?= date('Y-m-d\TH:i:s\Z', strtotime($currency->updated_at)) ?></news:publication_date>
            <news:title>{{ __('main.newCurrencyPageTitle', ['cur_from_name' => $currency->name, 'cur_from_code' => $currency->cur_code]) }}</news:title>
            <news:keywords>{{ implode(',',__('main.cur_keywords_page', ['currency_code' => $currency->cur_code, 'currency' => $currency->name])) }}</news:keywords>
        </news:news>
    </url> 
@endforeach
    @foreach (\App\Models\Banks::where('is_lost', 0)->where('active', 1)->orderByRaw('bank_sort = 0, bank_id asc')->get() as $bank)
        <url>
            <loc>{{ lurl(route('bank_price', ['slug' => $bank->bank_slug])) }}</loc>
            <news:news>
                <news:publication>
                    <news:name>{{ sitename() }}</news:name>
                    <news:language>{{ \LaravelLocalization::getCurrentLocale() }}</news:language>
                </news:publication>
                <news:publication_date><?= date('Y-m-d\TH:i:s\Z', strtotime($bank->updated_at)) ?></news:publication_date>
                <news:title>{{ __('main.bank_title', ['bank_name' => $bank->name]) }}</news:title>
                <news:keywords>{{ implode(',',__('main.bank_rates_keywords', ['bank' => $bank->name])) }}</news:keywords>
            </news:news>
        </url> 
    @endforeach
    
    @foreach (\App\Models\SilverPrices::with('kind')->get() as $silver)
        <url>
            <loc>{{ lurl(route('silver_karat', ['karat' => $silver->kind->slug])) }}</loc>
            <news:news>
                <news:publication>
                    <news:name>{{ sitename() }}</news:name>
                    <news:language>{{ \LaravelLocalization::getCurrentLocale() }}</news:language>
                </news:publication>
                <news:publication_date><?= date('Y-m-d\TH:i:s\Z', strtotime($silver->updated_at)) ?></news:publication_date>
                <news:title>{{ __('main.silver_karat_title', ['karat' => $silver->kind->name]) }}</news:title>
                <news:keywords>{{ implode(',',__('main.silver_karat_keywords', ['karat' => $silver->kind->name])) }}</news:keywords>
            </news:news>
        </url> 
    @endforeach

    @foreach (\App\Models\Golden::with('rate')->orderBy('sort', 'asc')->get() as $gold)
        <url>
            <loc>{{ lurl(route('gold_karat', ['karat' => $gold->slug])) }}</loc>
            <news:news>
                <news:publication>
                    <news:name>{{ sitename() }}</news:name>
                    <news:language>{{ \LaravelLocalization::getCurrentLocale() }}</news:language>
                </news:publication>
                <news:publication_date><?= date('Y-m-d\TH:i:s\Z', strtotime($gold->updated_at)) ?></news:publication_date>
                <news:title>{{ __('main.goldpricekarat', ['karat' => $gold->name]) }}</news:title>
                <news:keywords>{{ implode(',',__('main.gold_karat_keywords', ['karat' => $gold->name])) }}</news:keywords>
            </news:news>
        </url> 
    @endforeach
    
    @foreach (\App\Models\petroleumPrice::with('types')->get() as $gas)
        <url>
            <loc>{{ lurl(route('petrolUnit', ['slug' => $gas->types->slug])) }}</loc>
            <news:news>
                <news:publication>
                    <news:name>{{ sitename() }}</news:name>
                    <news:language>{{ \LaravelLocalization::getCurrentLocale() }}</news:language>
                </news:publication>
                <news:publication_date><?= date('Y-m-d\TH:i:s\Z', strtotime($gas->updated_at)) ?></news:publication_date>
                <news:title>{{ __('main.fuel_unit_title', ['name' => $gas->types->name]) }}</news:title>
                <news:keywords>{{ implode(',',__('main.new_gasoline_keywords', ['gasolineType' => $gas->types->name, 'year' => now()->year])) }}</news:keywords>
            </news:news>
        </url> 
    @endforeach
    <url>
        <loc>{{ lurl(route('banks')) }}</loc>
        <news:news>
            <news:publication>
                <news:name>{{ sitename() }}</news:name>
                <news:language>{{ \LaravelLocalization::getCurrentLocale() }}</news:language>
            </news:publication>
            <news:publication_date><?= date('Y-m-d\TH:i:s\Z', strtotime($banksUpdatedAt)) ?></news:publication_date>
            <news:title>{{ __('main.allBanksNew') }}</news:title>
            <news:keywords>{{ $bankskeywordsText }}</news:keywords>
        </news:news>
    </url>












</urlset>
