<?php 
    echo '<?xml version="1.0" encoding="UTF-8" ?>';
    $sitename  = config('mainSettings.site_name_' . __('main.lang'));
    $desc_meta = config('mainSettings.site_desc_' . __('main.lang'));
    $img_meta  = 'https://banklive.net/public/assets/img/bank_live_logo.png';
?>

<rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom">
     <channel>
          <atom:link href="{{ lurl('rss.xml') }}" rel="self" type="application/rss+xml"/>
          <title>{{$sitename .' - '. config('mainSettings.site_mini_desc_' . __('main.lang'))}}</title>
          <link>{{ lurl('/') }}</link>
          <description>{{$desc_meta}}</description>
     
          @foreach( $banks as $bank )
               <item>
                    <title>{{ __('main.bank_title', ['bank_name' => $bank[__('main.db_bank_name')]]) }} - {{ $sitename }}</title>
                    <link>{{ lurl(route('bank_price', ['slug' => $bank['bank_slug']])) }}</link>
                    <description><![CDATA[ <img alt="{{ __('main.bank_title', ['bank_name' => $bank[__('main.db_bank_name')]]) }}" title="{{ __('main.bank_title', ['bank_name' => $bank[__('main.db_bank_name')]]) }}" src="{{str_replace('35x35/', '',$bank->img_path)}}" />
                    {{__('main.bank_desc', [
                         'bank_name' => $bank->toArray()[__('main.db_bank_name')],
                         'date' => timeago($bank->bank_last_update),
                         ])}}]]></description>
                    <pubDate>{{gmdate(DATE_RSS, $bank->bank_last_update)}}</pubDate>
                    <guid>{{ lurl(route('bank_price', ['slug' => $bank['bank_slug']])) }}</guid>
               </item>
          @endforeach
     

          @foreach( $currencies as $currency )
          @if ($currency->cur_banks_support == 0)
          <item>
               <title>{{ __('main.newCurrencyPageTitle', ['cur_from_name' => $currency->name, 'cur_from_code' => $currency->cur_code]) }} - {{ $sitename }}</title>

               <link>{{ lurl(route('currency', ['c_from' => $currency['cur_code'], 'c_to' => 'EGP'])) }}</link>
               <description><![CDATA[
                    {{ __('main.newCurrencyPageDesc', ['cur_from_name' => $currency->name, 'cur_from_code' => $currency->cur_code]) }}
                    ]]></description>

               <pubDate>{{gmdate(DATE_RSS, $currency->cur_last_update)}}</pubDate>
               <guid>{{ lurl(route('currency', ['c_from' => $currency['cur_code'], 'c_to' => 'EGP'])) }}</guid>
          </item>
          @else 
               <item>
                    <title>{{__('main.curr_title', ['curr' => $currency->name])}} - {{ $sitename }}</title>
                    <link>{{ lurl(route('currency', ['c_from' => $currency['cur_code'], 'c_to' => 'EGP'])) }}</link>
                    
                    <description><![CDATA[ <img alt="{{__('main.curr_title', ['curr' => $currency->name])}}" title="{{__('main.curr_title', ['curr' => $currency->name])}}" src="{{$img_meta}}" /> {{__('main.cur_desc_page', [
                              'currency' => $currency->toArray()[__('main.db_curr_name')],
                              'date' => timeago($currency->cur_last_update)
                              ])}}]]></description>
                    <pubDate>{{gmdate(DATE_RSS, $currency->cur_last_update)}}</pubDate>
                    <guid>{{ lurl(route('currency', ['c_from' => $currency['cur_code'], 'c_to' => 'EGP'])) }}</guid>
               </item>
          @endif
          @endforeach
     
     
          <item>
               <title>{{__('main.gold_title')}} - {{ $sitename }}</title>
               <link>{{ lurl(route('goldprice')) }}</link>
               <description>{{__('main.gold_desc')}}</description>
               <pubDate>{{gmdate(DATE_RSS, (int)time())}}</pubDate>
               <guid>{{ lurl(route('goldprice')) }}</guid>
          </item>
          
          <item>
               <title>{{__('main.silver_title')}} - {{ $sitename }}</title>
               <link>{{ lurl(route('silverprice')) }}</link>
               <description>{{__('main.silver_desc')}}</description>
               <pubDate>{{gmdate(DATE_RSS, (int)time())}}</pubDate>
               <guid>{{ lurl(route('silverprice')) }}</guid>
          </item>
     </channel>
</rss>
    



     

 
