<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">
    <url>
        <loc>{{ lurl('/') }}</loc>
        <lastmod>{{ date('c', time()) }}</lastmod>
        <changefreq>hourly</changefreq>
        <priority>1</priority>
    </url>

    <url>
        <loc>{{ lurl(route('contact')) }}</loc>
        <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
        <changefreq>hourly</changefreq>
        <priority>0.8</priority>
    </url>
    @foreach (\App\Models\Pages::where('page_active', 1)->orderBy('page_sort', 'asc')->get() as $page)
        <url>
            <loc>{{ lurl(route('page', ['slug' => $page->page_slug])) }}</loc>
            <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
            <changefreq>hourly</changefreq>
            <priority>0.8</priority>
        </url>
    @endforeach
    <url>
        <loc>{{ lurl(route('banks')) }}</loc>
        <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
        <changefreq>hourly</changefreq>
        <priority>0.8</priority>
    </url>

    @foreach (\App\Models\Banks::where('is_lost', 0)->where('active', 1)->orderByRaw('bank_sort = 0, bank_id asc')->get() as $bank)
        <url>
            <loc>{{ lurl(route('bank_price', ['slug' => $bank->bank_slug])) }}</loc>
            <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
            {{-- <lastmod>{{date('c', $bank->bank_last_update)}}</lastmod> --}}
            <changefreq>hourly</changefreq>
            <priority>0.8</priority>
        </url>
    @endforeach
    @foreach (\App\Models\Banks::where('is_lost', 0)->where('active', 1)->orderByRaw('bank_sort = 0, bank_id asc')->get() as $bank)
        @php
            $BPrices = \App\Models\Query::getCurrRatesByBank($bank->bank_slug);
        @endphp
        @foreach ($BPrices->rates as $rate)
            @if ($rate['bankp_buy_banknote'] == 0)
                @continue
            @endif
            <url>
                <loc>{{ bankCurrencyUrl($BPrices->bank_slug, $rate->currency->cur_code) }}</loc>
                <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
                {{-- <lastmod>{{date('c', $bank->bank_last_update)}}</lastmod> --}}
                <changefreq>hourly</changefreq>
                <priority>0.8</priority>
            </url>
        @endforeach
    @endforeach

    <url>
        <loc>{{ lurl(route('currencies')) }}</loc>
        <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
        <changefreq>hourly</changefreq>
        <priority>0.8</priority>
    </url>
    @foreach (\App\Models\Currencies::selectRaw('cur_code,cur_flag,cur_name_ar,cur_name_en,cur_sort,cur_last_update')->orderByRaw('cur_sort = 0, cur_sort asc')->get() as $currency)
        <url>
            <loc>{{ lurl(route('currency', ['c_from' => $currency->cur_code, 'c_to' => 'EGP'])) }}</loc>
            <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
            {{-- <lastmod>{{ date('c', $currency->cur_last_update) }}</lastmod> --}}
            <changefreq>hourly</changefreq>
            <priority>0.8</priority>
        </url>
    @endforeach

    <url>
        <loc>{{ lurl(route('goldprice')) }}</loc>
        <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
        <changefreq>hourly</changefreq>
        <priority>0.8</priority>
    </url>
    @foreach (\App\Models\Golden::with('rate')->orderBy('sort', 'asc')->get() as $gold)
        <url>
            <loc>{{ lurl(route('gold_karat', ['karat' => $gold->slug])) }}</loc>
            <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
            {{-- <lastmod>{{ date('c', $currency->cur_last_update) }}</lastmod> --}}
            <changefreq>hourly</changefreq>
            <priority>0.8</priority>
        </url>
    @endforeach
    <url>
        <loc>{{ lurl(route('silverprice')) }}</loc>
        <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
        <changefreq>hourly</changefreq>
        <priority>0.8</priority>
    </url>
    @foreach (\App\Models\SilverPrices::with('kind')->get() as $silver)
        <url>
            <loc>{{ lurl(route('silver_karat', ['karat' => $silver->kind->slug])) }}</loc>
            <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
            {{-- <lastmod>{{ date('c', $currency->cur_last_update) }}</lastmod> --}}
            <changefreq>hourly</changefreq>
            <priority>0.8</priority>
        </url>
    @endforeach


    <url>
        <loc>{{ lurl(route('petrol')) }}</loc>
        <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
        <changefreq>hourly</changefreq>
        <priority>0.8</priority>
    </url>
    @foreach (\App\Models\petroleumPrice::with('types')->get() as $gas)
        <url>
            <loc>{{ lurl(route('petrolUnit', ['slug' => $gas->types->slug])) }}</loc>
            <lastmod>{{ now()->format('Y-m-d') }}</lastmod>
            <changefreq>hourly</changefreq>
            <priority>0.8</priority>
        </url>
    @endforeach
    
    {{--

<url>
<loc>{{ lurl(route('converter')) }}</loc>
<lastmod>{{date('c', time())}}</lastmod>
<priority>0.8</priority>
</url> --}}

</urlset>
