<?php
/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/


Route::namespace('Api')->group(function (){
	Route::get('allBanks', 'HomeController@getAllBanks');
	Route::get('allCurrencies', 'HomeController@getAllCurrencies');
	Route::get('bestPricesToday', 'HomeController@getBestPricesToday');
	Route::get('bestPricesToday/{cur}', 'HomeController@getBestPricesToday');
	Route::get('getBankRates/{bank_id}', 'HomeController@getBankRates');
	Route::get('curencyRates/{cur}', 'HomeController@getCurencyRates');
	Route::get('allGoldenPrice', 'HomeController@getGoldenPrice');
	Route::get('appUpdate', 'HomeController@checkAppUpdate');
});

Route::group(['middleware' => ['api'], 'prefix' => 'v2', 'namespace' => 'Api\v2'], function ()
{
	// register a new Token info
	Route::post('auth/register-id', 'AuthApplicationController@storeDeviceToken');
	// home
	Route::get('home', 'HomeController@index');
	Route::get('settings', 'HomeController@settings');

	

	// all banks
	Route::get('banks', 'BanksController@index');
	// bank route
	Route::get('banks/{bank_id}', 'BanksController@getBankRates');


	// all currencies
	Route::get('currencies', 'CurrenciesController@index');
	// one currency
	Route::get('currencies/{currency_id}', 'CurrenciesController@getCurrencyRates');


	// all news
	Route::get('news', 'NewsController@index');
	Route::get('news/show/{news_id}', 'NewsController@show');



	// gold price
	Route::get('gold-price', 'GoldController@index');


	// silver price
	Route::get('silver-price', 'SilverController@index');


	// petrol price
	Route::get('petrol-price', 'PetroleumController@index');

	// get general pricing
	Route::get('global-market', 'GlobalMarketController@index');



	// calculator
	Route::get('calculator', 'CalculatorController@index');


	// check app
});